include '%lib%/compiler/executable.inc'
include '%lib%/macros/allmacros.inc'
include '%lib%/equates/allequates.inc'

GlobalAPI equ ascii
_BinaryType console

include '%lib%/simpledebug/debug.asm'
include '%lib%/system/files.asm'
include '%lib%/system/process.asm'

_CodeSection

start:

        InitializeAll

        DebugMsg 'FreshLib Tutorials - Module: Files'

iglobal
        filename        db './tut01.txt',0
        sizeof.filename = $-filename
endg

uglobal
        hFile   dd ?
endg

        stdcall FileCreate, filename
        jc      .error
        mov     [hFile], eax
        DebugMsg "A new file was created:"
        stdcall OutputNumber, [hFile], 16, 2
        DebugMsg " is the handle of the file"

        stdcall FileWrite, [hFile], filename, sizeof.filename
        jc      .error
        stdcall OutputNumber, eax, 10, 2
        DebugMsg " bytes were written into the file"

        stdcall FileClose, [hFile]
        jc      .error
        DebugMsg "The file was properly closed"

        stdcall FileDelete, filename
        jc      .error
        DebugMsg "The file was finally deleted"
        jmp     .exit

.error:
        DebugMsg "Sorry, an error occurred"

.exit:
        FinalizeAll
        stdcall Terminate, 0

_ImportSection

include '%lib%/imports/allimports.asm'

_DataSection

IncludeAllGlobals
