include '%lib%/compiler/executable.inc'
_BinaryType GUI


include '%lib%/macros/allmacros.inc'
include '%lib%/equates/allequates.inc'
include '%lib%/GUI/SysEvents.asm'


_CodeSection

include '%lib%/simpledebug/debug.asm'
include '%lib%/system/process.asm'

include '%lib%/system/memory.asm'
include '%lib%/system/files.asm'
include '%lib%/data/arrays.asm'
include '%lib%/data/strlib.asm'

include '%lib%/timers/timers.asm'

include '%lib%/graphics/context.asm'
include '%lib%/graphics/text.asm'
include '%lib%/graphics/draw.asm'
include '%lib%/graphics/images.asm'
include '%lib%/graphics/giflib.asm'

include '%lib%/mouse/mouse.asm'
include '%lib%/GUI/GUI.asm'


iglobal
frmMainForm:
        ObjTemplate  tfParent or tfEnd, Form, frmMain, \
                     x, 100,        \
                     y, 50,         \
                     width, 320,    \
                     height, 200,   \
                     visible, TRUE, \
                     caption, 'Very simple window'

          ObjTemplate  tfChild or tfEnd, Button, btnChild1,          \
                     x, 48,         \
                     y, 48,         \
                     width, 80,     \
                     height, 48,    \
                     TextAlign, dtfAlignLeft or dtfAlignMiddle or dtfCRLF or dtfWordWrap,\
                     caption, 'Hello',        \
                     visible, TRUE, \
                     OnClick, Button1Click
endg

start:
        InitializeAll

        stdcall Create, CApplication
        jc      .start_error
        mov     [pApplication], ebx

uglobal
  test_timer1 dd ?
endg

DebugMsg 'After initializing.'

        stdcall CreateFromTemplate, frmMainForm, 0
        mov     ecx, [Application]
        mov     [ecx+TApplication.MainWindow], ebx

        DebugMsg 'After attaching window.'


        stdcall TimerCreate
        mov     [test_timer1], eax
        mov     [eax+TTimer.interval], 10
        mov     [eax+TTimer.Callback], procTestTimer1
        mov     [eax+TTimer.flags], tmfCallProc
        or      [eax+TTimer.flags], tmfRunning


        stdcall Run

        FinalizeAll
        stdcall Terminate, eax

.start_error:
        stdcall Terminate, 1

proc Button1Click, .self, .button
begin
        DebugMsg 'Button1 clicked'
        return
endp

iglobal
  test_counter dd 0
endg


proc procTestTimer1, .ptrTimer
begin
        add [test_counter],1
        cmp [test_counter],100
        jbe .not_yet
        stdcall OutputNumber,[test_counter],10,10
        stdcall Destroy,[frmMainForm]
  .not_yet:
        return
endp



_ImportSection

include '%lib%/imports/allimports.asm'

_DataSection
IncludeAllGlobals
