; This file is not needed anymore, but it contains very tiny implementation of Forth-like script engine.
; maybe it worths to keep it some time......

__ScriptEngine:

struct TCommandItem
  .name dd ?
  .proc dd ?
ends

macro CommandList lbl, [name, proc] {
common
  label lbl dword
forward
  local len
  dd name, proc
common
  dd 0
}


CommandList  ScriptCommands,                     \
  'l' ,   TFreshEdit.__CommandLeft,              \       ; left
  'r' ,   TFreshEdit.__CommandRight,             \       ; right
  'u' ,   TFreshEdit.__CommandUp,                \       ; up
  'd' ,   TFreshEdit.__CommandDown,              \       ; down
  'ul',   TFreshEdit.__CommandScrollLockUp,      \       ; up scroll lock
  'dl',   TFreshEdit.__CommandScrollLockDown,    \       ; down scroll lock
  'su',   TFreshEdit.__CommandScrollUp,          \       ; scroll up
  'sd',   TFreshEdit.__CommandScrollDown,        \       ; scroll down
  'pu',   TFreshEdit.__CommandPgUp,              \       ; page up
  'pd',   TFreshEdit.__CommandPgDown,            \       ; page down
  'lb',   TFreshEdit.__CommandHome,              \       ; line begin
  'le',   TFreshEdit.__CommandEnd,               \       ; line end
  'sb',   TFreshEdit.__CommandBeginOfScreen,     \       ; begin of screen
  'se',   TFreshEdit.__CommandEndOfScreen,       \       ;
  'fb',   TFreshEdit.__CommandFileBegin,         \       ; file begin
  'fe',   TFreshEdit.__CommandFileEnd,           \       ; file end
  'wp',   TFreshEdit.__CommandWordPrev,          \       ; word previous
  'wn',   TFreshEdit.__CommandWordNext,          \       ; word next
  'gsm',  TFreshEdit.__CommandGetSelectionMode,  \       ; get selection mode (0..2)
  'ssm',  TFreshEdit.__CommandSetSelectionMode,  \       ; set selection mode (0..2)
  'gim',  TFreshEdit.__CommandGetInsertMode,     \       ; get insert mode.
  'sim',  TFreshEdit.__CommandSetInsertMode,     \       ; set insert mode.
  'grc',  TFreshEdit.__CommandGetRowCount,       \       ; get row count.
\
\ ; Aritmerics
\
  '+',    __ScriptPlus,                          \
  '-',    __ScriptMinus,                         \
  '*',    __ScriptMul,                           \
  '/',    __ScriptDiv,                           \
  '%',    __ScriptMod,                           \
  'neg',  __ScriptNeg,                           \
\
\ ; Output
\
  '.',    __ScriptOutNumber,                     \
  '?',    __ScriptOutString,                     \
\
\ ; Stack operations and variables
\
  'swap', __ScriptSwap,                          \
  'pop',  __ScriptPop,                           \
  '->',   ExecScript.__assign,                   \
\
\ ; word logic
\
  'and',  __ScriptAnd,                           \
  'or',   __ScriptOr,                            \
  'xor',  __ScriptXor,                           \
  'not',  __ScriptNot,                           \
\
\ ; Loop
\
  'rep',  __ScriptRepeat,                        \
  'loop', __ScriptLoop,                          \
\
\ ; conditional
\
  'if',   ExecScript.__if,                       \
  'else', ExecScript.__else,                     \
  'then', ExecScript.__then




macro KeyScripts [scancode, modkeys, script] {
forward
local ptrscr
  dd scancode, modkeys
  if script eqtype 'A'
    dd ptrscr
  else
    dd script
  end if
common
  dd 0
forward
  if script eqtype 'A'
    ptrscr db script, 0
    align 4
  end if
}

struc script text {
  db text, 0
  align 4
}


KeyScripts                                     \
  keyUp,         0,        scrUp,      \
  keyUpNumpad,   0,        scrUp,      \
  keyDown,       0,        scrDown,    \
  keyDownNumpad, 0,        scrDown,    \
  keyLeft,       0,        scrLeft,    \
  keyLeftNumpad, 0,        scrLeft,    \
  keyRight,      0,        scrRight,   \
  keyRightNumpad,0,        scrRight,   \
  keyPgUp,       0,        scrPgUp,    \
  keyPgUpNumpad, 0,        scrPgUp,    \
  keyPgDown,     0,        scrPgDn,    \
  keyPgDnNumpad, 0,        scrPgDn,    \
  keyHome,       0,        scrHome,    \
  keyHomeNumpad, 0,        scrHome,    \
  keyEnd,        0,        scrEnd,     \
  keyEndNumpad,  0,        scrEnd,     \
  keyPgDown,     maskCtrl, scrEndOfFile,        \
  keyPgDnNumpad, maskCtrl, scrEndOfFile,        \
  keyPgUp,       maskCtrl, scrBegOfFile,        \
  keyPgUpNumpad, maskCtrl, scrBegOfFile,        \
  keyHome,       maskCtrl, scrBegOfScreen,      \
  keyHomeNumpad, maskCtrl, scrBegOfScreen,      \
  keyEnd,        maskCtrl, scrEndOfScreen,      \
  keyEndNumpad,  maskCtrl, scrEndOfScreen,      \
  keyInsert,     0,        scrToggleInsMode,    \
  keyInsNumpad,  0,        scrToggleInsMode,    \
  keyInsert,     maskAlt,  scrToggleSelectionMode


scrUp                   script 'u'
scrDown                 script 'd'
scrLeft                 script 'l'
scrRight                script 'r'
scrPgUp                 script 'pu'
scrPgDn                 script 'pd'
scrHome                 script 'lb'
scrEnd                  script 'le'
scrEndOfFile            script 'fe'
scrBegOfFile            script 'fb'
scrBegOfScreen          script 'sb'
scrEndOfScreen          script 'se'
scrToggleInsMode        script 'gim 1 xor sim'
scrToggleSelectionMode  script 'gsm 1 + 3 % ssm'




proc ExecScript, .editor, .pScript

.stack     rd 16

.pvar      dd ?
.fassign   dd ?

.changes dd ?

.errInvalidCommand = -1
.errInvalidNumber  = -2
.errStackOverflow  = -3
.errMissingQuote   = -4
.errInvalidVar     = -5
.errIfThenElse     = -6


begin
        push    ebx ecx edx esi edi

        stdcall GetMem, 65536
        mov     [.pvar], eax

        mov     ecx, 16
        lea     edi, [.stack]
        xor     eax, eax
        rep stosd

        mov     [.changes], eax
        mov     [.fassign], eax
        mov     edi, 15          ; intex to the stack bottom
        mov     esi, [.pScript]

.scriptloop:
        xor     ebx, ebx
        xor     ecx, ecx
        xor     eax, eax

.wordloop:
        movzx   eax, byte [esi]

        cmp     al, ' '
        jbe     .endofword

        cmp     al, '@'
        je      .variable

        cmp     al, "'"
        je      .string

        cmp     al, '"'
        je      .string

        cmp     al, '0'
        jb      .word
        cmp     al, '9'
        jbe     .digit

.word:
        inc     esi
        shl     eax, cl
        or      ebx, eax        ; command
        add     cl, 8
        cmp     cl, 32
        jbe     .wordloop
        jmp     .invalid_command


.variable:
        test    ecx, ecx
        jnz     .invalid_command

        mov     eax, $811C9DC5                  ; 2166136261              ; FNV offset basis

.hashloop:
        inc     esi

        movzx   edx, byte [esi]

        cmp     edx, ' '
        jbe     .endofvar

        xor     eax, edx
        imul    eax, $01000193                  ;   16777619              ; FNV prime
        jmp     .hashloop

.endofvar:
        mov     ebx, eax
        and     eax, $ffff
        shr     ebx, 16
        xor     ebx, eax
        and     ebx, $fffc
        add     ebx, [.pvar]

        cmp     [.fassign], 0
        je      .pushvar
; pop var
        mov     [.fassign], 0
        cmp     edi, 15
        jae     .stack_overflow

        inc     edi
        mov     eax, [.stack+4*edi]
        mov     [ebx], eax
        jmp     .nextchar

.pushvar:
        test    edi, edi
        js      .stack_overflow

        mov     eax, [ebx]
        mov     [.stack+4*edi], eax
        dec     edi
        jmp     .nextchar

.string:
        test    ecx, ecx
        jnz     .invalid_command

        inc     esi
        mov     ebx, esi

        xor     ecx, ecx

.lenloop:
        cmp     byte [esi], 0
        je      .missing_quote

        cmp     byte [esi], al
        je      .endofstring

        inc     esi
        inc     ecx
        jmp     .lenloop

.endofstring:
        test    edi, edi
        js      .stack_overflow

        stdcall StrNew
        mov     [.stack+4*edi], eax
        stdcall StrCopyPart, eax, ebx, 0, ecx
        stdcall StrPtr, eax

        dec     edi
        inc     esi
        jmp     .scriptloop

.digit:
        test    ecx, ecx
        jnz     .invalid_command

.numberloop:
        mov     al, [esi]
        cmp     al, ' '
        jbe     .endofnumber
        inc     esi

        cmp     al, '0'
        jb      .invalid_number
        cmp     al, '9'
        ja      .invalid_number

        and     eax, $0f
        imul    ebx, 10
        add     ebx, eax
        jmp     .numberloop

.endofnumber:
        test    edi, edi
        js      .stack_overflow

        mov     [.stack+4*edi], ebx
        dec     edi

        test    eax, eax
        jz      .endofscript

        inc     esi
        jmp     .scriptloop


.endofword:
        jecxz   .nextchar
        mov     eax, ScriptCommands - sizeof.TCommandItem

.search_command:
        add     eax, sizeof.TCommandItem

        cmp     dword [eax], 0
        je      .invalid_command

        cmp     [eax], ebx
        jne     .search_command

;.found:
        push    esi
        lea     ebx, [.stack]
        mov     esi, [.editor]
        call    [eax+TCommandItem.proc]
        pop     esi

        jc      .stack_overflow
        or      [.changes], eax

        cmp     edi, 15
        ja      .stack_overflow

.nextchar:
        inc     esi
        cmp     byte [esi-1], 0
        jne     .scriptloop

.endofscript:
        clc
        mov     eax, [.changes]

.finish:
        stdcall FreeMem, [.pvar]
        pop     edi esi edx ecx ebx
        return

; Context dependent control commands

; "->" (assign) command
.__assign:
        mov     [.fassign], 1
        xor     eax, eax
        clc
        retn

.__if:
        cmp     edi, 15
        jae     .ifok

        inc     edi
        cmp     [.stack+4*edi], 0
        jne     .ifok

; search for else of then
        mov     eax, [esp+4]    ; stored pointer to the script text
        xor     ecx, ecx

.ifloop:
        inc     eax
        mov     edx, [eax]
        cmp     edx, 'else'
        je      .else
        cmp     edx, 'then'
        je      .then
        test    edx, $ff000000
        jz      .iferror

        and     edx, $ffff
        cmp     edx, 'if'
        jne     .ifloop

        inc     ecx
        jmp     .ifloop

.else:
        jecxz   .elsehere
        dec     ecx
        jmp     .ifloop

.elsehere:
        add     eax, 4
        cmp     byte [eax], ' '
        ja      .iferror

        mov     [esp+4], eax
        jmp     .ifok

.then:
        jecxz   .thenhere
        dec     ecx
        jmp     .ifloop

.thenhere:
        add     eax, 4
        cmp     byte [eax], ' '
        ja      .iferror
        mov     [esp+4], eax

.ifok:
        xor     eax, eax
        clc
        retn

.iferror:
        stc
        mov     eax, .errIfThenElse
        retn


.__else:
; search for "then"
        mov     eax, [esp+4]    ; stored pointer to the script text
        xor     ecx, ecx

.elseloop:
        inc     eax
        mov     edx, [eax]
        cmp     edx, 'else'
        je      .else2
        cmp     edx, 'then'
        je      .then2
        test    edx, $ff000000
        jz      .iferror

        and     edx, $ffff
        cmp     edx, 'if'
        jne     .elseloop

        inc     ecx
        jmp     .elseloop

.else2:
        jecxz   .iferror
        dec     ecx
        jmp     .elseloop

.then2:
        jecxz   .thenhere2
        dec     ecx
        jmp     .elseloop

.thenhere2:
        add     eax, 4
        cmp     byte [eax], ' '
        ja      .iferror
        mov     [esp+4], eax
        jmp     .ifok

.__then:
        xor     eax, eax
        clc
        retn


; errors

.invalid_command:
        stc
        mov     eax, .errInvalidCommand
        jmp     .finish

.invalid_number:
        stc
        mov     eax, .errInvalidNumber
        jmp     .finish

.stack_overflow:
        stc
        mov     eax, .errStackOverflow
        jmp     .finish

.missing_quote:
        stc
        mov     eax, .errMissingQuote
        jmp     .finish

endp


call    ExecScript



proc __ScriptPlus
begin
        cmp     edi, 14
        jae     .end

        mov     eax, [ebx+4*edi+4]
        inc     edi
        add     [ebx+4*edi+4], eax

.end:
        xor     eax, eax
        return
endp



proc __ScriptMinus
begin
        cmp     edi, 14
        jae     .end

        mov     eax, [ebx+4*edi+4]
        inc     edi
        sub     [ebx+4*edi+4], eax

.end:
        xor     eax, eax
        clc
        return
endp



proc __ScriptMul
begin
        cmp     edi, 14
        jae     .end

        mov     eax, [ebx+4*edi+4]
        inc     edi
        imul    eax, [ebx+4*edi+4]
        mov     [ebx+4*edi+4], eax
.end:
        xor     eax, eax
        clc
        return
endp



proc __ScriptDiv
begin
        cmp     edi, 14
        jae     .end

        cmp     dword [ebx+4*edi+4], 0
        je      .err

        inc     edi
        mov     eax, [ebx+4*edi+4]
        cdq
        div     dword [ebx+4*edi]
        mov     [ebx+4*edi+4], eax

.end:
        xor     eax, eax
        clc
        return

.err:
        stc
        return
endp




proc __ScriptMod
begin
        cmp     edi, 14
        jae     .end

        cmp     dword [ebx+4*edi+4], 0
        je      .err

        inc     edi
        mov     eax, [ebx+4*edi+4]
        cdq
        div     dword [ebx+4*edi]
        mov     [ebx+4*edi+4], edx

.end:
        xor     eax, eax
        clc
        return

.err:
        stc
        return
endp



proc __ScriptOutNumber
begin
        cmp     edi, 15
        jae     .end

        inc     edi
        mov     eax, [ebx+4*edi]

        stdcall NumToStr, eax, ntsSigned or ntsDec
        push    eax

        stdcall StrPtr, eax
        stdcall Output, eax
        stdcall StrDel ; from the stack.

.end:
        xor     eax, eax
        clc
        return
endp


proc __ScriptOutString
begin
        cmp     edi, 15
        jae     .end

        inc     edi
        cmp     dword [ebx+4*edi], 0
        je      .crlf

        stdcall StrPtr, [ebx+4*edi]
        stdcall Output, eax
        stdcall StrDel, [ebx+4*edi]

.end:
        xor     eax, eax
        clc
        return

.crlf:
        stdcall Output, .scrlf
        jmp     .end

.scrlf db 13, 10, 0

endp



proc __ScriptSwap
begin
        cmp     edi, 14
        jae     .end

        pushd   [ebx+4*edi+4]
        pushd   [ebx+4*edi+8]
        popd    [ebx+4*edi+4]
        popd    [ebx+4*edi+8]

.end:
        xor     eax, eax
        clc
        return
endp


proc __ScriptPop
begin
        cmp     edi, 15
        jae     .end

        inc     edi
.end:
        xor     eax, eax
        clc
        return
endp



proc __ScriptAnd
begin
        cmp     edi, 14
        jae     .end

        mov     eax, [ebx+4*edi+4]
        inc     edi
        and     [ebx+4*edi+4], eax

.end:
        xor     eax, eax
        clc
        return
endp


proc __ScriptOr
begin
        cmp     edi, 14
        jae     .end

        mov     eax, [ebx+4*edi+4]
        inc     edi
        or      [ebx+4*edi+4], eax

.end:
        xor     eax, eax
        clc
        return
endp


proc __ScriptXor
begin
        cmp     edi, 14
        jae     .end

        mov     eax, [ebx+4*edi+4]
        inc     edi
        xor     [ebx+4*edi+4], eax

.end:
        xor     eax, eax
        clc
        return
endp




proc __ScriptNot
begin
        cmp     edi, 15
        jae     .end

        not     dword [ebx+4*edi+4]

.end:
        xor     eax, eax
        clc
        return
endp



proc __ScriptNeg
begin
        cmp     edi, 15
        jae     .end

        neg     dword [ebx+4*edi+4]

.end:
        xor     eax, eax
        clc
        return
endp



proc __ScriptRepeat
begin
        cmp     edi, 14
        jae     .end


.end:
        xor     eax, eax
        clc
        return
endp


proc __ScriptLoop
begin
        cmp     edi, 14
        jae     .end

.end:
        xor     eax, eax
        clc
        return
endp







DispSize 'Script engine', $ - __ScriptEngine

