cInitStringPoolSize = 1024


struct TStringPool
  .ptrPool  dd ?
  .iEnd     dd ?
ends



proc StringHeapCreate, .ptrStringPool
begin
        push    esi
        mov     esi, [.ptrStringPool]
        stdcall GetMem, cInitStringPoolSize
        mov     [esi+TStringPool.ptrPool], eax

        pop     esi
        return
endp



proc StringHeapAdd, .ptrStringPool, .ptrString
.size dd ?
begin
        push    ebx ecx edx esi edi

        mov     esi, [.ptrString]
        mov     edi, [.ptrStringPool]

        stdcall GetMemSize, [edi+TStringPool.ptrPool]
        mov     [.size], eax

        mov     ebx, [edi+TStringPool.iEnd]
        add     ebx, [esi-4]    ; length of the string.
        add     ebx, 8          ; dword len + dword zero terminator.
        cmp     ebx, [.size]    ;
        jb      .sizeok

        mov     ecx, [.size]
        sar     ecx, 2  ; 1/4 of the size.
        cmp     ecx, cInitStringPoolSize
        ja      .reserveok
        mov     ecx, cInitStringPoolSize
.reserveok:

        add     ebx, ecx
        stdcall ResizeMem, [edi+TStringPool.ptrPool], ebx
        mov     [edi+TStringPool.ptrPool], eax

.sizeok:
; size is OK, so go copy:

        mov     ebx, [edi+TStringPool.ptrPool]
        mov     ecx, [esi-4]                    ; len of the string

        mov     eax, [edi+TStringPool.iEnd]
        lea     eax, [eax+4]
        push    eax                             ; result offset.

        lea     ebx, [ebx+eax]
        mov     [ebx-4], ecx                    ; length of the string

; ebx -> pointer to the destination
; esi -> pointer to the source
; ecx -> lenght in bytes.

        mov     edx, ecx
        shr     edx, 2          ; quotient
        and     ecx, 3          ; remainder

        mov     dword [ebx+4*edx], 0        ; zero termination
        mov     dword [ebx+4*edx+4], 0        ; zero termination
        lea     eax, [ebx+4*edx+8]
        sub     eax, [edi+TStringPool.ptrPool]
        mov     [edi+TStringPool.iEnd], eax

        push    ebx esi
        lea     ebx, [ebx+4*edx]
        lea     esi, [esi+4*edx]

.looprem:
        dec     ecx
        js      .endrem
        mov     al, [esi+ecx]
        mov     [ebx+ecx], al
        jmp     .looprem

.endrem:
        pop     esi ebx

.loopdword:
        dec     edx
        js      .endcopy
        mov     eax, [esi+4*edx]
        mov     [ebx+4*edx], eax
        jmp     .loopdword

.endcopy:
        pop     eax
        pop     edi esi edx ecx ebx
        return
endp