;*************************************************************
;* macroses.inc
;*
;* This file contains some common data structures and
;* constants. It not contains any data or
;* code.
;*
;* You must include somewhere in the begining of the program.
;*
;* You can use this work for any purpos, only don't forget to
;* write somewhere in docs: "Based on work of John Found" or
;* something similar. :)
;*
;* '2003 John Found
;*************************************************************

macro icon group, [label, icon_file, index] {
  common
    local count

    count = 0
  forward
    local data,size,position

    load size dword from icon_file:$0e + $10 * index  ; size of icon
    load position dword from icon_file:$12 + $10 * index  ; position

    label dd RVA data,size, 0, 0

    data file icon_file:position,size

    count = count + 1

  common
    local header

    align 4
    group dd RVA header,6+count*14,0,0
    header dw 0,1,count

  forward

    file icon_file: 6+index*16, 12
    dw label#.resid

  common
    align 4

}



macro cursor [group,_label,cursor_file] {
  forward
    local _header, _data,_size,_position,_hotX, _hotY, _xsize, _ysize

    load _xsize     byte  from cursor_file:$06
    load _ysize     byte  from cursor_file:$07
    load _hotX	    word  from cursor_file:$0a
    load _hotY	    word  from cursor_file:$0c
    load _size	    dword from cursor_file:$0e
    load _position  dword from cursor_file:$12

    align 4

    group   dd	  RVA _header, $14, 0, 0

    _header dw	  0, 2, 1
	    dw	  _xsize, _ysize
	    dw	  $1			 ; Planes ???
	    dw	  $00			  ; Bit count ???
	    dd	  _size+4		     ; Resource len

    filter_id = RVA _label

	    dw	  _label#.resid

    _label dd RVA _data, _size+4, 0, 0

    _data dw _hotX, _hotY
	    file    cursor_file:_position,_size
}








struc TInitCommonControlsEx Flg {
  .dwSize: dd .size	    ; size of this structure
  .dwICC:  dd Flg	    ; flags indicating which classes to be initialized
  .size = $ - .dwSize
}


struc TMenuItemInfo {
  .cbSize	 dd  .size
  .fMask	 dd  ?
  .fType	 dd  ?
  .fState	 dd  ?
  .wID		 dd  ?
  .hSubMenu	 dd  ?
  .hBmpChecked	 dd  ?
  .hBmpUnchecked dd  ?
  .dwItemData	 dd  ?
  .dwTypeData	 dd  ?
  .cch		 dd  ?
  .size 	 =   $ - .cbSize
}


virtual at 0
  TMenuItemInfo TMenuItemInfo
end virtual



struc  TMeasureItemStruct {
  .CtlType    dd ?
  .CtlID      dd ?
  .itemID     dd ?
  .itemWidth  dd ?
  .itemHeight dd ?
  .itemData   dd ?

  .size = $ - .CtlType
}

virtual at 0
  TMeasureItemStruct TMeasureItemStruct
end virtual


struc	TDrawItemStruct {
  .CtlType     dd ?
  .CtlID       dd ?
  .itemID      dd ?
  .itemAction  dd ?
  .itemState   dd ?
  .hwndItem    dd ?
  .hDC	       dd ?
  .rectItem    RECT
  .itemData    dd ?

  .size = $ - .CtlType
}

virtual at 0
  TDrawItemStruct TDrawItemStruct
end virtual




struc TLogBrush Color {
  .lbStyle    dd    BS_SOLID
  .lbColor    dd    Color
  .lbHatch    dd    ?
}


struc TWindowClass AStyle, AWinProc, ABackground, AClassName
 {
   .style	  dd AStyle
   .lpfnWndProc   dd AWinProc
   .cbClsExtra	  dd 0
   .cbWndExtra	  dd 0
   .hInstance	  dd ?
   .hIcon	  dd ?
   .hCursor	  dd ?
   .hbrBackground dd ABackground
   .lpszMenuName  dd 0

   if AClassName eqtype ''
     .lpszClassName dd .ClassName
     .ClassName   db AClassName,0
   else
     .lpszClassName dd AClassName
     .ClassName = AClassName
   end if
 }


struc TLogBrush Color {
  .lbStyle    dd    BS_SOLID
  .lbColor    dd    Color
  .lbHatch    dd    ?
}

