; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "Fresh artistic license."         |
;|_______________________________________________________________________________________|
;
;  Description: advapi32.dll API functions.
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________

import_proto advapi32,  \
    A_SHAFinal, N, <NONE>,  'A_SHAFinal',  \
    A_SHAInit, N, <NONE>,  'A_SHAInit',  \
    A_SHAUpdate, N, <NONE>,  'A_SHAUpdate',  \
    AbortSystemShutdown, A, <.lpMachineName>,  'AbortSystemShutdownA',  \
    AbortSystemShutdown, W, <.lpMachineName>,  'AbortSystemShutdownW',  \
    AccessCheck, N, <.pSecurityDescriptor, .ClientToken, .DesiredAccess, .GenericMapping, .PrivilegeSet, .PrivilegeSetLength, .GrantedAccess,  \
        .Status>,  'AccessCheck',  \
    AccessCheckAndAuditAlarm, A, <.SubsystemName, .HandleId, .ObjectTypeName, .ObjectName, .SecurityDescriptor, .DesiredAccess, .GenericMapping,  \
        .ObjectCreation, .GrantedAccess, .AccessStatus, .pfGenerateOnClose>,  'AccessCheckAndAuditAlarmA',  \
    AccessCheckAndAuditAlarm, W, <.SubsystemName, .HandleId, .ObjectTypeName, .ObjectName, .SecurityDescriptor, .DesiredAccess, .GenericMapping,  \
        .ObjectCreation, .GrantedAccess, .AccessStatus, .pfGenerateOnClose>,  'AccessCheckAndAuditAlarmW',  \
    AccessCheckByType, N, <.pSecurityDescriptor, .PrincipalSelfSid, .ClientToken, .DesiredAccess, .ObjectTypeList, .ObjectTypeListLength,  \
        .GenericMapping, .PrivilegeSet, .PrivilegeSetLength, .GrantedAccess, .AccessStatus>,  'AccessCheckByType',  \
    AccessCheckByTypeAndAuditAlarm, A, <.SubsystemName, .HandleId, .ObjectTypeName, .ObjectName, .SecurityDescriptor, .PrincipalSelfSid,  \
        .DesiredAccess, .AuditType, .Flags, .ObjectTypeList, .ObjectTypeListLength, .GenericMapping, .ObjectCreation, .GrantedAccess,  \
        .AccessStatus, .pfGenerateOnClose>,  'AccessCheckByTypeAndAuditAlarmA',  \
    AccessCheckByTypeAndAuditAlarm, W, <.SubsystemName, .HandleId, .ObjectTypeName, .ObjectName, .SecurityDescriptor, .PrincipalSelfSid,  \
        .DesiredAccess, .AuditType, .Flags, .ObjectTypeList, .ObjectTypeListLength, .GenericMapping, .ObjectCreation, .GrantedAccess,  \
        .AccessStatus, .pfGenerateOnClose>,  'AccessCheckByTypeAndAuditAlarmW',  \
    AccessCheckByTypeResultList, N, <.pSecurityDescriptor, .PrincipalSelfSid, .ClientToken, .DesiredAccess, .ObjectTypeList, .ObjectTypeListLength,  \
        .GenericMapping, .PrivilegeSet, .PrivilegeSetLength, .GrantedAccessList, .AccessStatusList>,  'AccessCheckByTypeResultList',  \
    AccessCheckByTypeResultListAndAuditAlarm, A, <.SubsystemName, .HandleId, .ObjectTypeName, .ObjectName, .SecurityDescriptor, .PrincipalSelfSid,  \
        .DesiredAccess, .AuditType, .Flags, .ObjectTypeList, .ObjectTypeListLength, .GenericMapping, .ObjectCreation, .GrantedAccess,  \
        .AccessStatusList, .pfG>,  'AccessCheckByTypeResultListAndAuditAlarmA',  \
    AccessCheckByTypeResultListAndAuditAlarmByHandle, A, <.SubsystemName, .HandleId, .ClientToken, .ObjectTypeName, .ObjectName, .SecurityDescriptor,  \
        .PrincipalSelfSid, .DesiredAccess, .AuditType, .flags, .ObjectTypeList, .ObjectTypeListLength, .GenericMapping, .ObjectCreation,  \
        .GrantedAccess, .AccessibleChildren, .paccContainer, .iChildStart, .cChildren, .rgvarChildren, .pcObtained>,  'AccessCheckByTypeResultListAndAuditAlarmByHandleA',  \
    AccessCheckByTypeResultListAndAuditAlarmByHandle, W, <.SubsystemName, .HandleId, .ClientToken, .ObjectTypeName, .ObjectName, .SecurityDescriptor,  \
        .PrincipalSelfSid, .DesiredAccess, .AuditType, .flags, .ObjectTypeList, .ObjectTypeListLength, .GenericMapping, .ObjectCreation,  \
        .GrantedAccess, .AccessibleChildren, .paccContainer, .iChildStart, .cChildren, .rgvarChildren, .pcObtained>,  'AccessCheckByTypeResultListAndAuditAlarmByHandleW',  \
    AccessCheckByTypeResultListAndAuditAlarm, W, <.SubsystemName, .HandleId, .ObjectTypeName, .ObjectName, .SecurityDescriptor, .PrincipalSelfSid,  \
        .DesiredAccess, .AuditType, .Flags, .ObjectTypeList, .ObjectTypeListLength, .GenericMapping, .ObjectCreation, .GrantedAccess,  \
        .AccessStatusList, .pfG>,  'AccessCheckByTypeResultListAndAuditAlarmW',  \
    AddAccessAllowedAce, N, <.pAcl, .dwAceRevision, .AccessMask, .pSid>,  'AddAccessAllowedAce',  \
    AddAccessAllowedAceEx, N, <.pAcl, .dwAceRevision, .AceFlags, .AccessMask, .pSid>,  'AddAccessAllowedAceEx',  \
    AddAccessAllowedObjectAce, N, <.pAcl, .dwAceRevision, .AceFlags, .AccessMask, .ObjectTypeGuid, .ByRefheritedObjectTypeGuid, .pSid,  \
      >,  'AddAccessAllowedObjectAce',  \
    AddAccessDeniedAce, N, <.pAcl, .dwAceRevision, .AccessMask, .pSid>,  'AddAccessDeniedAce',  \
    AddAccessDeniedAceEx, N, <.pAcl, .dwAceRevision, .AceFlags, .AccessMask, .pSid>,  'AddAccessDeniedAceEx',  \
    AddAccessDeniedObjectAce, N, <.pAcl, .dwAceRevision, .AceFlags, .AccessMask, .ObjectTypeGuid, .ByRefheritedObjectTypeGuid, .pSid,  \
      >,  'AddAccessDeniedObjectAce',  \
    AddAce, N, <.pAcl, .dwAceRevision, .dwStartingAceIndex, .pAceList, .nAceListLength>,  'AddAce',  \
    AddAuditAccessAce, N, <.pAcl, .dwAceRevision, .dwAccessMask, .pSid, .bAuditSuccess, .bAuditFailure>,  'AddAuditAccessAce',  \
    AddAuditAccessAceEx, N, <.pAcl, .dwAceRevision, .AceFlags, .dwAccessMask, .pSid, .bAuditSuccess, .bAuditFailure>,  'AddAuditAccessAceEx',  \
    AddAuditAccessObjectAce, N, <.pAcl, .dwAceRevision, .AceFlags, .AccessMask, .ObjectTypeGuid, .ByRefheritedObjectTypeGuid, .pSid, .bAuditSuccess,  \
        .bAuditFailure>,  'AddAuditAccessObjectAce',  \
    AddUsersToEncryptedFile, N, <.lpFileName, .pUsers>,  'AddUsersToEncryptedFile',  \
    AdjustTokenGroups, N, <.TokenHandle, .ResetToDefault, .NewState, .BufferLength, .PreviousState, .ReturnLength>,  'AdjustTokenGroups',  \
    AdjustTokenPrivileges, N, <.TokenHandle, .DisableAllPrivileges, .NewState, .BufferLength, .PreviousState, .ReturnLength>,  'AdjustTokenPrivileges',  \
    AllocateAndInitializeSid, N, <.pIdentifierAuthority, .nSubAuthorityCount, .nSubAuthority0, .nSubAuthority1, .nSubAuthority2, .nSubAuthority3,  \
        .nSubAuthority4, .nSubAuthority5, .nSubAuthority6, .nSubAuthority7, .lpPSid>,  'AllocateAndInitializeSid',  \
    AllocateLocallyUniqueId, N, <.Luid>,  'AllocateLocallyUniqueId',  \
    AreAllAccessesGranted, N, <.GrantedAccess, .DesiredAccess>,  'AreAllAccessesGranted',  \
    AreAnyAccessesGranted, N, <.GrantedAccess, .DesiredAccess>,  'AreAnyAccessesGranted',  \
    BackupEventLog, A, <.hEventLog, .lpBackupFileName>,  'BackupEventLogA',  \
    BackupEventLog, W, <.hEventLog, .lpBackupFileName>,  'BackupEventLogW',  \
    BuildExplicitAccessWithName, A, <.pExplicitAccess, .pTrusteeName, .AccessPermissions, .AccessMode, .Inheritance>,  'BuildExplicitAccessWithNameA',  \
    BuildExplicitAccessWithName, W, <.pExplicitAccess, .pTrusteeName, .AccessPermissions, .AccessMode, .Inheritance>,  'BuildExplicitAccessWithNameW',  \
    BuildImpersonateExplicitAccessWithName, A, <.pExplicitAccess, .pTrusteeName, .pTrustee, .AccessPermissions, .AccessMode, .Inheritance,  \
      >,  'BuildImpersonateExplicitAccessWithNameA',  \
    BuildImpersonateExplicitAccessWithName, W, <.pExplicitAccess, .pTrusteeName, .pTrustee, .AccessPermissions, .AccessMode, .Inheritance,  \
      >,  'BuildImpersonateExplicitAccessWithNameW',  \
    BuildImpersonateTrustee, A, <.pTrustee, .pImpersonateTrustee>,  'BuildImpersonateTrusteeA',  \
    BuildImpersonateTrustee, W, <.pTrustee, .pImpersonateTrustee>,  'BuildImpersonateTrusteeW',  \
    BuildSecurityDescriptor, A, <.pOwner, .pGroup, .cCountOfAccessEntries, .pListOfAccessEntries, .cCountOfAuditEntries, .pListOfAuditEntries,  \
        .pOldSD, .pSizeNewSD, .pNewSD>,  'BuildSecurityDescriptorA',  \
    BuildSecurityDescriptor, W, <.pOwner, .pGroup, .cCountOfAccessEntries, .pListOfAccessEntries, .cCountOfAuditEntries, .pListOfAuditEntries,  \
        .pOldSD, .pSizeNewSD, .pNewSD>,  'BuildSecurityDescriptorW',  \
    BuildTrusteeWithName, A, <.pTrustee, .pname>,  'BuildTrusteeWithNameA',  \
    BuildTrusteeWithName, W, <.pTrustee, .pname>,  'BuildTrusteeWithNameW',  \
    BuildTrusteeWithObjectsAndName, A, <.pTrustee, .pObjName, .ObjectType, .ObjectTypeName, .InheritedObjectTypeName, .name>,  'BuildTrusteeWithObjectsAndNameA',  \
    BuildTrusteeWithObjectsAndName, W, <.pTrustee, .pObjName, .ObjectType, .ObjectTypeName, .InheritedObjectTypeName, .name>,  'BuildTrusteeWithObjectsAndNameW',  \
    BuildTrusteeWithObjectsAndSid, A, <.pTrustee, .pObjSid, .pObjectGuid, .pInheritedObjectGuid, .pSid>,  'BuildTrusteeWithObjectsAndSidA',  \
    BuildTrusteeWithObjectsAndSid, W, <.pTrustee, .pObjSid, .pObjectGuid, .pInheritedObjectGuid, .pSid>,  'BuildTrusteeWithObjectsAndSidW',  \
    BuildTrusteeWithSid, A, <.pTrustee, .pSid>,  'BuildTrusteeWithSidA',  \
    BuildTrusteeWithSid, W, <.pTrustee, .pSid>,  'BuildTrusteeWithSidW',  \
    CancelOverlappedAccess, N, <NONE>,  'CancelOverlappedAccess',  \
    ChangeServiceConfig2, A, <.hService, .dwInfoLevel, .lpInfo>,  'ChangeServiceConfig2A',  \
    ChangeServiceConfig2, W, <.hService, .dwInfoLevel, .lpInfo>,  'ChangeServiceConfig2W',  \
    ChangeServiceConfig, A, <.hService, .dwServiceType, .dwStartType, .dwErrorControl, .lpBinaryPathName, .lpLoadOrderGroup, .lpdwTagId,  \
        .lpDependencies, .lpServiceStartName, .lpPassword, .lpDisplayName>,  'ChangeServiceConfigA',  \
    ChangeServiceConfig, W, <.hService, .dwServiceType, .dwStartType, .dwErrorControl, .lpBinaryPathName, .lpLoadOrderGroup, .lpdwTagId,  \
        .lpDependencies, .lpServiceStartName, .lpPassword, .lpDisplayName>,  'ChangeServiceConfigW',  \
    CheckTokenMembership, N, <.TokenHandle, .SidToCheck, .IsMember>,  'CheckTokenMembership',  \
    ClearEventLog, A, <.hEventLog, .lpBackupFileName>,  'ClearEventLogA',  \
    ClearEventLog, W, <.hEventLog, .lpBackupFileName>,  'ClearEventLogW',  \
    CloseCodeAuthzLevel, N, <NONE>,  'CloseCodeAuthzLevel',  \
    CloseEncryptedFileRaw, N, <.pvContext>,  'CloseEncryptedFileRaw',  \
    CloseEventLog, N, <.hEventLog>,  'CloseEventLog',  \
    CloseServiceHandle, N, <.hSCObject>,  'CloseServiceHandle',  \
    CloseTrace, N, <NONE>,  'CloseTrace',  \
    CommandLineFromMsiDescriptor, N, <NONE>,  'CommandLineFromMsiDescriptor',  \
    ComputeAccessTokenFromCodeAuthzLevel, N, <NONE>,  'ComputeAccessTokenFromCodeAuthzLevel',  \
    ControlService, N, <.hService, .dwControl, .lpServiceStatus>,  'ControlService',  \
    ControlTrace, A, <NONE>,  'ControlTraceA',  \
    ControlTrace, W, <NONE>,  'ControlTraceW',  \
    ConvertAccessToSecurityDescriptor, A, <NONE>,  'ConvertAccessToSecurityDescriptorA',  \
    ConvertAccessToSecurityDescriptor, W, <NONE>,  'ConvertAccessToSecurityDescriptorW',  \
    ConvertSDToStringSDRootDomain, A, <NONE>,  'ConvertSDToStringSDRootDomainA',  \
    ConvertSDToStringSDRootDomain, W, <NONE>,  'ConvertSDToStringSDRootDomainW',  \
    ConvertSecurityDescriptorToAccess, A, <NONE>,  'ConvertSecurityDescriptorToAccessA',  \
    ConvertSecurityDescriptorToAccessNamed, A, <NONE>,  'ConvertSecurityDescriptorToAccessNamedA',  \
    ConvertSecurityDescriptorToAccessNamed, W, <NONE>,  'ConvertSecurityDescriptorToAccessNamedW',  \
    ConvertSecurityDescriptorToAccess, W, <NONE>,  'ConvertSecurityDescriptorToAccessW',  \
    ConvertSecurityDescriptorToStringSecurityDescriptor, A, <.SecurityDescriptor, .RequestedStringSDRevision, .SecurityInformation, .StringSecurityDescriptor,  \
        .StringSecurityDescriptorLen>,  'ConvertSecurityDescriptorToStringSecurityDescriptorA',  \
    ConvertSecurityDescriptorToStringSecurityDescriptor, W, <.SecurityDescriptor, .RequestedStringSDRevision, .SecurityInformation, .StringSecurityDescriptor,  \
        .StringSecurityDescriptorLen>,  'ConvertSecurityDescriptorToStringSecurityDescriptorW',  \
    ConvertSidToStringSid, A, <.Sid, .StringSid>,  'ConvertSidToStringSidA',  \
    ConvertSidToStringSid, W, <.Sid, .StringSid>,  'ConvertSidToStringSidW',  \
    ConvertStringSDToSDDomain, A, <NONE>,  'ConvertStringSDToSDDomainA',  \
    ConvertStringSDToSDDomain, W, <NONE>,  'ConvertStringSDToSDDomainW',  \
    ConvertStringSDToSDRootDomain, A, <NONE>,  'ConvertStringSDToSDRootDomainA',  \
    ConvertStringSDToSDRootDomain, W, <NONE>,  'ConvertStringSDToSDRootDomainW',  \
    ConvertStringSecurityDescriptorToSecurityDescriptor, A, <.StringSecurityDescriptor, .StringSDRevision, .SecurityDescriptor, .SecurityDescriptorSize,  \
      >,  'ConvertStringSecurityDescriptorToSecurityDescriptorA',  \
    ConvertStringSecurityDescriptorToSecurityDescriptor, W, <.StringSecurityDescriptor, .StringSDRevision, .SecurityDescriptor, .SecurityDescriptorSize,  \
      >,  'ConvertStringSecurityDescriptorToSecurityDescriptorW',  \
    ConvertStringSidToSid, A, <.StringSid, .Sid>,  'ConvertStringSidToSidA',  \
    ConvertStringSidToSid, W, <.StringSid, .Sid>,  'ConvertStringSidToSidW',  \
    ConvertToAutoInheritPrivateObjectSecurity, N, <.ParentDescriptor, .CurrentSecurityDescriptor, .NewSecurityDescriptor, .ObjectType,  \
        .IsDirectoryObject, .GenericMapping>,  'ConvertToAutoInheritPrivateObjectSecurity',  \
    CopySid, N, <.nDestinationSidLength, .pDestinationSid, .pSourceSid>,  'CopySid',  \
    CreateCodeAuthzLevel, N, <NONE>,  'CreateCodeAuthzLevel',  \
    CreatePrivateObjectSecurity, N, <.ParentDescriptor, .CreatorDescriptor, .NewDescriptor, .IsDirectoryObject, .Token, .GenericMapping,  \
      >,  'CreatePrivateObjectSecurity',  \
    CreatePrivateObjectSecurityEx, N, <.ParentDescriptor, .CreatorDescriptor, .NewDescriptor, .ObjectType, .IsContainerObject, .AutoInheritFlags,  \
        .Token, .GenericMapping>,  'CreatePrivateObjectSecurityEx',  \
    CreatePrivateObjectSecurityWithMultipleInheritance, N, <NONE>,  'CreatePrivateObjectSecurityWithMultipleInheritance',  \
    CreateProcessAsUser, A, <.hToken, .lpApplicationName, .lpCommandLine, .lpProcessAttributes, .lpThreadAttributes, .bInheritHandles,  \
        .dwCreationFlags, .lpEnvironment, .lpCurrentDirectory, .lpStartupInfo, .lpProcessInformation>,  'CreateProcessAsUserA',  \
    CreateProcessAsUserSecure, N, <NONE>,  'CreateProcessAsUserSecure',  \
    CreateProcessAsUser, W, <.hToken, .lpApplicationName, .lpCommandLine, .lpProcessAttributes, .lpThreadAttributes, .bInheritHandles,  \
        .dwCreationFlags, .lpEnvironment, .lpCurrentDirectory, .lpStartupInfo, .lpProcessInformation>,  'CreateProcessAsUserW',  \
    CreateProcessWithLogon, W, <NONE>,  'CreateProcessWithLogonW',  \
    CreateRestrictedToken, N, <.ExistingTokenHandle, .Flags, .DisableSidCount, .SidsToDisable, .DeletePrivilegeCount, .PrivilegesToDelete,  \
        .RestrictedSidCount, .SidsToRestrict, .NewTokenHandle>,  'CreateRestrictedToken',  \
    CreateService, A, <.hSCManager, .lpServiceName, .lpDisplayName, .dwDesiredAccess, .dwServiceType, .dwStartType, .dwErrorControl, .lpBinaryPathName,  \
        .lpLoadOrderGroup, .lpdwTagId, .lpDependencies, .lp, .lpPassword>,  'CreateServiceA',  \
    CreateService, W, <.hSCManager, .lpServiceName, .lpDisplayName, .dwDesiredAccess, .dwServiceType, .dwStartType, .dwErrorControl, .lpBinaryPathName,  \
        .lpLoadOrderGroup, .lpdwTagId, .lpDependencies, .lp, .lpPassword>,  'CreateServiceW',  \
    CreateTraceInstanceId, N, <NONE>,  'CreateTraceInstanceId',  \
    CreateWellKnownSid, N, <NONE>,  'CreateWellKnownSid',  \
    CredDelete, A, <NONE>,  'CredDeleteA',  \
    CredDelete, W, <NONE>,  'CredDeleteW',  \
    CredEnumerate, A, <NONE>,  'CredEnumerateA',  \
    CredEnumerate, W, <NONE>,  'CredEnumerateW',  \
    CredFree, N, <NONE>,  'CredFree',  \
    CredGetSessionTypes, N, <NONE>,  'CredGetSessionTypes',  \
    CredGetTargetInfo, A, <NONE>,  'CredGetTargetInfoA',  \
    CredGetTargetInfo, W, <NONE>,  'CredGetTargetInfoW',  \
    CredIsMarshaledCredential, A, <NONE>,  'CredIsMarshaledCredentialA',  \
    CredIsMarshaledCredential, W, <NONE>,  'CredIsMarshaledCredentialW',  \
    CredMarshalCredential, A, <NONE>,  'CredMarshalCredentialA',  \
    CredMarshalCredential, W, <NONE>,  'CredMarshalCredentialW',  \
    CredProfileLoaded, N, <NONE>,  'CredProfileLoaded',  \
    CredRead, A, <NONE>,  'CredReadA',  \
    CredReadDomainCredentials, A, <NONE>,  'CredReadDomainCredentialsA',  \
    CredReadDomainCredentials, W, <NONE>,  'CredReadDomainCredentialsW',  \
    CredRead, W, <NONE>,  'CredReadW',  \
    CredRename, A, <NONE>,  'CredRenameA',  \
    CredRename, W, <NONE>,  'CredRenameW',  \
    CredUnmarshalCredential, A, <NONE>,  'CredUnmarshalCredentialA',  \
    CredUnmarshalCredential, W, <NONE>,  'CredUnmarshalCredentialW',  \
    CredWrite, A, <NONE>,  'CredWriteA',  \
    CredWriteDomainCredentials, A, <NONE>,  'CredWriteDomainCredentialsA',  \
    CredWriteDomainCredentials, W, <NONE>,  'CredWriteDomainCredentialsW',  \
    CredWrite, W, <NONE>,  'CredWriteW',  \
    CredpConvertCredential, N, <NONE>,  'CredpConvertCredential',  \
    CredpConvertTargetInfo, N, <NONE>,  'CredpConvertTargetInfo',  \
    CredpDecodeCredential, N, <NONE>,  'CredpDecodeCredential',  \
    CredpEncodeCredential, N, <NONE>,  'CredpEncodeCredential',  \
    CryptAcquireContext, A, <.phProv, .pszContainer, .pszProvider, .dwProvType, .dwFlags>,  'CryptAcquireContextA',  \
    CryptAcquireContext, W, <.phProv, .pszContainer, .pszProvider, .dwProvType, .dwFlags>,  'CryptAcquireContextW',  \
    CryptContextAddRef, N, <.hProv, .pdwReserved, .dwFlags>,  'CryptContextAddRef',  \
    CryptCreateHash, N, <.hProv, .Algid, .hKey, .dwFlags, .phHash>,  'CryptCreateHash',  \
    CryptDecrypt, N, <.hKey, .hHash, .Final, .dwFlags, .pbData, .pdwDataLen>,  'CryptDecrypt',  \
    CryptDeriveKey, N, <.hProv, .Algid, .hBaseData, .dwFlags, .phKey>,  'CryptDeriveKey',  \
    CryptDestroyHash, N, <.hHash>,  'CryptDestroyHash',  \
    CryptDestroyKey, N, <.hKey>,  'CryptDestroyKey',  \
    CryptDuplicateHash, N, <.hHash, .pdwReserved, .dwFlags, .phHash>,  'CryptDuplicateHash',  \
    CryptDuplicateKey, N, <.hKey, .pdwReserved, .dwFlags, .phKey>,  'CryptDuplicateKey',  \
    CryptEncrypt, N, <.hKey, .hHash, .Final, .dwFlags, .pbData, .pdwDataLen, .dwBufLen>,  'CryptEncrypt',  \
    CryptEnumProviderTypes, A, <.dwIndex, .pdwReserved, .dwFlags, .pdwProvType, .pszTypeName, .pcbTypeName>,  'CryptEnumProviderTypesA',  \
    CryptEnumProviderTypes, W, <.dwIndex, .pdwReserved, .dwFlags, .pdwProvType, .pszTypeName, .pcbTypeName>,  'CryptEnumProviderTypesW',  \
    CryptEnumProviders, A, <.dwIndex, .pdwReserved, .dwFlags, .pdwProvType, .pszProvName, .pcbProvName>,  'CryptEnumProvidersA',  \
    CryptEnumProviders, W, <.dwIndex, .pdwReserved, .dwFlags, .pdwProvType, .pszProvName, .pcbProvName>,  'CryptEnumProvidersW',  \
    CryptExportKey, N, <.hKey, .hExpKey, .dwBlobType, .dwFlags, .pbData, .pdwDataLen>,  'CryptExportKey',  \
    CryptGenKey, N, <.hProv, .Algid, .dwFlags, .phKey>,  'CryptGenKey',  \
    CryptGenRandom, N, <.hProv, .dwLen, .pbBuffer>,  'CryptGenRandom',  \
    CryptGetDefaultProvider, A, <.dwProvType, .pdwReserved, .dwFlags, .pszProvName, .pcbProvName>,  'CryptGetDefaultProviderA',  \
    CryptGetDefaultProvider, W, <.dwProvType, .pdwReserved, .dwFlags, .pszProvName, .pcbProvName>,  'CryptGetDefaultProviderW',  \
    CryptGetHashParam, N, <.hHash, .dwParam, .pbData, .pdwDataLen, .dwFlags>,  'CryptGetHashParam',  \
    CryptGetKeyParam, N, <.hKey, .dwParam, .pbData, .pdwDataLen, .dwFlags>,  'CryptGetKeyParam',  \
    CryptGetProvParam, N, <.hProv, .dwParam, .pbData, .pdwDataLen, .dwFlags>,  'CryptGetProvParam',  \
    CryptGetUserKey, N, <.hProv, .dwKeySpec, .phUserKey>,  'CryptGetUserKey',  \
    CryptHashData, N, <.hHash, .pbData, .dwDataLen, .dwFlags>,  'CryptHashData',  \
    CryptHashSessionKey, N, <.hHash, .hKey, .dwFlags>,  'CryptHashSessionKey',  \
    CryptImportKey, N, <.hProv, .pbData, .dwDataLen, .hPubKey, .dwFlags, .phKey>,  'CryptImportKey',  \
    CryptReleaseContext, N, <.hProv, .dwFlags>,  'CryptReleaseContext',  \
    CryptSetHashParam, N, <.hHash, .dwParam, .pbData, .dwFlags>,  'CryptSetHashParam',  \
    CryptSetKeyParam, N, <.hKey, .dwParam, .pbData, .dwFlags>,  'CryptSetKeyParam',  \
    CryptSetProvParam, N, <.hProv, .dwParam, .pbData, .dwFlags>,  'CryptSetProvParam',  \
    CryptSetProvider, A, <.pszProvName, .dwProvType>,  'CryptSetProviderA',  \
    CryptSetProviderEx, A, <.pszProvName, .dwProvType, .pdwReserved, .dwFlags>,  'CryptSetProviderExA',  \
    CryptSetProviderEx, W, <.pszProvName, .dwProvType, .pdwReserved, .dwFlags>,  'CryptSetProviderExW',  \
    CryptSetProvider, W, <.pszProvName, .dwProvType>,  'CryptSetProviderW',  \
    CryptSignHash, A, <.hHash, .dwKeySpec, .sDescription, .dwFlags, .pbSignature, .pdwSigLen>,  'CryptSignHashA',  \
    CryptSignHash, W, <.hHash, .dwKeySpec, .sDescription, .dwFlags, .pbSignature, .pdwSigLen>,  'CryptSignHashW',  \
    CryptVerifySignature, A, <.hHash, .pbSignature, .dwSigLen, .hPubKey, .sDescription, .dwFlags>,  'CryptVerifySignatureA',  \
    CryptVerifySignature, W, <.hHash, .pbSignature, .dwSigLen, .hPubKey, .sDescription, .dwFlags>,  'CryptVerifySignatureW',  \
    DecryptFile, A, <.lpFileName, .dwReserved>,  'DecryptFileA',  \
    DecryptFile, W, <.lpFileName, .dwReserved>,  'DecryptFileW',  \
    DeleteAce, N, <.pAcl, .dwAceIndex>,  'DeleteAce',  \
    DeleteService, N, <.hService>,  'DeleteService',  \
    DeregisterEventSource, N, <.hEventLog>,  'DeregisterEventSource',  \
    DestroyPrivateObjectSecurity, N, <.ObjectDescriptor>,  'DestroyPrivateObjectSecurity',  \
    DuplicateEncryptionInfoFile, N, <NONE>,  'DuplicateEncryptionInfoFile',  \
    DuplicateToken, N, <.ExistingTokenHandle, .ImpersonationLevel, .DuplicateTokenHandle>,  'DuplicateToken',  \
    DuplicateTokenEx, N, <.hExistingToken, .dwDesiredAccess, .lpTokenAttributes, .ImpersonationLevel, .TokenType, .phNewToken>,  'DuplicateTokenEx',  \
    ElfBackupEventLogFile, A, <NONE>,  'ElfBackupEventLogFileA',  \
    ElfBackupEventLogFile, W, <NONE>,  'ElfBackupEventLogFileW',  \
    ElfChangeNotify, N, <NONE>,  'ElfChangeNotify',  \
    ElfClearEventLogFile, A, <NONE>,  'ElfClearEventLogFileA',  \
    ElfClearEventLogFile, W, <NONE>,  'ElfClearEventLogFileW',  \
    ElfCloseEventLog, N, <NONE>,  'ElfCloseEventLog',  \
    ElfDeregisterEventSource, N, <NONE>,  'ElfDeregisterEventSource',  \
    ElfFlushEventLog, N, <NONE>,  'ElfFlushEventLog',  \
    ElfNumberOfRecords, N, <NONE>,  'ElfNumberOfRecords',  \
    ElfOldestRecord, N, <NONE>,  'ElfOldestRecord',  \
    ElfOpenBackupEventLog, A, <NONE>,  'ElfOpenBackupEventLogA',  \
    ElfOpenBackupEventLog, W, <NONE>,  'ElfOpenBackupEventLogW',  \
    ElfOpenEventLog, A, <NONE>,  'ElfOpenEventLogA',  \
    ElfOpenEventLog, W, <NONE>,  'ElfOpenEventLogW',  \
    ElfReadEventLog, A, <NONE>,  'ElfReadEventLogA',  \
    ElfReadEventLog, W, <NONE>,  'ElfReadEventLogW',  \
    ElfRegisterEventSource, A, <NONE>,  'ElfRegisterEventSourceA',  \
    ElfRegisterEventSource, W, <NONE>,  'ElfRegisterEventSourceW',  \
    ElfReportEvent, A, <NONE>,  'ElfReportEventA',  \
    ElfReportEvent, W, <NONE>,  'ElfReportEventW',  \
    EnableTrace, N, <NONE>,  'EnableTrace',  \
    EncryptFile, A, <.lpFileName>,  'EncryptFileA',  \
    EncryptFile, W, <.lpFileName>,  'EncryptFileW',  \
    EncryptedFileKeyInfo, N, <NONE>,  'EncryptedFileKeyInfo',  \
    EncryptionDisable, N, <.DirPath, .Disable>,  'EncryptionDisable',  \
    EnumDependentServices, A, <.hService, .dwServiceState, .lpServices, .cbBufSize, .pcbBytesNeeded, .lpServicesReturned>,  'EnumDependentServicesA',  \
    EnumDependentServices, W, <.hService, .dwServiceState, .lpServices, .cbBufSize, .pcbBytesNeeded, .lpServicesReturned>,  'EnumDependentServicesW',  \
    EnumServiceGroup, W, <NONE>,  'EnumServiceGroupW',  \
    EnumServicesStatus, A, <.hSCManager, .dwServiceType, .dwServiceState, .lpServices, .cbBufSize, .pcbBytesNeeded, .lpServicesReturned,  \
        .lpResumeHandle>,  'EnumServicesStatusA',  \
    EnumServicesStatusEx, A, <.hSCManager, .InfoLevel, .dwServiceType, .dwServiceState, .lpServices, .cbBufSize, .pcbBytesNeeded, .lpServicesReturned,  \
        .lpResumeHandle, .pszGroupName>,  'EnumServicesStatusExA',  \
    EnumServicesStatusEx, W, <.hSCManager, .InfoLevel, .dwServiceType, .dwServiceState, .lpServices, .cbBufSize, .pcbBytesNeeded, .lpServicesReturned,  \
        .lpResumeHandle, .pszGroupName>,  'EnumServicesStatusExW',  \
    EnumServicesStatus, W, <.hSCManager, .dwServiceType, .dwServiceState, .lpServices, .cbBufSize, .pcbBytesNeeded, .lpServicesReturned,  \
        .lpResumeHandle>,  'EnumServicesStatusW',  \
    EnumerateTraceGuids, N, <NONE>,  'EnumerateTraceGuids',  \
    EqualDomainSid, N, <NONE>,  'EqualDomainSid',  \
    EqualPrefixSid, N, <.pSid1, .pSid2>,  'EqualPrefixSid',  \
    EqualSid, N, <.pSid1, .pSid2>,  'EqualSid',  \
    FileEncryptionStatus, A, <.lpFileName, .lpStatus>,  'FileEncryptionStatusA',  \
    FileEncryptionStatus, W, <.lpFileName, .lpStatus>,  'FileEncryptionStatusW',  \
    FindFirstFreeAce, N, <.pAcl, .pAce>,  'FindFirstFreeAce',  \
    FlushTrace, A, <NONE>,  'FlushTraceA',  \
    FlushTrace, W, <NONE>,  'FlushTraceW',  \
    FreeEncryptedFileKeyInfo, N, <NONE>,  'FreeEncryptedFileKeyInfo',  \
    FreeEncryptionCertificateHashList, N, <.pHashes>,  'FreeEncryptionCertificateHashList',  \
    FreeInheritedFromArray, N, <.pInheritArray, .AceCnt, .pfnArray>,  'FreeInheritedFromArray',  \
    FreeSid, N, <.pSid>,  'FreeSid',  \
    GetAccessPermissionsForObject, A, <NONE>,  'GetAccessPermissionsForObjectA',  \
    GetAccessPermissionsForObject, W, <NONE>,  'GetAccessPermissionsForObjectW',  \
    GetAce, N, <.pAcl, .dwAceIndex, .pAce>,  'GetAce',  \
    GetAclInformation, N, <.pAcl, .pAclInformation, .nAclInformationLength, .dwAclInformationClass>,  'GetAclInformation',  \
    GetAuditedPermissionsFromAcl, A, <.pAcl, .pTrustee, .pSuccessfulAuditedRights, .pFailedAuditRights>,  'GetAuditedPermissionsFromAclA',  \
    GetAuditedPermissionsFromAcl, W, <.pAcl, .pTrustee, .pSuccessfulAuditedRights, .pFailedAuditRights>,  'GetAuditedPermissionsFromAclW',  \
    GetCurrentHwProfile, A, <.lpHwProfileInfo>,  'GetCurrentHwProfileA',  \
    GetCurrentHwProfile, W, <.lpHwProfileInfo>,  'GetCurrentHwProfileW',  \
    GetEffectiveRightsFromAcl, A, <.pAcl, .pTrustee, .pAccessRights>,  'GetEffectiveRightsFromAclA',  \
    GetEffectiveRightsFromAcl, W, <.pAcl, .pTrustee, .pAccessRights>,  'GetEffectiveRightsFromAclW',  \
    GetEventLogInformation, N, <.hEventLog, .dwInfoLevel, .lpBuffer, .cbBufSize, .pcbBytesNeeded>,  'GetEventLogInformation',  \
    GetExplicitEntriesFromAcl, A, <.pAcl, .pcCountOfExplicitEntries, .pListOfExplicitEntries>,  'GetExplicitEntriesFromAclA',  \
    GetExplicitEntriesFromAcl, W, <.pAcl, .pcCountOfExplicitEntries, .pListOfExplicitEntries>,  'GetExplicitEntriesFromAclW',  \
    GetFileSecurity, A, <.lpFileName, .RequestedInformation, .pSecurityDescriptor, .nLength, .lpnLengthNeeded>,  'GetFileSecurityA',  \
    GetFileSecurity, W, <.lpFileName, .RequestedInformation, .pSecurityDescriptor, .nLength, .lpnLengthNeeded>,  'GetFileSecurityW',  \
    GetInformationCodeAuthzLevel, W, <NONE>,  'GetInformationCodeAuthzLevelW',  \
    GetInformationCodeAuthzPolicy, W, <NONE>,  'GetInformationCodeAuthzPolicyW',  \
    GetInheritanceSource, A, <.pObjectName, .ObjectType, .SecurityInfo, .Container, .ObjectTypeGuid, .pAcl, .pfnArray, .pGenericMapping,  \
        .pInheritArray>,  'GetInheritanceSourceA',  \
    GetInheritanceSource, W, <.pObjectName, .ObjectType, .SecurityInfo, .Container, .ObjectTypeGuid, .pAcl, .pfnArray, .pGenericMapping,  \
        .pInheritArray>,  'GetInheritanceSourceW',  \
    GetKernelObjectSecurity, N, <.Handle, .RequestedInformation, .pSecurityDescriptor, .nLength, .lpnLengthNeeded>,  'GetKernelObjectSecurity',  \
    GetLengthSid, N, <.pSid>,  'GetLengthSid',  \
    GetLocalManagedApplicationData, N, <NONE>,  'GetLocalManagedApplicationData',  \
    GetLocalManagedApplications, N, <NONE>,  'GetLocalManagedApplications',  \
    GetManagedApplicationCategories, N, <NONE>,  'GetManagedApplicationCategories',  \
    GetManagedApplications, N, <NONE>,  'GetManagedApplications',  \
    GetMultipleTrustee, A, <.pTrustee>,  'GetMultipleTrusteeA',  \
    GetMultipleTrusteeOperation, A, <.pTrustee>,  'GetMultipleTrusteeOperationA',  \
    GetMultipleTrusteeOperation, W, <.pTrustee>,  'GetMultipleTrusteeOperationW',  \
    GetMultipleTrustee, W, <.pTrustee>,  'GetMultipleTrusteeW',  \
    GetNamedSecurityInfo, A, <.pObjectName, .ObjectType, .SecurityInfo, .ppsidOwner, .ppsidGroup, .ppDacl, .ppSacl, .ppSecurityDescriptor,  \
      >,  'GetNamedSecurityInfoA',  \
    GetNamedSecurityInfoEx, A, <NONE>,  'GetNamedSecurityInfoExA',  \
    GetNamedSecurityInfoEx, W, <NONE>,  'GetNamedSecurityInfoExW',  \
    GetNamedSecurityInfo, W, <.pObjectName, .ObjectType, .SecurityInfo, .ppsidOwner, .ppsidGroup, .ppDacl, .ppSacl, .ppSecurityDescriptor,  \
      >,  'GetNamedSecurityInfoW',  \
    GetNumberOfEventLogRecords, N, <.hEventLog, .NumberOfRecords>,  'GetNumberOfEventLogRecords',  \
    GetOldestEventLogRecord, N, <.hEventLog, .OldestRecord>,  'GetOldestEventLogRecord',  \
    GetOverlappedAccessResults, N, <NONE>,  'GetOverlappedAccessResults',  \
    GetPrivateObjectSecurity, N, <.ObjectDescriptor, .SecurityInformation, .ResultantDescriptor, .DescriptorLength, .ReturnLength>,  'GetPrivateObjectSecurity',  \
    GetSecurityDescriptorControl, N, <.pSecurityDescriptor, .pControl, .lpdwRevision>,  'GetSecurityDescriptorControl',  \
    GetSecurityDescriptorDacl, N, <.pSecurityDescriptor, .lpbDaclPresent, .pDacl, .lpbDaclDefaulted>,  'GetSecurityDescriptorDacl',  \
    GetSecurityDescriptorGroup, N, <.pSecurityDescriptor, .pGroup, .lpbGroupDefaulted>,  'GetSecurityDescriptorGroup',  \
    GetSecurityDescriptorLength, N, <.pSecurityDescriptor>,  'GetSecurityDescriptorLength',  \
    GetSecurityDescriptorOwner, N, <.pSecurityDescriptor, .pOwner, .lpbOwnerDefaulted>,  'GetSecurityDescriptorOwner',  \
    GetSecurityDescriptorRMControl, N, <.SecurityDescriptor, .RMControl>,  'GetSecurityDescriptorRMControl',  \
    GetSecurityDescriptorSacl, N, <.pSecurityDescriptor, .lpbSaclPresent, .pSacl, .lpbSaclDefaulted>,  'GetSecurityDescriptorSacl',  \
    GetSecurityInfo, N, <.Handle, .ObjectType, .SecurityInfo, .ppsidOwner, .ppsidGroup, .ppDacl, .ppSacl, .ppSecurityDescriptor>,  'GetSecurityInfo',  \
    GetSecurityInfoEx, A, <NONE>,  'GetSecurityInfoExA',  \
    GetSecurityInfoEx, W, <NONE>,  'GetSecurityInfoExW',  \
    GetServiceDisplayName, A, <.hSCManager, .lpServiceName, .lpDisplayName, .lpcchBuffer>,  'GetServiceDisplayNameA',  \
    GetServiceDisplayName, W, <.hSCManager, .lpServiceName, .lpDisplayName, .lpcchBuffer>,  'GetServiceDisplayNameW',  \
    GetServiceKeyName, A, <.hSCManager, .lpDisplayName, .lpServiceName, .lpcchBuffer>,  'GetServiceKeyNameA',  \
    GetServiceKeyName, W, <.hSCManager, .lpDisplayName, .lpServiceName, .lpcchBuffer>,  'GetServiceKeyNameW',  \
    GetSidIdentifierAuthority, N, <.pSid>,  'GetSidIdentifierAuthority',  \
    GetSidLengthRequired, N, <.nSubAuthorityCount>,  'GetSidLengthRequired',  \
    GetSidSubAuthority, N, <.pSid, .nSubAuthority>,  'GetSidSubAuthority',  \
    GetSidSubAuthorityCount, N, <.pSid>,  'GetSidSubAuthorityCount',  \
    GetTokenInformation, N, <.TokenHandle, .TokenInformationClass, .TokenInformation, .TokenInformationLength, .ReturnLength>,  'GetTokenInformation',  \
    GetTraceEnableFlags, N, <NONE>,  'GetTraceEnableFlags',  \
    GetTraceEnableLevel, N, <NONE>,  'GetTraceEnableLevel',  \
    GetTraceLoggerHandle, N, <NONE>,  'GetTraceLoggerHandle',  \
    GetTrusteeForm, A, <.pTrustee>,  'GetTrusteeFormA',  \
    GetTrusteeForm, W, <.pTrustee>,  'GetTrusteeFormW',  \
    GetTrusteeName, A, <.pTrustee>,  'GetTrusteeNameA',  \
    GetTrusteeName, W, <.pTrustee>,  'GetTrusteeNameW',  \
    GetTrusteeType, A, <.pTrustee>,  'GetTrusteeTypeA',  \
    GetTrusteeType, W, <.pTrustee>,  'GetTrusteeTypeW',  \
    GetUserName, A, <.lpBuffer, .nSize>,  'GetUserNameA',  \
    GetUserName, W, <.lpBuffer, .nSize>,  'GetUserNameW',  \
    GetWindowsAccountDomainSid, N, <NONE>,  'GetWindowsAccountDomainSid',  \
    I_ScGetCurrentGroupState, W, <NONE>,  'I_ScGetCurrentGroupStateW',  \
    I_ScIsSecurityProcess, N, <NONE>,  'I_ScIsSecurityProcess',  \
    I_ScPnPGetServiceName, N, <NONE>,  'I_ScPnPGetServiceName',  \
    I_ScSendTSMessage, N, <NONE>,  'I_ScSendTSMessage',  \
    I_ScSetServiceBits, A, <NONE>,  'I_ScSetServiceBitsA',  \
    I_ScSetServiceBits, W, <NONE>,  'I_ScSetServiceBitsW',  \
    IdentifyCodeAuthzLevel, W, <NONE>,  'IdentifyCodeAuthzLevelW',  \
    ImpersonateAnonymousToken, N, <.ThreadHandle>,  'ImpersonateAnonymousToken',  \
    ImpersonateLoggedOnUser, N, <.hToken>,  'ImpersonateLoggedOnUser',  \
    ImpersonateNamedPipeClient, N, <.hNamedPipe>,  'ImpersonateNamedPipeClient',  \
    ImpersonateSelf, N, <.ImpersonationLevel>,  'ImpersonateSelf',  \
    InitializeAcl, N, <.pAcl, .nAclLength, .dwAclRevision>,  'InitializeAcl',  \
    InitializeSecurityDescriptor, N, <.pSecurityDescriptor, .dwRevision>,  'InitializeSecurityDescriptor',  \
    InitializeSid, N, <.Sid, .pIdentifierAuthority, .nSubAuthorityCount>,  'InitializeSid',  \
    InitiateSystemShutdown, A, <.lpMachineName, .lpMessage, .dwTimeout, .bForceAppsClosed, .bRebootAfterShutdown>,  'InitiateSystemShutdownA',  \
    InitiateSystemShutdownEx, A, <.lpMachineName, .lpMessage, .dwTimeout, .bForceAppsClosed, .bRebootAfterShutdown, .dwReason>,  'InitiateSystemShutdownExA',  \
    InitiateSystemShutdownEx, W, <.lpMachineName, .lpMessage, .dwTimeout, .bForceAppsClosed, .bRebootAfterShutdown, .dwReason>,  'InitiateSystemShutdownExW',  \
    InitiateSystemShutdown, W, <.lpMachineName, .lpMessage, .dwTimeout, .bForceAppsClosed, .bRebootAfterShutdown>,  'InitiateSystemShutdownW',  \
    InstallApplication, N, <NONE>,  'InstallApplication',  \
    IsTextUnicode, N, <.lpBuffer, .cb, .lpi>,  'IsTextUnicode',  \
    IsTokenRestricted, N, <.TokenHandle>,  'IsTokenRestricted',  \
    IsTokenUntrusted, N, <NONE>,  'IsTokenUntrusted',  \
    IsValidAcl, N, <.pAcl>,  'IsValidAcl',  \
    IsValidSecurityDescriptor, N, <.pSecurityDescriptor>,  'IsValidSecurityDescriptor',  \
    IsValidSid, N, <.pSid>,  'IsValidSid',  \
    IsWellKnownSid, N, <NONE>,  'IsWellKnownSid',  \
    LockServiceDatabase, N, <.hSCManager>,  'LockServiceDatabase',  \
    LogonUser, A, <.lpszUsername, .lpszDomain, .lpszPassword, .dwLogonType, .dwLogonProvider, .phToken>,  'LogonUserA',  \
    LogonUserEx, A, <NONE>,  'LogonUserExA',  \
    LogonUserEx, W, <NONE>,  'LogonUserExW',  \
    LogonUser, W, <.lpszUsername, .lpszDomain, .lpszPassword, .dwLogonType, .dwLogonProvider, .phToken>,  'LogonUserW',  \
    LookupAccountName, A, <.lpSystemName, .lpAccountName, .Sid, .cbSid, .ReferencedDomainName, .cbReferencedDomainName, .peUse>,  'LookupAccountNameA',  \
    LookupAccountName, W, <.lpSystemName, .lpAccountName, .Sid, .cbSid, .ReferencedDomainName, .cbReferencedDomainName, .peUse>,  'LookupAccountNameW',  \
    LookupAccountSid, A, <.lpSystemName, .Sid, .Name, .cbName, .ReferencedDomainName, .cbReferencedDomainName, .peUse>,  'LookupAccountSidA',  \
    LookupAccountSid, W, <.lpSystemName, .Sid, .Name, .cbName, .ReferencedDomainName, .cbReferencedDomainName, .peUse>,  'LookupAccountSidW',  \
    LookupPrivilegeDisplayName, A, <.lpSystemName, .lpName, .lpDisplayName, .cbDisplayName, .lpLanguageID>,  'LookupPrivilegeDisplayNameA',  \
    LookupPrivilegeDisplayName, W, <.lpSystemName, .lpName, .lpDisplayName, .cbDisplayName, .lpLanguageID>,  'LookupPrivilegeDisplayNameW',  \
    LookupPrivilegeName, A, <.lpSystemName, .lpLuid, .lpName, .cbName>,  'LookupPrivilegeNameA',  \
    LookupPrivilegeName, W, <.lpSystemName, .lpLuid, .lpName, .cbName>,  'LookupPrivilegeNameW',  \
    LookupPrivilegeValue, A, <.lpSystemName, .lpName, .lpLuid>,  'LookupPrivilegeValueA',  \
    LookupPrivilegeValue, W, <.lpSystemName, .lpName, .lpLuid>,  'LookupPrivilegeValueW',  \
    LookupSecurityDescriptorParts, A, <.pOwner, .pGroup, .cCountOfAccessEntries, .pListOfAccessEntries, .cCountOfAuditEntries, .pListOfAuditEntries,  \
        .pSD>,  'LookupSecurityDescriptorPartsA',  \
    LookupSecurityDescriptorParts, W, <.pOwner, .pGroup, .cCountOfAccessEntries, .pListOfAccessEntries, .cCountOfAuditEntries, .pListOfAuditEntries,  \
        .pSD>,  'LookupSecurityDescriptorPartsW',  \
    LsaAddAccountRights, N, <.PolicyHandle, .AccountSid, .UserRights, .CountOfRights>,  'LsaAddAccountRights',  \
    LsaAddPrivilegesToAccount, N, <NONE>,  'LsaAddPrivilegesToAccount',  \
    LsaClearAuditLog, N, <NONE>,  'LsaClearAuditLog',  \
    LsaClose, N, <.ObjectHandle>,  'LsaClose',  \
    LsaCreateAccount, N, <NONE>,  'LsaCreateAccount',  \
    LsaCreateSecret, N, <NONE>,  'LsaCreateSecret',  \
    LsaCreateTrustedDomain, N, <NONE>,  'LsaCreateTrustedDomain',  \
    LsaCreateTrustedDomainEx, N, <.PolicyHandle, .TrustedDomainInformation, .AuthenticationInformation, .DesiredAccess, .TrustedDomainHandle,  \
      >,  'LsaCreateTrustedDomainEx',  \
    LsaDelete, N, <NONE>,  'LsaDelete',  \
    LsaDeleteTrustedDomain, N, <.PolicyHandle, .TrustedDomainSid>,  'LsaDeleteTrustedDomain',  \
    LsaEnumerateAccountRights, N, <.PolicyHandle, .AccountSid, .UserRights, .CountOfRights>,  'LsaEnumerateAccountRights',  \
    LsaEnumerateAccounts, N, <NONE>,  'LsaEnumerateAccounts',  \
    LsaEnumerateAccountsWithUserRight, N, <.PolicyHandle, .UserRights, .EnumerationBuffer, .CountReturned>,  'LsaEnumerateAccountsWithUserRight',  \
    LsaEnumeratePrivileges, N, <NONE>,  'LsaEnumeratePrivileges',  \
    LsaEnumeratePrivilegesOfAccount, N, <NONE>,  'LsaEnumeratePrivilegesOfAccount',  \
    LsaEnumerateTrustedDomains, N, <.PolicyHandle, .EnumerationContext, .buffer, .PreferedMaximumLength, .CountReturned>,  'LsaEnumerateTrustedDomains',  \
    LsaEnumerateTrustedDomainsEx, N, <.PolicyHandle, .EnumerationContext, .buffer, .PreferedMaximumLength, .CountReturned>,  'LsaEnumerateTrustedDomainsEx',  \
    LsaFreeMemory, N, <.buffer>,  'LsaFreeMemory',  \
    LsaGetQuotasForAccount, N, <NONE>,  'LsaGetQuotasForAccount',  \
    LsaGetRemoteUserName, N, <NONE>,  'LsaGetRemoteUserName',  \
    LsaGetSystemAccessAccount, N, <NONE>,  'LsaGetSystemAccessAccount',  \
    LsaGetUserName, N, <NONE>,  'LsaGetUserName',  \
    LsaICLookupNames, N, <NONE>,  'LsaICLookupNames',  \
    LsaICLookupNamesWithCreds, N, <NONE>,  'LsaICLookupNamesWithCreds',  \
    LsaICLookupSids, N, <NONE>,  'LsaICLookupSids',  \
    LsaICLookupSidsWithCreds, N, <NONE>,  'LsaICLookupSidsWithCreds',  \
    LsaLookupNames, N, <.PolicyHandle, .count, .Names, .ReferencedDomains, .Sids>,  'LsaLookupNames',  \
    LsaLookupNames2, N, <NONE>,  'LsaLookupNames2',  \
    LsaLookupPrivilegeDisplayName, N, <NONE>,  'LsaLookupPrivilegeDisplayName',  \
    LsaLookupPrivilegeName, N, <NONE>,  'LsaLookupPrivilegeName',  \
    LsaLookupPrivilegeValue, N, <NONE>,  'LsaLookupPrivilegeValue',  \
    LsaLookupSids, N, <.PolicyHandle, .count, .Sids, .ReferencedDomains, .Names>,  'LsaLookupSids',  \
    LsaNtStatusToWinError, N, <.Status>,  'LsaNtStatusToWinError',  \
    LsaOpenAccount, N, <NONE>,  'LsaOpenAccount',  \
    LsaOpenPolicy, N, <.SystemName, .ObjectAttributes, .DesiredAccess, .PolicyHandle>,  'LsaOpenPolicy',  \
    LsaOpenPolicySce, N, <NONE>,  'LsaOpenPolicySce',  \
    LsaOpenSecret, N, <NONE>,  'LsaOpenSecret',  \
    LsaOpenTrustedDomain, N, <NONE>,  'LsaOpenTrustedDomain',  \
    LsaOpenTrustedDomainByName, N, <.PolicyHandle, .TrustedDomainName, .DesiredAccess, .TrustedDomainHandle>,  'LsaOpenTrustedDomainByName',  \
    LsaQueryDomainInformationPolicy, N, <.PolicyHandle, .InformationClass, .buffer>,  'LsaQueryDomainInformationPolicy',  \
    LsaQueryForestTrustInformation, N, <NONE>,  'LsaQueryForestTrustInformation',  \
    LsaQueryInfoTrustedDomain, N, <NONE>,  'LsaQueryInfoTrustedDomain',  \
    LsaQueryInformationPolicy, N, <.PolicyHandle, .InformationClass, .buffer>,  'LsaQueryInformationPolicy',  \
    LsaQuerySecret, N, <NONE>,  'LsaQuerySecret',  \
    LsaQuerySecurityObject, N, <NONE>,  'LsaQuerySecurityObject',  \
    LsaQueryTrustedDomainInfo, N, <.PolicyHandle, .TrustedDomainSid, .InformationClass, .buffer>,  'LsaQueryTrustedDomainInfo',  \
    LsaQueryTrustedDomainInfoByName, N, <.PolicyHandle, .TrustedDomainName, .InformationClass, .buffer>,  'LsaQueryTrustedDomainInfoByName',  \
    LsaRemoveAccountRights, N, <.PolicyHandle, .AccountSid, .AllRights, .UserRights, .CountOfRights>,  'LsaRemoveAccountRights',  \
    LsaRemovePrivilegesFromAccount, N, <NONE>,  'LsaRemovePrivilegesFromAccount',  \
    LsaRetrievePrivateData, N, <.PolicyHandle, .KeyName, .PrivateData>,  'LsaRetrievePrivateData',  \
    LsaSetDomainInformationPolicy, N, <.PolicyHandle, .InformationClass, .buffer>,  'LsaSetDomainInformationPolicy',  \
    LsaSetForestTrustInformation, N, <NONE>,  'LsaSetForestTrustInformation',  \
    LsaSetInformationPolicy, N, <.PolicyHandle, .InformationClass, .buffer>,  'LsaSetInformationPolicy',  \
    LsaSetInformationTrustedDomain, N, <NONE>,  'LsaSetInformationTrustedDomain',  \
    LsaSetQuotasForAccount, N, <NONE>,  'LsaSetQuotasForAccount',  \
    LsaSetSecret, N, <NONE>,  'LsaSetSecret',  \
    LsaSetSecurityObject, N, <NONE>,  'LsaSetSecurityObject',  \
    LsaSetSystemAccessAccount, N, <NONE>,  'LsaSetSystemAccessAccount',  \
    LsaSetTrustedDomainInfoByName, N, <.PolicyHandle, .TrustedDomainName, .InformationClass, .buffer>,  'LsaSetTrustedDomainInfoByName',  \
    LsaSetTrustedDomainInformation, N, <.PolicyHandle, .TrustedDomainSid, .InformationClass, .buffer>,  'LsaSetTrustedDomainInformation',  \
    LsaStorePrivateData, N, <.PolicyHandle, .KeyName, .PrivateData>,  'LsaStorePrivateData',  \
    MD4Final, N, <NONE>,  'MD4Final',  \
    MD4Init, N, <NONE>,  'MD4Init',  \
    MD4Update, N, <NONE>,  'MD4Update',  \
    MD5Final, N, <NONE>,  'MD5Final',  \
    MD5Init, N, <NONE>,  'MD5Init',  \
    MD5Update, N, <NONE>,  'MD5Update',  \
    MSChapSrvChangePassword, N, <NONE>,  'MSChapSrvChangePassword',  \
    MSChapSrvChangePassword2, N, <NONE>,  'MSChapSrvChangePassword2',  \
    MakeAbsoluteSD, N, <.pSelfRelativeSecurityDescriptor, .pAbsoluteSecurityDescriptor, .lpdwAbsoluteSecurityDescriptorSize, .pDacl, .lpdwDaclSize,  \
        .pSacl, .lpdwSaclSize, .pOwner, .lpdwOwnerSize, .pPrimaryGroup, .lpdwPrimaryGroupSize>,  'MakeAbsoluteSD',  \
    MakeAbsoluteSD2, N, <.pSelfRelativeSecurityDescriptor, .lpdwBufferSize>,  'MakeAbsoluteSD2',  \
    MakeSelfRelativeSD, N, <.pAbsoluteSecurityDescriptor, .pSelfRelativeSecurityDescriptor, .lpdwBufferLength>,  'MakeSelfRelativeSD',  \
    MapGenericMask, N, <.AccessMask, .GenericMapping>,  'MapGenericMask',  \
    NotifyBootConfigStatus, N, <.BootAcceptable>,  'NotifyBootConfigStatus',  \
    NotifyChangeEventLog, N, <.hEventLog, .hEvent>,  'NotifyChangeEventLog',  \
    ObjectCloseAuditAlarm, A, <.SubsystemName, .HandleId, .GenerateOnClose>,  'ObjectCloseAuditAlarmA',  \
    ObjectCloseAuditAlarm, W, <.SubsystemName, .HandleId, .GenerateOnClose>,  'ObjectCloseAuditAlarmW',  \
    ObjectDeleteAuditAlarm, A, <.SubsystemName, .HandleId, .GenerateOnClose>,  'ObjectDeleteAuditAlarmA',  \
    ObjectDeleteAuditAlarm, W, <.SubsystemName, .HandleId, .GenerateOnClose>,  'ObjectDeleteAuditAlarmW',  \
    ObjectOpenAuditAlarm, A, <.SubsystemName, .HandleId, .ObjectTypeName, .ObjectName, .pSecurityDescriptor, .ClientToken, .DesiredAccess,  \
        .GrantedAccess, .Privileges, .ObjectCreation, .AccessGranted, .GenerateOnClose>,  'ObjectOpenAuditAlarmA',  \
    ObjectOpenAuditAlarm, W, <.SubsystemName, .HandleId, .ObjectTypeName, .ObjectName, .pSecurityDescriptor, .ClientToken, .DesiredAccess,  \
        .GrantedAccess, .Privileges, .ObjectCreation, .AccessGranted, .GenerateOnClose>,  'ObjectOpenAuditAlarmW',  \
    ObjectPrivilegeAuditAlarm, A, <.SubsystemName, .HandleId, .ClientToken, .DesiredAccess, .Privileges, .AccessGranted>,  'ObjectPrivilegeAuditAlarmA',  \
    ObjectPrivilegeAuditAlarm, W, <.SubsystemName, .HandleId, .ClientToken, .DesiredAccess, .Privileges, .AccessGranted>,  'ObjectPrivilegeAuditAlarmW',  \
    OpenBackupEventLog, A, <.lpUNCServerName, .lpFileName>,  'OpenBackupEventLogA',  \
    OpenBackupEventLog, W, <.lpUNCServerName, .lpFileName>,  'OpenBackupEventLogW',  \
    OpenEncryptedFileRaw, A, <.lpFileName, .ulFlags, .pvContext>,  'OpenEncryptedFileRawA',  \
    OpenEncryptedFileRaw, W, <.lpFileName, .ulFlags, .pvContext>,  'OpenEncryptedFileRawW',  \
    OpenEventLog, A, <.lpUNCServerName, .lpSourceName>,  'OpenEventLogA',  \
    OpenEventLog, W, <.lpUNCServerName, .lpSourceName>,  'OpenEventLogW',  \
    OpenProcessToken, N, <.ProcessHandle, .DesiredAccess, .TokenHandle>,  'OpenProcessToken',  \
    OpenSCManager, A, <.lpMachineName, .lpDatabaseName, .dwDesiredAccess>,  'OpenSCManagerA',  \
    OpenSCManager, W, <.lpMachineName, .lpDatabaseName, .dwDesiredAccess>,  'OpenSCManagerW',  \
    OpenService, A, <.hSCManager, .lpServiceName, .dwDesiredAccess>,  'OpenServiceA',  \
    OpenService, W, <.hSCManager, .lpServiceName, .dwDesiredAccess>,  'OpenServiceW',  \
    OpenThreadToken, N, <.ThreadHandle, .DesiredAccess, .OpenAsSelf, .TokenHandle>,  'OpenThreadToken',  \
    OpenTrace, A, <NONE>,  'OpenTraceA',  \
    OpenTrace, W, <NONE>,  'OpenTraceW',  \
    PrivilegeCheck, N, <.ClientToken, .RequiredPrivileges, .pfResult>,  'PrivilegeCheck',  \
    PrivilegedServiceAuditAlarm, A, <.SubsystemName, .ServiceName, .ClientToken, .Privileges, .AccessGranted>,  'PrivilegedServiceAuditAlarmA',  \
    PrivilegedServiceAuditAlarm, W, <.SubsystemName, .ServiceName, .ClientToken, .Privileges, .AccessGranted>,  'PrivilegedServiceAuditAlarmW',  \
    ProcessIdleTasks, N, <NONE>,  'ProcessIdleTasks',  \
    ProcessTrace, N, <NONE>,  'ProcessTrace',  \
    QueryAllTraces, A, <NONE>,  'QueryAllTracesA',  \
    QueryAllTraces, W, <NONE>,  'QueryAllTracesW',  \
    QueryRecoveryAgentsOnEncryptedFile, N, <.lpFileName, .pRecoveryAgents>,  'QueryRecoveryAgentsOnEncryptedFile',  \
    QueryServiceConfig2, A, <.hService, .dwInfoLevel, .lpBuffer, .cbBufSize, .pcbBytesNeeded>,  'QueryServiceConfig2A',  \
    QueryServiceConfig2, W, <.hService, .dwInfoLevel, .lpBuffer, .cbBufSize, .pcbBytesNeeded>,  'QueryServiceConfig2W',  \
    QueryServiceConfig, A, <.hService, .lpServiceConfig, .cbBufSize, .pcbBytesNeeded>,  'QueryServiceConfigA',  \
    QueryServiceConfig, W, <.hService, .lpServiceConfig, .cbBufSize, .pcbBytesNeeded>,  'QueryServiceConfigW',  \
    QueryServiceLockStatus, A, <.hSCManager, .lpLockStatus, .cbBufSize, .pcbBytesNeeded>,  'QueryServiceLockStatusA',  \
    QueryServiceLockStatus, W, <.hSCManager, .lpLockStatus, .cbBufSize, .pcbBytesNeeded>,  'QueryServiceLockStatusW',  \
    QueryServiceObjectSecurity, N, <.hService, .dwSecurityInformation, .lpSecurityDescriptor, .cbBufSize, .pcbBytesNeeded>,  'QueryServiceObjectSecurity',  \
    QueryServiceStatus, N, <.hService, .lpServiceStatus>,  'QueryServiceStatus',  \
    QueryServiceStatusEx, N, <.hService, .InfoLevel, .lpBuffer, .cbBufSize, .pcbBytesNeeded>,  'QueryServiceStatusEx',  \
    QueryTrace, A, <NONE>,  'QueryTraceA',  \
    QueryTrace, W, <NONE>,  'QueryTraceW',  \
    QueryUsersOnEncryptedFile, N, <.lpFileName, .pUsers>,  'QueryUsersOnEncryptedFile',  \
    QueryWindows31FilesMigration, N, <NONE>,  'QueryWindows31FilesMigration',  \
    ReadEncryptedFileRaw, N, <.pfExportCallback, .pvCallbackContext, .pvContext>,  'ReadEncryptedFileRaw',  \
    ReadEventLog, A, <.hEventLog, .dwReadFlags, .dwRecordOffset, .lpBuffer, .nNumberOfBytesToRead, .pnBytesRead, .pnMinNumberOfBytesNeeded,  \
      >,  'ReadEventLogA',  \
    ReadEventLog, W, <.hEventLog, .dwReadFlags, .dwRecordOffset, .lpBuffer, .nNumberOfBytesToRead, .pnBytesRead, .pnMinNumberOfBytesNeeded,  \
      >,  'ReadEventLogW',  \
    RegCloseKey, N, <.hKey>,  'RegCloseKey',  \
    RegConnectRegistry, A, <.lpMachineName, .hKey, .phkResult>,  'RegConnectRegistryA',  \
    RegConnectRegistry, W, <.lpMachineName, .hKey, .phkResult>,  'RegConnectRegistryW',  \
    RegCreateKey, A, <.hKey, .lpSubKey, .phkResult>,  'RegCreateKeyA',  \
    RegCreateKeyEx, A, <.hKey, .lpSubKey, .Reserved, .lpClass, .dwOptions, .samDesired, .lpSecurityAttributes, .phkResult, .lpdwDisposition,  \
      >,  'RegCreateKeyExA',  \
    RegCreateKeyEx, W, <.hKey, .lpSubKey, .Reserved, .lpClass, .dwOptions, .samDesired, .lpSecurityAttributes, .phkResult, .lpdwDisposition,  \
      >,  'RegCreateKeyExW',  \
    RegCreateKey, W, <.hKey, .lpSubKey, .phkResult>,  'RegCreateKeyW',  \
    RegDeleteKey, A, <.hKey, .lpSubKey>,  'RegDeleteKeyA',  \
    RegDeleteKey, W, <.hKey, .lpSubKey>,  'RegDeleteKeyW',  \
    RegDeleteValue, A, <.hKey, .lpValueName>,  'RegDeleteValueA',  \
    RegDeleteValue, W, <.hKey, .lpValueName>,  'RegDeleteValueW',  \
    RegDisablePredefinedCache, N, <VOID>,  'RegDisablePredefinedCache',  \
    RegDisablePredefinedCacheEx, N, <NONE>,  'RegDisablePredefinedCacheEx',  \
    RegEnumKey, A, <.hKey, .dwIndex, .lpName, .cbName>,  'RegEnumKeyA',  \
    RegEnumKeyEx, A, <.hKey, .dwIndex, .lpName, .lpcbName, .lpReserved, .lpClass, .lpcbClass, .lpftLastWriteTime>,  'RegEnumKeyExA',  \
    RegEnumKeyEx, W, <.hKey, .dwIndex, .lpName, .lpcbName, .lpReserved, .lpClass, .lpcbClass, .lpftLastWriteTime>,  'RegEnumKeyExW',  \
    RegEnumKey, W, <.hKey, .dwIndex, .lpName, .cbName>,  'RegEnumKeyW',  \
    RegEnumValue, A, <.hKey, .dwIndex, .lpValueName, .lpcbValueName, .lpReserved, .lpType, .lpData, .lpcbData>,  'RegEnumValueA',  \
    RegEnumValue, W, <.hKey, .dwIndex, .lpValueName, .lpcbValueName, .lpReserved, .lpType, .lpData, .lpcbData>,  'RegEnumValueW',  \
    RegFlushKey, N, <.hKey>,  'RegFlushKey',  \
    RegGetKeySecurity, N, <.hKey, .SecurityInformation, .pSecurityDescriptor, .lpcbSecurityDescriptor>,  'RegGetKeySecurity',  \
    RegLoadKey, A, <.hKey, .lpSubKey, .lpFile>,  'RegLoadKeyA',  \
    RegLoadKey, W, <.hKey, .lpSubKey, .lpFile>,  'RegLoadKeyW',  \
    RegNotifyChangeKeyValue, N, <.hKey, .bWatchSubtree, .dwNotifyFilter, .hEvent, .fAsynchronus>,  'RegNotifyChangeKeyValue',  \
    RegOpenCurrentUser, N, <.samDesired, .phkResult>,  'RegOpenCurrentUser',  \
    RegOpenKey, A, <.hKey, .lpSubKey, .phkResult>,  'RegOpenKeyA',  \
    RegOpenKeyEx, A, <.hKey, .lpSubKey, .ulOptions, .samDesired, .phkResult>,  'RegOpenKeyExA',  \
    RegOpenKeyEx, W, <.hKey, .lpSubKey, .ulOptions, .samDesired, .phkResult>,  'RegOpenKeyExW',  \
    RegOpenKey, W, <.hKey, .lpSubKey, .phkResult>,  'RegOpenKeyW',  \
    RegOpenUserClassesRoot, N, <.hToken, .dwOptions, .samDesired, .phkResult>,  'RegOpenUserClassesRoot',  \
    RegOverridePredefKey, N, <.hKey, .hNewHKey>,  'RegOverridePredefKey',  \
    RegQueryInfoKey, A, <.hKey, .lpClass, .lpcbClass, .lpReserved, .lpcSubKeys, .lpcbMaxSubKeyLen, .lpcbMaxClassLen, .lpcValues, .lpcbMaxValueNameLen,  \
        .lpcbMaxValueLen, .lpcbSecurityDescriptor, .lpftLastWriteTime>,  'RegQueryInfoKeyA',  \
    RegQueryInfoKey, W, <.hKey, .lpClass, .lpcbClass, .lpReserved, .lpcSubKeys, .lpcbMaxSubKeyLen, .lpcbMaxClassLen, .lpcValues, .lpcbMaxValueNameLen,  \
        .lpcbMaxValueLen, .lpcbSecurityDescriptor, .lpftLastWriteTime>,  'RegQueryInfoKeyW',  \
    RegQueryMultipleValues, A, <.hKey, .val_list, .num_vals, .lpValueBuf, .ldwTotsize>,  'RegQueryMultipleValuesA',  \
    RegQueryMultipleValues, W, <.hKey, .val_list, .num_vals, .lpValueBuf, .ldwTotsize>,  'RegQueryMultipleValuesW',  \
    RegQueryValue, A, <.hKey, .lpSubKey, .lpValue, .lpcbValue>,  'RegQueryValueA',  \
    RegQueryValueEx, A, <.hKey, .lpValueName, .lpReserved, .lpType, .lpData, .lpcbData>,  'RegQueryValueExA',  \
    RegQueryValueEx, W, <.hKey, .lpValueName, .lpReserved, .lpType, .lpData, .lpcbData>,  'RegQueryValueExW',  \
    RegQueryValue, W, <.hKey, .lpSubKey, .lpValue, .lpcbValue>,  'RegQueryValueW',  \
    RegReplaceKey, A, <.hKey, .lpSubKey, .lpNewFile, .lpOldFile>,  'RegReplaceKeyA',  \
    RegReplaceKey, W, <.hKey, .lpSubKey, .lpNewFile, .lpOldFile>,  'RegReplaceKeyW',  \
    RegRestoreKey, A, <.hKey, .lpFile, .dwFlags>,  'RegRestoreKeyA',  \
    RegRestoreKey, W, <.hKey, .lpFile, .dwFlags>,  'RegRestoreKeyW',  \
    RegSaveKey, A, <.hKey, .lpFile, .lpSecurityAttributes>,  'RegSaveKeyA',  \
    RegSaveKeyEx, A, <NONE>,  'RegSaveKeyExA',  \
    RegSaveKeyEx, W, <NONE>,  'RegSaveKeyExW',  \
    RegSaveKey, W, <.hKey, .lpFile, .lpSecurityAttributes>,  'RegSaveKeyW',  \
    RegSetKeySecurity, N, <.hKey, .SecurityInformation, .pSecurityDescriptor>,  'RegSetKeySecurity',  \
    RegSetValue, A, <.hKey, .lpSubKey, .dwType, .lpData, .cbData>,  'RegSetValueA',  \
    RegSetValueEx, A, <.hKey, .lpValueName, .Reserved, .dwType, .lpData, .cbData>,  'RegSetValueExA',  \
    RegSetValueEx, W, <.hKey, .lpValueName, .Reserved, .dwType, .lpData, .cbData>,  'RegSetValueExW',  \
    RegSetValue, W, <.hKey, .lpSubKey, .dwType, .lpData, .cbData>,  'RegSetValueW',  \
    RegUnLoadKey, A, <.hKey, .lpSubKey>,  'RegUnLoadKeyA',  \
    RegUnLoadKey, W, <.hKey, .lpSubKey>,  'RegUnLoadKeyW',  \
    RegisterEventSource, A, <.lpUNCServerName, .lpSourceName>,  'RegisterEventSourceA',  \
    RegisterEventSource, W, <.lpUNCServerName, .lpSourceName>,  'RegisterEventSourceW',  \
    RegisterIdleTask, N, <NONE>,  'RegisterIdleTask',  \
    RegisterServiceCtrlHandler, A, <.lpServiceName, .lpHandlerProc>,  'RegisterServiceCtrlHandlerA',  \
    RegisterServiceCtrlHandlerEx, A, <.lpServiceName, .lpHandlerProc, .lpContext>,  'RegisterServiceCtrlHandlerExA',  \
    RegisterServiceCtrlHandlerEx, W, <.lpServiceName, .lpHandlerProc, .lpContext>,  'RegisterServiceCtrlHandlerExW',  \
    RegisterServiceCtrlHandler, W, <.lpServiceName, .lpHandlerProc>,  'RegisterServiceCtrlHandlerW',  \
    RegisterTraceGuids, A, <NONE>,  'RegisterTraceGuidsA',  \
    RegisterTraceGuids, W, <NONE>,  'RegisterTraceGuidsW',  \
    RemoveTraceCallback, N, <NONE>,  'RemoveTraceCallback',  \
    RemoveUsersFromEncryptedFile, N, <.lpFileName, .pHashes>,  'RemoveUsersFromEncryptedFile',  \
    ReportEvent, A, <.hEventLog, .wType, .wCategory, .dwEventID, .lpUserSid, .wNumStrings, .dwDataSize, .lpStrings, .lpRawData>,  'ReportEventA',  \
    ReportEvent, W, <.hEventLog, .wType, .wCategory, .dwEventID, .lpUserSid, .wNumStrings, .dwDataSize, .lpStrings, .lpRawData>,  'ReportEventW',  \
    RevertToSelf, N, <VOID>,  'RevertToSelf',  \
    SaferCloseLevel, N, <NONE>,  'SaferCloseLevel',  \
    SaferComputeTokenFromLevel, N, <NONE>,  'SaferComputeTokenFromLevel',  \
    SaferCreateLevel, N, <NONE>,  'SaferCreateLevel',  \
    SaferGetLevelInformation, N, <NONE>,  'SaferGetLevelInformation',  \
    SaferGetPolicyInformation, N, <NONE>,  'SaferGetPolicyInformation',  \
    SaferIdentifyLevel, N, <NONE>,  'SaferIdentifyLevel',  \
    SaferRecordEventLogEntry, N, <NONE>,  'SaferRecordEventLogEntry',  \
    SaferSetLevelInformation, N, <NONE>,  'SaferSetLevelInformation',  \
    SaferSetPolicyInformation, N, <NONE>,  'SaferSetPolicyInformation',  \
    SaferiChangeRegistryScope, N, <NONE>,  'SaferiChangeRegistryScope',  \
    SaferiCompareTokenLevels, N, <NONE>,  'SaferiCompareTokenLevels',  \
    SaferiIsExecutableFileType, N, <NONE>,  'SaferiIsExecutableFileType',  \
    SaferiPopulateDefaultsInRegistry, N, <NONE>,  'SaferiPopulateDefaultsInRegistry',  \
    SaferiRecordEventLogEntry, N, <NONE>,  'SaferiRecordEventLogEntry',  \
    SaferiReplaceProcessThreadTokens, N, <NONE>,  'SaferiReplaceProcessThreadTokens',  \
    SaferiSearchMatchingHashRules, N, <NONE>,  'SaferiSearchMatchingHashRules',  \
    SetAclInformation, N, <.pAcl, .pAclInformation, .nAclInformationLength, .dwAclInformationClass>,  'SetAclInformation',  \
    SetEntriesInAccessList, A, <NONE>,  'SetEntriesInAccessListA',  \
    SetEntriesInAccessList, W, <NONE>,  'SetEntriesInAccessListW',  \
    SetEntriesInAcl, A, <.cCountOfExplicitEntries, .pListOfExplicitEntries, .OldAcl, .NewAcl>,  'SetEntriesInAclA',  \
    SetEntriesInAcl, W, <.cCountOfExplicitEntries, .pListOfExplicitEntries, .OldAcl, .NewAcl>,  'SetEntriesInAclW',  \
    SetEntriesInAuditList, A, <NONE>,  'SetEntriesInAuditListA',  \
    SetEntriesInAuditList, W, <NONE>,  'SetEntriesInAuditListW',  \
    SetFileSecurity, A, <.lpFileName, .SecurityInformation, .pSecurityDescriptor>,  'SetFileSecurityA',  \
    SetFileSecurity, W, <.lpFileName, .SecurityInformation, .pSecurityDescriptor>,  'SetFileSecurityW',  \
    SetInformationCodeAuthzLevel, W, <NONE>,  'SetInformationCodeAuthzLevelW',  \
    SetInformationCodeAuthzPolicy, W, <NONE>,  'SetInformationCodeAuthzPolicyW',  \
    SetKernelObjectSecurity, N, <.Handle, .SecurityInformation, .SecurityDescriptor>,  'SetKernelObjectSecurity',  \
    SetNamedSecurityInfo, A, <.pObjectName, .ObjectType, .SecurityInfo, .psidOwner, .psidGroup, .pDacl, .pSacl>,  'SetNamedSecurityInfoA',  \
    SetNamedSecurityInfoEx, A, <NONE>,  'SetNamedSecurityInfoExA',  \
    SetNamedSecurityInfoEx, W, <NONE>,  'SetNamedSecurityInfoExW',  \
    SetNamedSecurityInfo, W, <.pObjectName, .ObjectType, .SecurityInfo, .psidOwner, .psidGroup, .pDacl, .pSacl>,  'SetNamedSecurityInfoW',  \
    SetPrivateObjectSecurity, N, <.SecurityInformation, .ModificationDescriptor, .ObjectsSecurityDescriptor, .GenericMapping, .Token,  \
      >,  'SetPrivateObjectSecurity',  \
    SetPrivateObjectSecurityEx, N, <.SecurityInformation, .ModificationDescriptor, .ObjectsSecurityDescriptor, .AutoInheritFlags, .GenericMapping,  \
        .Token>,  'SetPrivateObjectSecurityEx',  \
    SetSecurityDescriptorControl, N, <.pSecurityDescriptor, .ControlBitsOfInterest, .ControlBitsToSet>,  'SetSecurityDescriptorControl',  \
    SetSecurityDescriptorDacl, N, <.pSecurityDescriptor, .bDaclPresent, .pDacl, .bDaclDefaulted>,  'SetSecurityDescriptorDacl',  \
    SetSecurityDescriptorGroup, N, <.pSecurityDescriptor, .pGroup, .bGroupDefaulted>,  'SetSecurityDescriptorGroup',  \
    SetSecurityDescriptorOwner, N, <.pSecurityDescriptor, .pOwner, .bOwnerDefaulted>,  'SetSecurityDescriptorOwner',  \
    SetSecurityDescriptorRMControl, N, <.SecurityDescriptor, .RMControl>,  'SetSecurityDescriptorRMControl',  \
    SetSecurityDescriptorSacl, N, <.pSecurityDescriptor, .bSaclPresent, .pSacl, .bSaclDefaulted>,  'SetSecurityDescriptorSacl',  \
    SetSecurityInfo, N, <.handle, .ObjectType, .SecurityInfo, .psidOwner, .psidGroup, .pDacl, .pSacl>,  'SetSecurityInfo',  \
    SetSecurityInfoEx, A, <NONE>,  'SetSecurityInfoExA',  \
    SetSecurityInfoEx, W, <NONE>,  'SetSecurityInfoExW',  \
    SetServiceBits, N, <.hServiceStatus, .dwServiceBits, .bSetBitsOn, .bUpdateImmediately>,  'SetServiceBits',  \
    SetServiceObjectSecurity, N, <.hService, .dwSecurityInformation, .lpSecurityDescriptor>,  'SetServiceObjectSecurity',  \
    SetServiceStatus, N, <.hServiceStatus, .lpServiceStatus>,  'SetServiceStatus',  \
    SetThreadToken, N, <.Thread, .Token>,  'SetThreadToken',  \
    SetTokenInformation, N, <.TokenHandle, .TokenInformationClass, .TokenInformation, .TokenInformationLength>,  'SetTokenInformation',  \
    SetTraceCallback, N, <NONE>,  'SetTraceCallback',  \
    SetUserFileEncryptionKey, N, <.pEncryptionCertificate>,  'SetUserFileEncryptionKey',  \
    StartService, A, <.hService, .dwNumServiceArgs, .lpServiceArgVectors>,  'StartServiceA',  \
    StartServiceCtrlDispatcher, A, <.lpServiceStartTable>,  'StartServiceCtrlDispatcherA',  \
    StartServiceCtrlDispatcher, W, <.lpServiceStartTable>,  'StartServiceCtrlDispatcherW',  \
    StartService, W, <.hService, .dwNumServiceArgs, .lpServiceArgVectors>,  'StartServiceW',  \
    StartTrace, A, <NONE>,  'StartTraceA',  \
    StartTrace, W, <NONE>,  'StartTraceW',  \
    StopTrace, A, <NONE>,  'StopTraceA',  \
    StopTrace, W, <NONE>,  'StopTraceW',  \
    SynchronizeWindows31FilesAndWindowsNTRegistry, N, <NONE>,  'SynchronizeWindows31FilesAndWindowsNTRegistry',  \
    SystemFunction001, N, <NONE>,  'SystemFunction001',  \
    SystemFunction002, N, <NONE>,  'SystemFunction002',  \
    SystemFunction003, N, <NONE>,  'SystemFunction003',  \
    SystemFunction004, N, <NONE>,  'SystemFunction004',  \
    SystemFunction005, N, <NONE>,  'SystemFunction005',  \
    SystemFunction006, N, <NONE>,  'SystemFunction006',  \
    SystemFunction007, N, <NONE>,  'SystemFunction007',  \
    SystemFunction008, N, <NONE>,  'SystemFunction008',  \
    SystemFunction009, N, <NONE>,  'SystemFunction009',  \
    SystemFunction010, N, <NONE>,  'SystemFunction010',  \
    SystemFunction011, N, <NONE>,  'SystemFunction011',  \
    SystemFunction012, N, <NONE>,  'SystemFunction012',  \
    SystemFunction013, N, <NONE>,  'SystemFunction013',  \
    SystemFunction014, N, <NONE>,  'SystemFunction014',  \
    SystemFunction015, N, <NONE>,  'SystemFunction015',  \
    SystemFunction016, N, <NONE>,  'SystemFunction016',  \
    SystemFunction017, N, <NONE>,  'SystemFunction017',  \
    SystemFunction018, N, <NONE>,  'SystemFunction018',  \
    SystemFunction019, N, <NONE>,  'SystemFunction019',  \
    SystemFunction020, N, <NONE>,  'SystemFunction020',  \
    SystemFunction021, N, <NONE>,  'SystemFunction021',  \
    SystemFunction022, N, <NONE>,  'SystemFunction022',  \
    SystemFunction023, N, <NONE>,  'SystemFunction023',  \
    SystemFunction024, N, <NONE>,  'SystemFunction024',  \
    SystemFunction025, N, <NONE>,  'SystemFunction025',  \
    SystemFunction026, N, <NONE>,  'SystemFunction026',  \
    SystemFunction027, N, <NONE>,  'SystemFunction027',  \
    SystemFunction028, N, <NONE>,  'SystemFunction028',  \
    SystemFunction029, N, <NONE>,  'SystemFunction029',  \
    SystemFunction030, N, <NONE>,  'SystemFunction030',  \
    SystemFunction031, N, <NONE>,  'SystemFunction031',  \
    SystemFunction032, N, <NONE>,  'SystemFunction032',  \
    SystemFunction033, N, <NONE>,  'SystemFunction033',  \
    SystemFunction034, N, <NONE>,  'SystemFunction034',  \
    SystemFunction035, N, <NONE>,  'SystemFunction035',  \
    SystemFunction036, N, <NONE>,  'SystemFunction036',  \
    SystemFunction040, N, <NONE>,  'SystemFunction040',  \
    SystemFunction041, N, <NONE>,  'SystemFunction041',  \
    TraceEvent, N, <NONE>,  'TraceEvent',  \
    TraceEventInstance, N, <NONE>,  'TraceEventInstance',  \
    TraceMessage, N, <NONE>,  'TraceMessage',  \
    TraceMessageVa, N, <NONE>,  'TraceMessageVa',  \
    TreeResetNamedSecurityInfo, A, <.pObjectName, .ObjectType, .SecurityInfo, .pOwner, .pGroup, .pDacl, .pSacl, .KeepExplicit, .fnProgress,  \
        .ProgressInvokeSetting, .Args>,  'TreeResetNamedSecurityInfoA',  \
    TreeResetNamedSecurityInfo, W, <.pObjectName, .ObjectType, .SecurityInfo, .pOwner, .pGroup, .pDacl, .pSacl, .KeepExplicit, .fnProgress,  \
        .ProgressInvokeSetting, .Args>,  'TreeResetNamedSecurityInfoW',  \
    TrusteeAccessToObject, A, <NONE>,  'TrusteeAccessToObjectA',  \
    TrusteeAccessToObject, W, <NONE>,  'TrusteeAccessToObjectW',  \
    UninstallApplication, N, <NONE>,  'UninstallApplication',  \
    UnlockServiceDatabase, N, <.ScLock>,  'UnlockServiceDatabase',  \
    UnregisterIdleTask, N, <NONE>,  'UnregisterIdleTask',  \
    UnregisterTraceGuids, N, <NONE>,  'UnregisterTraceGuids',  \
    UpdateTrace, A, <NONE>,  'UpdateTraceA',  \
    UpdateTrace, W, <NONE>,  'UpdateTraceW',  \
    WdmWmiServiceMain, N, <NONE>,  'WdmWmiServiceMain',  \
    WmiCloseBlock, N, <NONE>,  'WmiCloseBlock',  \
    WmiCloseTraceWithCursor, N, <NONE>,  'WmiCloseTraceWithCursor',  \
    WmiConvertTimestamp, N, <NONE>,  'WmiConvertTimestamp',  \
    WmiDevInstToInstanceName, A, <NONE>,  'WmiDevInstToInstanceNameA',  \
    WmiDevInstToInstanceName, W, <NONE>,  'WmiDevInstToInstanceNameW',  \
    WmiEnumerateGuids, N, <NONE>,  'WmiEnumerateGuids',  \
    WmiExecuteMethod, A, <NONE>,  'WmiExecuteMethodA',  \
    WmiExecuteMethod, W, <NONE>,  'WmiExecuteMethodW',  \
    WmiFileHandleToInstanceName, A, <NONE>,  'WmiFileHandleToInstanceNameA',  \
    WmiFileHandleToInstanceName, W, <NONE>,  'WmiFileHandleToInstanceNameW',  \
    WmiFreeBuffer, N, <NONE>,  'WmiFreeBuffer',  \
    WmiGetFirstTraceOffset, N, <NONE>,  'WmiGetFirstTraceOffset',  \
    WmiGetNextEvent, N, <NONE>,  'WmiGetNextEvent',  \
    WmiGetTraceHeader, N, <NONE>,  'WmiGetTraceHeader',  \
    WmiMofEnumerateResources, A, <NONE>,  'WmiMofEnumerateResourcesA',  \
    WmiMofEnumerateResources, W, <NONE>,  'WmiMofEnumerateResourcesW',  \
    WmiNotificationRegistration, A, <NONE>,  'WmiNotificationRegistrationA',  \
    WmiNotificationRegistration, W, <NONE>,  'WmiNotificationRegistrationW',  \
    WmiOpenBlock, N, <NONE>,  'WmiOpenBlock',  \
    WmiOpenTraceWithCursor, N, <NONE>,  'WmiOpenTraceWithCursor',  \
    WmiParseTraceEvent, N, <NONE>,  'WmiParseTraceEvent',  \
    WmiQueryAllData, A, <NONE>,  'WmiQueryAllDataA',  \
    WmiQueryAllDataMultiple, A, <NONE>,  'WmiQueryAllDataMultipleA',  \
    WmiQueryAllDataMultiple, W, <NONE>,  'WmiQueryAllDataMultipleW',  \
    WmiQueryAllData, W, <NONE>,  'WmiQueryAllDataW',  \
    WmiQueryGuidInformation, N, <NONE>,  'WmiQueryGuidInformation',  \
    WmiQuerySingleInstance, A, <NONE>,  'WmiQuerySingleInstanceA',  \
    WmiQuerySingleInstanceMultiple, A, <NONE>,  'WmiQuerySingleInstanceMultipleA',  \
    WmiQuerySingleInstanceMultiple, W, <NONE>,  'WmiQuerySingleInstanceMultipleW',  \
    WmiQuerySingleInstance, W, <NONE>,  'WmiQuerySingleInstanceW',  \
    WmiReceiveNotifications, A, <NONE>,  'WmiReceiveNotificationsA',  \
    WmiReceiveNotifications, W, <NONE>,  'WmiReceiveNotificationsW',  \
    WmiSetSingleInstance, A, <NONE>,  'WmiSetSingleInstanceA',  \
    WmiSetSingleInstance, W, <NONE>,  'WmiSetSingleInstanceW',  \
    WmiSetSingleItem, A, <NONE>,  'WmiSetSingleItemA',  \
    WmiSetSingleItem, W, <NONE>,  'WmiSetSingleItemW',  \
    Wow64Win32ApiEntry, N, <NONE>,  'Wow64Win32ApiEntry',  \
    WriteEncryptedFileRaw, N, <.pfImportCallback, .pvCallbackContext, .pvContext>,  'WriteEncryptedFileRaw'
