; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "Fresh artistic license."         |
;|_______________________________________________________________________________________|
;
;  Description: comctl32.dll API calls
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


import_proto comctl32,  \
    AddMRUString, W, <NONE>,  'AddMRUStringW',  \
    CreateMRUList, W, <NONE>,  'CreateMRUListW',  \
    CreateMappedBitmap, N, <.hInstance, .idBitmap, .wFlags, .lpColorMap, .ByValumMaps>,  'CreateMappedBitmap',  \
    CreatePropertySheetPage, A, <.lpcpropsheetpagea>,  'CreatePropertySheetPageA',  \
    CreatePropertySheetPage, W, <.lpcpropsheetpagea>,  'CreatePropertySheetPageW',  \
    CreateStatusWindow, A, <.dwStyle, .lpszText, .hWndParent, .wID>,  'CreateStatusWindowA',  \
    CreateStatusWindow, W, <.dwStyle, .lpszText, .hWndParent, .wID>,  'CreateStatusWindowW',  \
    CreateToolbar, N, <NONE>,  'CreateToolbar',  \
    CreateToolbarEx, N, <.hWndParent, .dwStyle, .wID, .nBitmaps, .hBMInst, .wBMID, .lpButtons, .iNumButtons, .dxButton, .dyButton, .dxBitmap, .dyBitmap, .uStructSize>,  'CreateToolbarEx',  \
    CreateUpDownControl, N, <.dwStyle, .x, .y, .cx, .cy, .hParent, .nID, .hInst, .hBuddy, .nUpper, .nLower, .nPos>,  'CreateUpDownControl',  \
    DPA_Create, N, <NONE>,  'DPA_Create',  \
    DPA_DeleteAllPtrs, N, <NONE>,  'DPA_DeleteAllPtrs',  \
    DPA_DeletePtr, N, <NONE>,  'DPA_DeletePtr',  \
    DPA_Destroy, N, <NONE>,  'DPA_Destroy',  \
    DPA_DestroyCallback, N, <NONE>,  'DPA_DestroyCallback',  \
    DPA_EnumCallback, N, <NONE>,  'DPA_EnumCallback',  \
    DPA_GetPtr, N, <NONE>,  'DPA_GetPtr',  \
    DPA_InsertPtr, N, <NONE>,  'DPA_InsertPtr',  \
    DPA_Search, N, <NONE>,  'DPA_Search',  \
    DPA_SetPtr, N, <NONE>,  'DPA_SetPtr',  \
    DPA_Sort, N, <NONE>,  'DPA_Sort',  \
    DSA_Create, N, <NONE>,  'DSA_Create',  \
    DSA_DeleteAllItems, N, <NONE>,  'DSA_DeleteAllItems',  \
    DSA_Destroy, N, <NONE>,  'DSA_Destroy',  \
    DSA_DestroyCallback, N, <NONE>,  'DSA_DestroyCallback',  \
    DSA_GetItemPtr, N, <NONE>,  'DSA_GetItemPtr',  \
    DSA_InsertItem, N, <NONE>,  'DSA_InsertItem',  \
    DefSubclassProc, N, <NONE>,  'DefSubclassProc',  \
    DestroyPropertySheetPage, N, <.hpropsheetpage>,  'DestroyPropertySheetPage',  \
    DllGetVersion, N, <NONE>,  'DllGetVersion',  \
    DllInstall, N, <.bInstall, .pszCmdLine>,  'DllInstall',  \
    DrawInsert, N, <.handParent, .hLB, .nItem>,  'DrawInsert',  \
    DrawStatusText, A, <.hDC, .lprc, .pszText, .uFlags>,  'DrawStatusTextA',  \
    DrawStatusText, W, <.hDC, .lprc, .pszText, .uFlags>,  'DrawStatusTextW',  \
    EnumMRUList, W, <NONE>,  'EnumMRUListW',  \
    FlatSB_EnableScrollBar, N, <.hwnd, .ByValt, .uint>,  'FlatSB_EnableScrollBar',  \
    FlatSB_GetScrollInfo, N, <.hwnd, .code, .lpscrollinfo>,  'FlatSB_GetScrollInfo',  \
    FlatSB_GetScrollPos, N, <.hwnd, .code>,  'FlatSB_GetScrollPos',  \
    FlatSB_GetScrollProp, N, <.hwnd, .propIndex, .lpint>,  'FlatSB_GetScrollProp',  \
    FlatSB_GetScrollRange, N, <.hwnd, .code, .lpint>,  'FlatSB_GetScrollRange',  \
    FlatSB_SetScrollInfo, N, <.hwnd, .code, .lpscrollinfo, .fRedraw>,  'FlatSB_SetScrollInfo',  \
    FlatSB_SetScrollPos, N, <.hwnd, .code, .pos, .fRedraw>,  'FlatSB_SetScrollPos',  \
    FlatSB_SetScrollProp, N, <.hwnd, .index, .newValue, .bool>,  'FlatSB_SetScrollProp',  \
    FlatSB_SetScrollRange, N, <.hwnd, .code, .min, .max, .fRedraw>,  'FlatSB_SetScrollRange',  \
    FlatSB_ShowScrollBar, N, <.hwnd, .code, .bool>,  'FlatSB_ShowScrollBar',  \
    FreeMRUList, N, <NONE>,  'FreeMRUList',  \
    GetEffectiveClientRect, N, <.hWnd, .lprc, .lpInfo>,  'GetEffectiveClientRect',  \
    GetMUILanguage, N, <VOID>,  'GetMUILanguage',  \
    ImageList_Add, N, <.himl, .hbmImage, .hbmMask>,  'ImageList_Add',  \
    ImageList_AddIcon, N, <NONE>,  'ImageList_AddIcon',  \
    ImageList_AddMasked, N, <.himl, .hbmImage, .crMask>,  'ImageList_AddMasked',  \
    ImageList_BeginDrag, N, <.himlTrack, .iTrack, .dxHotspot, .dyHotspot>,  'ImageList_BeginDrag',  \
    ImageList_Copy, N, <.himlDst, .iDst, .himlSrc, .iSrc, .uFlags>,  'ImageList_Copy',  \
    ImageList_Create, N, <.cx, .cy, .flags, .cInitial, .cGrow>,  'ImageList_Create',  \
    ImageList_Destroy, N, <.himl>,  'ImageList_Destroy',  \
    ImageList_DragEnter, N, <.hwndLock, .x, .y>,  'ImageList_DragEnter',  \
    ImageList_DragLeave, N, <.hWndOwner>,  'ImageList_DragLeave',  \
    ImageList_DragMove, N, <.x, .y>,  'ImageList_DragMove',  \
    ImageList_DragShowNolock, N, <.fBoolean>,  'ImageList_DragShowNolock',  \
    ImageList_Draw, N, <.himl, .i, .hdcDst, .x, .y, .fStyle>,  'ImageList_Draw',  \
    ImageList_DrawEx, N, <.himl, .i, .hdcDst, .x, .y, .dx, .dy, .rgbBk, .rgbFg, .fStyle>,  'ImageList_DrawEx',  \
    ImageList_DrawIndirect, N, <.pimldp>,  'ImageList_DrawIndirect',  \
    ImageList_Duplicate, N, <.himl>,  'ImageList_Duplicate',  \
    ImageList_EndDrag, N, <VOID>,  'ImageList_EndDrag',  \
    ImageList_GetBkColor, N, <.himl>,  'ImageList_GetBkColor',  \
    ImageList_GetDragImage, N, <.ppt, .pptHotspot>,  'ImageList_GetDragImage',  \
    ImageList_GetFlags, N, <NONE>,  'ImageList_GetFlags',  \
    ImageList_GetIcon, N, <.himl, .i, .flags>,  'ImageList_GetIcon',  \
    ImageList_GetIconSize, N, <.himl, .cx, .cy>,  'ImageList_GetIconSize',  \
    ImageList_GetImageCount, N, <.himl>,  'ImageList_GetImageCount',  \
    ImageList_GetImageInfo, N, <.himl, .i, .pImageInfo>,  'ImageList_GetImageInfo',  \
    ImageList_GetImageRect, N, <NONE>,  'ImageList_GetImageRect',  \
    ImageList_LoadImage, A, <.hInst, .lpszbmp, .cx, .cGrow, .crMask, .uType, .uFlags>,  'ImageList_LoadImageA',  \
    ImageList_LoadImage, W, <.hInst, .lpszbmp, .cx, .cGrow, .crMask, .uType, .uFlags>,  'ImageList_LoadImageW',  \
    ImageList_Merge, N, <.himl1, .i1, .himl2, .i2, .dx, .dy>,  'ImageList_Merge',  \
    ImageList_Read, N, <.pstm>,  'ImageList_Read',  \
    ImageList_Remove, N, <.himl, .i>,  'ImageList_Remove',  \
    ImageList_Replace, N, <.himl, .i, .hbmImage, .hbmMask>,  'ImageList_Replace',  \
    ImageList_ReplaceIcon, N, <.himl, .i, .hicon>,  'ImageList_ReplaceIcon',  \
    ImageList_SetBkColor, N, <.himl, .clrBk>,  'ImageList_SetBkColor',  \
    ImageList_SetDragCursorImage, N, <.himlDrag, .iDrag, .dxHotspot, .dyHotspot>,  'ImageList_SetDragCursorImage',  \
    ImageList_SetFilter, N, <NONE>,  'ImageList_SetFilter',  \
    ImageList_SetFlags, N, <NONE>,  'ImageList_SetFlags',  \
    ImageList_SetIconSize, N, <.himl, .cx, .cy>,  'ImageList_SetIconSize',  \
    ImageList_SetImageCount, N, <.himl, .uNewCount>,  'ImageList_SetImageCount',  \
    ImageList_SetOverlayImage, N, <.himl, .iImage, .iOverlay>,  'ImageList_SetOverlayImage',  \
    ImageList_Write, N, <.himl, .pstm>,  'ImageList_Write',  \
    InitCommonControls, N, <VOID>,  'InitCommonControls',  \
    InitCommonControlsEx, N, <.pIcce>,  'InitCommonControlsEx',  \
    InitMUILanguage, N, <.uiLang>,  'InitMUILanguage',  \
    InitializeFlatSB, N, <.hwnd>,  'InitializeFlatSB',  \
    LBItemFromPt, N, <.hLB, .pt, .bAutoScroll>,  'LBItemFromPt',  \
    MakeDragList, N, <.hLB>,  'MakeDragList',  \
    MenuHelp, N, <.uMsg, .wParam, .lParam, .hMainMenu, .hInst, .hwndStatus, .lpwIDs>,  'MenuHelp',  \
    PropertySheet, A, <.lpcpropsheetheadera>,  'PropertySheetA',  \
    PropertySheet, W, <.lpcpropsheetheadera>,  'PropertySheetW',  \
    RemoveWindowSubclass, N, <NONE>,  'RemoveWindowSubclass',  \
    SetWindowSubclass, N, <NONE>,  'SetWindowSubclass',  \
    ShowHideMenuCtl, N, <.hWnd, .uFlags, .lpInfo>,  'ShowHideMenuCtl',  \
    Str_SetPtr, W, <NONE>,  'Str_SetPtrW',  \
    UninitializeFlatSB, N, <.hwnd>,  'UninitializeFlatSB',  \
    _TrackMouseEvent, N, <NONE>,  '_TrackMouseEvent'
