; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "Fresh artistic license."         |
;|_______________________________________________________________________________________|
;
;  Description: gdi32.dll API calls
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


import_proto gdi32,  \
    AbortDoc, N, <.hdc>,  'AbortDoc',  \
    AbortPath, N, <.hdc>,  'AbortPath',  \
    AddFontMemResourceEx, N, <.pvoid, .dword, .pDword>,  'AddFontMemResourceEx',  \
    AddFontResource, A, <.lpFileName>,  'AddFontResourceA',  \
    AddFontResourceEx, A, <.lpcstr, .dword>,  'AddFontResourceExA',  \
    AddFontResourceEx, W, <.lpcstr, .dword>,  'AddFontResourceExW',  \
    AddFontResourceTracking, N, <NONE>,  'AddFontResourceTracking',  \
    AddFontResource, W, <.lpFileName>,  'AddFontResourceW',  \
    AngleArc, N, <.hdc, .x, .y, .dwRadius, .eStartAngle, .eSweepAngle>,  'AngleArc',  \
    AnimatePalette, N, <.hPalette, .wStartIndex, .wNumEntries, .lpPaletteColors>,  'AnimatePalette',  \
    AnyLinkedFonts, N, <NONE>,  'AnyLinkedFonts',  \
    Arc, N, <.hdc, .X1, .Y1, .X2, .Y2, .X3, .Y3, .X4, .Y4>,  'Arc',  \
    ArcTo, N, <.hdc, .X1, .Y1, .X2, .Y2, .X3, .Y3, .X4, .Y4>,  'ArcTo',  \
    BRUSHOBJ_hGetColorTransform, N, <NONE>,  'BRUSHOBJ_hGetColorTransform',  \
    BRUSHOBJ_pvAllocRbrush, N, <NONE>,  'BRUSHOBJ_pvAllocRbrush',  \
    BRUSHOBJ_pvGetRbrush, N, <NONE>,  'BRUSHOBJ_pvGetRbrush',  \
    BRUSHOBJ_ulGetBrushColor, N, <NONE>,  'BRUSHOBJ_ulGetBrushColor',  \
    BeginPath, N, <.hdc>,  'BeginPath',  \
    BitBlt, N, <.hDestDC, .x, .y, .nWidth, .nHeight, .hSrcDC, .xSrc, .ySrc, .dwRop>,  'BitBlt',  \
    CLIPOBJ_bEnum, N, <NONE>,  'CLIPOBJ_bEnum',  \
    CLIPOBJ_cEnumStart, N, <NONE>,  'CLIPOBJ_cEnumStart',  \
    CLIPOBJ_ppoGetPath, N, <NONE>,  'CLIPOBJ_ppoGetPath',  \
    CancelDC, N, <.hdc>,  'CancelDC',  \
    CheckColorsInGamut, N, <.hdc, .lpv, .lpv2, .dw>,  'CheckColorsInGamut',  \
    ChoosePixelFormat, N, <.hDC, .pPixelFormatDescriptor>,  'ChoosePixelFormat',  \
    Chord, N, <.hdc, .X1, .Y1, .X2, .Y2, .X3, .Y3, .X4, .Y4>,  'Chord',  \
    ClearBitmapAttributes, N, <NONE>,  'ClearBitmapAttributes',  \
    ClearBrushAttributes, N, <NONE>,  'ClearBrushAttributes',  \
    CloseEnhMetaFile, N, <.hdc>,  'CloseEnhMetaFile',  \
    CloseFigure, N, <.hdc>,  'CloseFigure',  \
    CloseMetaFile, N, <.hMF>,  'CloseMetaFile',  \
    ColorCorrectPalette, N, <.hdc, .hpalette, .dword>,  'ColorCorrectPalette',  \
    ColorMatchToTarget, N, <.hdc, .hdc2, .dw>,  'ColorMatchToTarget',  \
    CombineRgn, N, <.hDestRgn, .hSrcRgn1, .hSrcRgn2, .nCombineMode>,  'CombineRgn',  \
    CombineTransform, N, <.lpxformResult, .lpxform1, .lpxform2>,  'CombineTransform',  \
    CopyEnhMetaFile, A, <.hemfSrc, .lpszFile>,  'CopyEnhMetaFileA',  \
    CopyEnhMetaFile, W, <.hemfSrc, .lpszFile>,  'CopyEnhMetaFileW',  \
    CopyMetaFile, A, <.hMF, .lpFileName>,  'CopyMetaFileA',  \
    CopyMetaFile, W, <.hMF, .lpFileName>,  'CopyMetaFileW',  \
    CreateBitmap, N, <.nWidth, .nHeight, .nPlanes, .nBitCount, .lpBits>,  'CreateBitmap',  \
    CreateBitmapIndirect, N, <.lpBitmap>,  'CreateBitmapIndirect',  \
    CreateBrushIndirect, N, <.lpLogBrush>,  'CreateBrushIndirect',  \
    CreateColorSpace, A, <.lplogcolorspace>,  'CreateColorSpaceA',  \
    CreateColorSpace, W, <.lplogcolorspace>,  'CreateColorSpaceW',  \
    CreateCompatibleBitmap, N, <.hdc, .nWidth, .nHeight>,  'CreateCompatibleBitmap',  \
    CreateCompatibleDC, N, <.hdc>,  'CreateCompatibleDC',  \
    CreateDC, A, <.lpDriverName, .lpDeviceName, .lpOutput, .lpInitData>,  'CreateDCA',  \
    CreateDC, W, <.lpDriverName, .lpDeviceName, .lpOutput, .lpInitData>,  'CreateDCW',  \
    CreateDIBPatternBrush, N, <.hPackedDIB, .wUsage>,  'CreateDIBPatternBrush',  \
    CreateDIBPatternBrushPt, N, <.lpPackedDIB, .iUsage>,  'CreateDIBPatternBrushPt',  \
    CreateDIBSection, N, <.hDC, .pBitmapInfo, .iUsage, .pVarBits, .hSection, .dwOffset>,  'CreateDIBSection',  \
    CreateDIBitmap, N, <.hdc, .lpInfoHeader, .dwUsage, .lpInitBits, .lpInitInfo, .wUsage>,  'CreateDIBitmap',  \
    CreateDiscardableBitmap, N, <.hdc, .nWidth, .nHeight>,  'CreateDiscardableBitmap',  \
    CreateEllipticRgn, N, <.X1, .Y1, .X2, .Y2>,  'CreateEllipticRgn',  \
    CreateEllipticRgnIndirect, N, <.lpRect>,  'CreateEllipticRgnIndirect',  \
    CreateEnhMetaFile, A, <.hdcRef, .lpFileName, .lpRect, .lpDescription>,  'CreateEnhMetaFileA',  \
    CreateEnhMetaFile, W, <.hdcRef, .lpFileName, .lpRect, .lpDescription>,  'CreateEnhMetaFileW',  \
    CreateFont, A, <.height, .width, .escapement, .orientation, .weight, .italic, .underline, .strikeout, .charset, .OutputPrecision, .ClipPrecision, .quality, .PitchAndFamily, .Face>,  'CreateFontA',  \
    CreateFontIndirect, A, <.lpLogFont>,  'CreateFontIndirectA',  \
    CreateFontIndirectEx, A, <.ENUMLOGFONTEXDVA>,  'CreateFontIndirectExA',  \
    CreateFontIndirectEx, W, <.ENUMLOGFONTEXDVA>,  'CreateFontIndirectExW',  \
    CreateFontIndirect, W, <.lpLogFont>,  'CreateFontIndirectW',  \
    CreateFont, W, <.height, .width, .escapement, .orientation, .weight, .italic, .underline, .strikeout, .charset, .OutputPrecision, .ClipPrecision, .quality, .PitchAndFamily, .Face>,  'CreateFontW',  \
    CreateHalftonePalette, N, <.hdc>,  'CreateHalftonePalette',  \
    CreateHatchBrush, N, <.nIndex, .crColor>,  'CreateHatchBrush',  \
    CreateIC, A, <.lpDriverName, .lpDeviceName, .lpOutput, .lpInitData>,  'CreateICA',  \
    CreateIC, W, <.lpDriverName, .lpDeviceName, .lpOutput, .lpInitData>,  'CreateICW',  \
    CreateMetaFile, A, <.lpString>,  'CreateMetaFileA',  \
    CreateMetaFile, W, <.lpString>,  'CreateMetaFileW',  \
    CreatePalette, N, <.lpLogPalette>,  'CreatePalette',  \
    CreatePatternBrush, N, <.hBitmap>,  'CreatePatternBrush',  \
    CreatePen, N, <.nPenStyle, .nWidth, .crColor>,  'CreatePen',  \
    CreatePenIndirect, N, <.lpLogPen>,  'CreatePenIndirect',  \
    CreatePolyPolygonRgn, N, <.lpPoint, .lpPolyCounts, .nCount, .nPolyFillMode>,  'CreatePolyPolygonRgn',  \
    CreatePolygonRgn, N, <.lpPoint, .nCount, .nPolyFillMode>,  'CreatePolygonRgn',  \
    CreateRectRgn, N, <.X1, .Y1, .X2, .Y2>,  'CreateRectRgn',  \
    CreateRectRgnIndirect, N, <.lpRect>,  'CreateRectRgnIndirect',  \
    CreateRoundRectRgn, N, <.X1, .Y1, .X2, .Y2, .X3, .Y3>,  'CreateRoundRectRgn',  \
    CreateScalableFontResource, A, <.fHidden, .lpszResourceFile, .lpszFontFile, .lpszCurrentPath>,  'CreateScalableFontResourceA',  \
    CreateScalableFontResource, W, <.fHidden, .lpszResourceFile, .lpszFontFile, .lpszCurrentPath>,  'CreateScalableFontResourceW',  \
    CreateSolidBrush, N, <.crColor>,  'CreateSolidBrush',  \
    DPtoLP, N, <.hdc, .lpPoint, .nCount>,  'DPtoLP',  \
    DdEntry0, N, <NONE>,  'DdEntry0',  \
    DdEntry1, N, <NONE>,  'DdEntry1',  \
    DdEntry10, N, <NONE>,  'DdEntry10',  \
    DdEntry11, N, <NONE>,  'DdEntry11',  \
    DdEntry12, N, <NONE>,  'DdEntry12',  \
    DdEntry13, N, <NONE>,  'DdEntry13',  \
    DdEntry14, N, <NONE>,  'DdEntry14',  \
    DdEntry15, N, <NONE>,  'DdEntry15',  \
    DdEntry16, N, <NONE>,  'DdEntry16',  \
    DdEntry17, N, <NONE>,  'DdEntry17',  \
    DdEntry18, N, <NONE>,  'DdEntry18',  \
    DdEntry19, N, <NONE>,  'DdEntry19',  \
    DdEntry2, N, <NONE>,  'DdEntry2',  \
    DdEntry20, N, <NONE>,  'DdEntry20',  \
    DdEntry21, N, <NONE>,  'DdEntry21',  \
    DdEntry22, N, <NONE>,  'DdEntry22',  \
    DdEntry23, N, <NONE>,  'DdEntry23',  \
    DdEntry24, N, <NONE>,  'DdEntry24',  \
    DdEntry25, N, <NONE>,  'DdEntry25',  \
    DdEntry26, N, <NONE>,  'DdEntry26',  \
    DdEntry27, N, <NONE>,  'DdEntry27',  \
    DdEntry28, N, <NONE>,  'DdEntry28',  \
    DdEntry29, N, <NONE>,  'DdEntry29',  \
    DdEntry3, N, <NONE>,  'DdEntry3',  \
    DdEntry30, N, <NONE>,  'DdEntry30',  \
    DdEntry31, N, <NONE>,  'DdEntry31',  \
    DdEntry32, N, <NONE>,  'DdEntry32',  \
    DdEntry33, N, <NONE>,  'DdEntry33',  \
    DdEntry34, N, <NONE>,  'DdEntry34',  \
    DdEntry35, N, <NONE>,  'DdEntry35',  \
    DdEntry36, N, <NONE>,  'DdEntry36',  \
    DdEntry37, N, <NONE>,  'DdEntry37',  \
    DdEntry38, N, <NONE>,  'DdEntry38',  \
    DdEntry39, N, <NONE>,  'DdEntry39',  \
    DdEntry4, N, <NONE>,  'DdEntry4',  \
    DdEntry40, N, <NONE>,  'DdEntry40',  \
    DdEntry41, N, <NONE>,  'DdEntry41',  \
    DdEntry42, N, <NONE>,  'DdEntry42',  \
    DdEntry43, N, <NONE>,  'DdEntry43',  \
    DdEntry44, N, <NONE>,  'DdEntry44',  \
    DdEntry45, N, <NONE>,  'DdEntry45',  \
    DdEntry46, N, <NONE>,  'DdEntry46',  \
    DdEntry47, N, <NONE>,  'DdEntry47',  \
    DdEntry48, N, <NONE>,  'DdEntry48',  \
    DdEntry49, N, <NONE>,  'DdEntry49',  \
    DdEntry5, N, <NONE>,  'DdEntry5',  \
    DdEntry50, N, <NONE>,  'DdEntry50',  \
    DdEntry51, N, <NONE>,  'DdEntry51',  \
    DdEntry52, N, <NONE>,  'DdEntry52',  \
    DdEntry53, N, <NONE>,  'DdEntry53',  \
    DdEntry54, N, <NONE>,  'DdEntry54',  \
    DdEntry55, N, <NONE>,  'DdEntry55',  \
    DdEntry56, N, <NONE>,  'DdEntry56',  \
    DdEntry6, N, <NONE>,  'DdEntry6',  \
    DdEntry7, N, <NONE>,  'DdEntry7',  \
    DdEntry8, N, <NONE>,  'DdEntry8',  \
    DdEntry9, N, <NONE>,  'DdEntry9',  \
    DeleteColorSpace, N, <.hcolorspace>,  'DeleteColorSpace',  \
    DeleteDC, N, <.hdc>,  'DeleteDC',  \
    DeleteEnhMetaFile, N, <.hemf>,  'DeleteEnhMetaFile',  \
    DeleteMetaFile, N, <.hMF>,  'DeleteMetaFile',  \
    DeleteObject, N, <.hObject>,  'DeleteObject',  \
    DescribePixelFormat, N, <.hDC, .n, .un, .lpPixelFormatDescriptor>,  'DescribePixelFormat',  \
    DeviceCapabilitiesEx, A, <NONE>,  'DeviceCapabilitiesExA',  \
    DeviceCapabilitiesEx, W, <NONE>,  'DeviceCapabilitiesExW',  \
    DrawEscape, N, <.hdc, .nEscape, .cbInput, .lpszInData>,  'DrawEscape',  \
    Ellipse, N, <.hdc, .X1, .Y1, .X2, .Y2>,  'Ellipse',  \
    EnableEUDC, N, <NONE>,  'EnableEUDC',  \
    EndDoc, N, <.hDC>,  'EndDoc',  \
    EndFormPage, N, <.hdc>,  'EndFormPage',  \
    EndPage, N, <.hdc>,  'EndPage',  \
    EndPath, N, <.hdc>,  'EndPath',  \
    EngAcquireSemaphore, N, <NONE>,  'EngAcquireSemaphore',  \
    EngAlphaBlend, N, <NONE>,  'EngAlphaBlend',  \
    EngAssociateSurface, N, <NONE>,  'EngAssociateSurface',  \
    EngBitBlt, N, <NONE>,  'EngBitBlt',  \
    EngCheckAbort, N, <NONE>,  'EngCheckAbort',  \
    EngComputeGlyphSet, N, <NONE>,  'EngComputeGlyphSet',  \
    EngCopyBits, N, <NONE>,  'EngCopyBits',  \
    EngCreateBitmap, N, <NONE>,  'EngCreateBitmap',  \
    EngCreateClip, N, <NONE>,  'EngCreateClip',  \
    EngCreateDeviceBitmap, N, <NONE>,  'EngCreateDeviceBitmap',  \
    EngCreateDeviceSurface, N, <NONE>,  'EngCreateDeviceSurface',  \
    EngCreatePalette, N, <NONE>,  'EngCreatePalette',  \
    EngCreateSemaphore, N, <NONE>,  'EngCreateSemaphore',  \
    EngDeleteClip, N, <NONE>,  'EngDeleteClip',  \
    EngDeletePalette, N, <NONE>,  'EngDeletePalette',  \
    EngDeletePath, N, <NONE>,  'EngDeletePath',  \
    EngDeleteSemaphore, N, <NONE>,  'EngDeleteSemaphore',  \
    EngDeleteSurface, N, <NONE>,  'EngDeleteSurface',  \
    EngEraseSurface, N, <NONE>,  'EngEraseSurface',  \
    EngFillPath, N, <NONE>,  'EngFillPath',  \
    EngFindResource, N, <NONE>,  'EngFindResource',  \
    EngFreeModule, N, <NONE>,  'EngFreeModule',  \
    EngGetCurrentCodePage, N, <NONE>,  'EngGetCurrentCodePage',  \
    EngGetDriverName, N, <NONE>,  'EngGetDriverName',  \
    EngGetPrinterDataFileName, N, <NONE>,  'EngGetPrinterDataFileName',  \
    EngGradientFill, N, <NONE>,  'EngGradientFill',  \
    EngLineTo, N, <NONE>,  'EngLineTo',  \
    EngLoadModule, N, <NONE>,  'EngLoadModule',  \
    EngLockSurface, N, <NONE>,  'EngLockSurface',  \
    EngMarkBandingSurface, N, <NONE>,  'EngMarkBandingSurface',  \
    EngMultiByteToUnicodeN, N, <NONE>,  'EngMultiByteToUnicodeN',  \
    EngMultiByteToWideChar, N, <NONE>,  'EngMultiByteToWideChar',  \
    EngPaint, N, <NONE>,  'EngPaint',  \
    EngPlgBlt, N, <NONE>,  'EngPlgBlt',  \
    EngQueryEMFInfo, N, <NONE>,  'EngQueryEMFInfo',  \
    EngQueryLocalTime, N, <NONE>,  'EngQueryLocalTime',  \
    EngReleaseSemaphore, N, <NONE>,  'EngReleaseSemaphore',  \
    EngStretchBlt, N, <NONE>,  'EngStretchBlt',  \
    EngStretchBltROP, N, <NONE>,  'EngStretchBltROP',  \
    EngStrokeAndFillPath, N, <NONE>,  'EngStrokeAndFillPath',  \
    EngStrokePath, N, <NONE>,  'EngStrokePath',  \
    EngTextOut, N, <NONE>,  'EngTextOut',  \
    EngTransparentBlt, N, <NONE>,  'EngTransparentBlt',  \
    EngUnicodeToMultiByteN, N, <NONE>,  'EngUnicodeToMultiByteN',  \
    EngUnlockSurface, N, <NONE>,  'EngUnlockSurface',  \
    EngWideCharToMultiByte, N, <NONE>,  'EngWideCharToMultiByte',  \
    EnumEnhMetaFile, N, <.hdc, .hemf, .lpEnhMetaFunc, .lpData, .lpRect>,  'EnumEnhMetaFile',  \
    EnumFontFamilies, A, <.hdc, .lpszFamily, .lpEnumFontFamProc, .lParam>,  'EnumFontFamiliesA',  \
    EnumFontFamiliesEx, A, <.hdc, .lpLogFont, .lpEnumFontProc, .lParam, .dw>,  'EnumFontFamiliesExA',  \
    EnumFontFamiliesEx, W, <.hdc, .lpLogFont, .lpEnumFontProc, .lParam, .dw>,  'EnumFontFamiliesExW',  \
    EnumFontFamilies, W, <.hdc, .lpszFamily, .lpEnumFontFamProc, .lParam>,  'EnumFontFamiliesW',  \
    EnumFonts, A, <.hDC, .lpsz, .lpFontEnumProc, .lParam>,  'EnumFontsA',  \
    EnumFonts, W, <.hDC, .lpsz, .lpFontEnumProc, .lParam>,  'EnumFontsW',  \
    EnumICMProfiles, A, <.hdc, .icmEnumProc, .lParam>,  'EnumICMProfilesA',  \
    EnumICMProfiles, W, <.hdc, .icmEnumProc, .lParam>,  'EnumICMProfilesW',  \
    EnumMetaFile, N, <.hDC, .hMetafile, .lpMFEnumProc, .lParam>,  'EnumMetaFile',  \
    EnumObjects, N, <.hDC, .n, .lpGOBJEnumProc, .lpVoid>,  'EnumObjects',  \
    EqualRgn, N, <.hSrcRgn1, .hSrcRgn2>,  'EqualRgn',  \
    Escape, N, <.hdc, .nEscape, .nCount, .lpInData, .lpOutData>,  'Escape',  \
    EudcLoadLink, W, <NONE>,  'EudcLoadLinkW',  \
    EudcUnloadLink, W, <NONE>,  'EudcUnloadLinkW',  \
    ExcludeClipRect, N, <.hdc, .X1, .Y1, .X2, .Y2>,  'ExcludeClipRect',  \
    ExtCreatePen, N, <.dwPenStyle, .dwWidth, .lplb, .dwStyleCount, .lpStyle>,  'ExtCreatePen',  \
    ExtCreateRegion, N, <.lpXform, .nCount, .lpRgnData>,  'ExtCreateRegion',  \
    ExtEscape, N, <.hdc, .nEscape, .cbInput, .lpszInData, .cbOutput, .lpszOutData>,  'ExtEscape',  \
    ExtFloodFill, N, <.hdc, .x, .y, .crColor, .wFillType>,  'ExtFloodFill',  \
    ExtSelectClipRgn, N, <.hdc, .hRgn, .fnMode>,  'ExtSelectClipRgn',  \
    ExtTextOut, A, <.hdc, .x, .y, .wOptions, .lpRect, .lpString, .nCount, .lpDx>,  'ExtTextOutA',  \
    ExtTextOut, W, <.hdc, .x, .y, .wOptions, .lpRect, .lpString, .nCount, .lpDx>,  'ExtTextOutW',  \
    FONTOBJ_cGetAllGlyphHandles, N, <NONE>,  'FONTOBJ_cGetAllGlyphHandles',  \
    FONTOBJ_cGetGlyphs, N, <NONE>,  'FONTOBJ_cGetGlyphs',  \
    FONTOBJ_pQueryGlyphAttrs, N, <NONE>,  'FONTOBJ_pQueryGlyphAttrs',  \
    FONTOBJ_pfdg, N, <NONE>,  'FONTOBJ_pfdg',  \
    FONTOBJ_pifi, N, <NONE>,  'FONTOBJ_pifi',  \
    FONTOBJ_pvTrueTypeFontFile, N, <NONE>,  'FONTOBJ_pvTrueTypeFontFile',  \
    FONTOBJ_pxoGetXform, N, <NONE>,  'FONTOBJ_pxoGetXform',  \
    FONTOBJ_vGetInfo, N, <NONE>,  'FONTOBJ_vGetInfo',  \
    FillPath, N, <.hdc>,  'FillPath',  \
    FillRgn, N, <.hdc, .hRgn, .hBrush>,  'FillRgn',  \
    FixBrushOrgEx, N, <.hDC, .n1, .n2, .lpPoint>,  'FixBrushOrgEx',  \
    FlattenPath, N, <.hdc>,  'FlattenPath',  \
    FloodFill, N, <.hdc, .x, .y, .crColor>,  'FloodFill',  \
    FontIsLinked, N, <NONE>,  'FontIsLinked',  \
    FrameRgn, N, <.hdc, .hRgn, .hBrush, .nWidth, .nHeight>,  'FrameRgn',  \
    GdiAddFontResource, W, <NONE>,  'GdiAddFontResourceW',  \
    GdiAddGlsBounds, N, <NONE>,  'GdiAddGlsBounds',  \
    GdiAddGlsRecord, N, <NONE>,  'GdiAddGlsRecord',  \
    GdiAlphaBlend, N, <NONE>,  'GdiAlphaBlend',  \
    GdiArtificialDecrementDriver, N, <NONE>,  'GdiArtificialDecrementDriver',  \
    GdiCleanCacheDC, N, <NONE>,  'GdiCleanCacheDC',  \
    GdiComment, N, <.hdc, .cbSize, .lpData>,  'GdiComment',  \
    GdiConsoleTextOut, N, <NONE>,  'GdiConsoleTextOut',  \
    GdiConvertAndCheckDC, N, <NONE>,  'GdiConvertAndCheckDC',  \
    GdiConvertBitmap, N, <NONE>,  'GdiConvertBitmap',  \
    GdiConvertBitmapV5, N, <NONE>,  'GdiConvertBitmapV5',  \
    GdiConvertBrush, N, <NONE>,  'GdiConvertBrush',  \
    GdiConvertDC, N, <NONE>,  'GdiConvertDC',  \
    GdiConvertEnhMetaFile, N, <NONE>,  'GdiConvertEnhMetaFile',  \
    GdiConvertFont, N, <NONE>,  'GdiConvertFont',  \
    GdiConvertMetaFilePict, N, <NONE>,  'GdiConvertMetaFilePict',  \
    GdiConvertPalette, N, <NONE>,  'GdiConvertPalette',  \
    GdiConvertRegion, N, <NONE>,  'GdiConvertRegion',  \
    GdiConvertToDevmode, W, <NONE>,  'GdiConvertToDevmodeW',  \
    GdiCreateLocalEnhMetaFile, N, <NONE>,  'GdiCreateLocalEnhMetaFile',  \
    GdiCreateLocalMetaFilePict, N, <NONE>,  'GdiCreateLocalMetaFilePict',  \
    GdiDeleteLocalDC, N, <NONE>,  'GdiDeleteLocalDC',  \
    GdiDeleteSpoolFileHandle, N, <NONE>,  'GdiDeleteSpoolFileHandle',  \
    GdiDescribePixelFormat, N, <NONE>,  'GdiDescribePixelFormat',  \
    GdiDllInitialize, N, <NONE>,  'GdiDllInitialize',  \
    GdiDrawStream, N, <NONE>,  'GdiDrawStream',  \
    GdiEndDocEMF, N, <NONE>,  'GdiEndDocEMF',  \
    GdiEndPageEMF, N, <NONE>,  'GdiEndPageEMF',  \
    GdiEntry1, N, <NONE>,  'GdiEntry1',  \
    GdiEntry10, N, <NONE>,  'GdiEntry10',  \
    GdiEntry11, N, <NONE>,  'GdiEntry11',  \
    GdiEntry12, N, <NONE>,  'GdiEntry12',  \
    GdiEntry13, N, <NONE>,  'GdiEntry13',  \
    GdiEntry14, N, <NONE>,  'GdiEntry14',  \
    GdiEntry15, N, <NONE>,  'GdiEntry15',  \
    GdiEntry16, N, <NONE>,  'GdiEntry16',  \
    GdiEntry2, N, <NONE>,  'GdiEntry2',  \
    GdiEntry3, N, <NONE>,  'GdiEntry3',  \
    GdiEntry4, N, <NONE>,  'GdiEntry4',  \
    GdiEntry5, N, <NONE>,  'GdiEntry5',  \
    GdiEntry6, N, <NONE>,  'GdiEntry6',  \
    GdiEntry7, N, <NONE>,  'GdiEntry7',  \
    GdiEntry8, N, <NONE>,  'GdiEntry8',  \
    GdiEntry9, N, <NONE>,  'GdiEntry9',  \
    GdiFixUpHandle, N, <NONE>,  'GdiFixUpHandle',  \
    GdiFlush, N, <VOID>,  'GdiFlush',  \
    GdiFullscreenControl, N, <NONE>,  'GdiFullscreenControl',  \
    GdiGetBatchLimit, N, <VOID>,  'GdiGetBatchLimit',  \
    GdiGetBitmapBitsSize, N, <NONE>,  'GdiGetBitmapBitsSize',  \
    GdiGetCharDimensions, N, <NONE>,  'GdiGetCharDimensions',  \
    GdiGetCodePage, N, <NONE>,  'GdiGetCodePage',  \
    GdiGetDC, N, <NONE>,  'GdiGetDC',  \
    GdiGetDevmodeForPage, N, <NONE>,  'GdiGetDevmodeForPage',  \
    GdiGetLocalBrush, N, <NONE>,  'GdiGetLocalBrush',  \
    GdiGetLocalDC, N, <NONE>,  'GdiGetLocalDC',  \
    GdiGetLocalFont, N, <NONE>,  'GdiGetLocalFont',  \
    GdiGetPageCount, N, <NONE>,  'GdiGetPageCount',  \
    GdiGetPageHandle, N, <NONE>,  'GdiGetPageHandle',  \
    GdiGetSpoolFileHandle, N, <NONE>,  'GdiGetSpoolFileHandle',  \
    GdiGetSpoolMessage, N, <NONE>,  'GdiGetSpoolMessage',  \
    GdiGradientFill, N, <NONE>,  'GdiGradientFill',  \
    GdiInitSpool, N, <NONE>,  'GdiInitSpool',  \
    GdiInitializeLanguagePack, N, <NONE>,  'GdiInitializeLanguagePack',  \
    GdiIsMetaFileDC, N, <NONE>,  'GdiIsMetaFileDC',  \
    GdiIsMetaPrintDC, N, <NONE>,  'GdiIsMetaPrintDC',  \
    GdiIsPlayMetafileDC, N, <NONE>,  'GdiIsPlayMetafileDC',  \
    GdiPlayDCScript, N, <NONE>,  'GdiPlayDCScript',  \
    GdiPlayEMF, N, <NONE>,  'GdiPlayEMF',  \
    GdiPlayJournal, N, <NONE>,  'GdiPlayJournal',  \
    GdiPlayPageEMF, N, <NONE>,  'GdiPlayPageEMF',  \
    GdiPlayPrivatePageEMF, N, <NONE>,  'GdiPlayPrivatePageEMF',  \
    GdiPlayScript, N, <NONE>,  'GdiPlayScript',  \
    GdiPrinterThunk, N, <NONE>,  'GdiPrinterThunk',  \
    GdiProcessSetup, N, <NONE>,  'GdiProcessSetup',  \
    GdiQueryFonts, N, <NONE>,  'GdiQueryFonts',  \
    GdiQueryTable, N, <NONE>,  'GdiQueryTable',  \
    GdiRealizationInfo, N, <NONE>,  'GdiRealizationInfo',  \
    GdiReleaseDC, N, <NONE>,  'GdiReleaseDC',  \
    GdiReleaseLocalDC, N, <NONE>,  'GdiReleaseLocalDC',  \
    GdiResetDCEMF, N, <NONE>,  'GdiResetDCEMF',  \
    GdiSetAttrs, N, <NONE>,  'GdiSetAttrs',  \
    GdiSetBatchLimit, N, <.dwLimit>,  'GdiSetBatchLimit',  \
    GdiSetLastError, N, <NONE>,  'GdiSetLastError',  \
    GdiSetPixelFormat, N, <NONE>,  'GdiSetPixelFormat',  \
    GdiSetServerAttr, N, <NONE>,  'GdiSetServerAttr',  \
    GdiStartDocEMF, N, <NONE>,  'GdiStartDocEMF',  \
    GdiStartPageEMF, N, <NONE>,  'GdiStartPageEMF',  \
    GdiSwapBuffers, N, <NONE>,  'GdiSwapBuffers',  \
    GdiTransparentBlt, N, <NONE>,  'GdiTransparentBlt',  \
    GdiValidateHandle, N, <NONE>,  'GdiValidateHandle',  \
    GetArcDirection, N, <.hdc>,  'GetArcDirection',  \
    GetAspectRatioFilterEx, N, <.hdc, .lpAspectRatio>,  'GetAspectRatioFilterEx',  \
    GetBitmapAttributes, N, <NONE>,  'GetBitmapAttributes',  \
    GetBitmapBits, N, <.hBitmap, .dwCount, .lpBits>,  'GetBitmapBits',  \
    GetBitmapDimensionEx, N, <.hBitmap, .lpDimension>,  'GetBitmapDimensionEx',  \
    GetBkColor, N, <.hdc>,  'GetBkColor',  \
    GetBkMode, N, <.hdc>,  'GetBkMode',  \
    GetBoundsRect, N, <.hdc, .lprcBounds, .flags>,  'GetBoundsRect',  \
    GetBrushAttributes, N, <NONE>,  'GetBrushAttributes',  \
    GetBrushOrgEx, N, <.hDC, .lpPoint>,  'GetBrushOrgEx',  \
    GetCharABCWidths, A, <.hdc, .uFirstChar, .uLastChar, .lpabc>,  'GetCharABCWidthsA',  \
    GetCharABCWidthsFloat, A, <.hdc, .iFirstChar, .iLastChar, .lpABCF>,  'GetCharABCWidthsFloatA',  \
    GetCharABCWidthsFloat, W, <.hdc, .iFirstChar, .iLastChar, .lpABCF>,  'GetCharABCWidthsFloatW',  \
    GetCharABCWidthsI, N, <.hdc, .uint, .lpword, .lpabc>,  'GetCharABCWidthsI',  \
    GetCharABCWidths, W, <.hdc, .uFirstChar, .uLastChar, .lpabc>,  'GetCharABCWidthsW',  \
    GetCharWidth32, A, <.hdc, .iFirstChar, .iLastChar, .lpBuffer>,  'GetCharWidth32A',  \
    GetCharWidth32, W, <.hdc, .iFirstChar, .iLastChar, .lpBuffer>,  'GetCharWidth32W',  \
    GetCharWidth, A, <.hdc, .wFirstChar, .wLastChar, .lpBuffer>,  'GetCharWidthA',  \
    GetCharWidthFloat, A, <.hdc, .iFirstChar, .iLastChar, .pxBuffer>,  'GetCharWidthFloatA',  \
    GetCharWidthFloat, W, <.hdc, .iFirstChar, .iLastChar, .pxBuffer>,  'GetCharWidthFloatW',  \
    GetCharWidthI, N, <.hdc, .uint, .lpword, .lpint>,  'GetCharWidthI',  \
    GetCharWidthInfo, N, <NONE>,  'GetCharWidthInfo',  \
    GetCharWidth, W, <.hdc, .wFirstChar, .wLastChar, .lpBuffer>,  'GetCharWidthW',  \
    GetCharacterPlacement, A, <.hdc, .lpsz, .n1, .n2, .lpGcpResults, .dw>,  'GetCharacterPlacementA',  \
    GetCharacterPlacement, W, <.hdc, .lpsz, .n1, .n2, .lpGcpResults, .dw>,  'GetCharacterPlacementW',  \
    GetClipBox, N, <.hdc, .lpRect>,  'GetClipBox',  \
    GetClipRgn, N, <.hdc, .hRgn>,  'GetClipRgn',  \
    GetColorAdjustment, N, <.hdc, .lpca>,  'GetColorAdjustment',  \
    GetColorSpace, N, <.hdc>,  'GetColorSpace',  \
    GetCurrentObject, N, <.hdc, .uObjectType>,  'GetCurrentObject',  \
    GetCurrentPositionEx, N, <.hdc, .lpPoint>,  'GetCurrentPositionEx',  \
    GetDCBrushColor, N, <.hdc>,  'GetDCBrushColor',  \
    GetDCOrgEx, N, <.hdc, .lpPoint>,  'GetDCOrgEx',  \
    GetDCPenColor, N, <.hdc>,  'GetDCPenColor',  \
    GetDIBColorTable, N, <.hDC, .un1, .un2, .pRGBQuad>,  'GetDIBColorTable',  \
    GetDIBits, N, <.aHDC, .hBitmap, .nStartScan, .nNumScans, .lpBits, .lpBI, .wUsage>,  'GetDIBits',  \
    GetDeviceCaps, N, <.hdc, .nIndex>,  'GetDeviceCaps',  \
    GetDeviceGammaRamp, N, <.hdc, .lpv>,  'GetDeviceGammaRamp',  \
    GetETM, N, <NONE>,  'GetETM',  \
    GetEUDCTimeStamp, N, <NONE>,  'GetEUDCTimeStamp',  \
    GetEUDCTimeStampEx, W, <NONE>,  'GetEUDCTimeStampExW',  \
    GetEnhMetaFile, A, <.lpszMetaFile>,  'GetEnhMetaFileA',  \
    GetEnhMetaFileBits, N, <.hemf, .cbBuffer, .lpbBuffer>,  'GetEnhMetaFileBits',  \
    GetEnhMetaFileDescription, A, <.hemf, .cchBuffer, .lpszDescription>,  'GetEnhMetaFileDescriptionA',  \
    GetEnhMetaFileDescription, W, <.hemf, .cchBuffer, .lpszDescription>,  'GetEnhMetaFileDescriptionW',  \
    GetEnhMetaFileHeader, N, <.hemf, .cbBuffer, .lpemh>,  'GetEnhMetaFileHeader',  \
    GetEnhMetaFilePaletteEntries, N, <.hemf, .cEntries, .lppe>,  'GetEnhMetaFilePaletteEntries',  \
    GetEnhMetaFilePixelFormat, N, <.henhmetafile, .uint, .PIXELFORMATDESCRIPTOR>,  'GetEnhMetaFilePixelFormat',  \
    GetEnhMetaFile, W, <.lpszMetaFile>,  'GetEnhMetaFileW',  \
    GetFontAssocStatus, N, <NONE>,  'GetFontAssocStatus',  \
    GetFontData, N, <.hdc, .dwTable, .dwOffset, .lpvBuffer, .cbData>,  'GetFontData',  \
    GetFontLanguageInfo, N, <.hdc>,  'GetFontLanguageInfo',  \
    GetFontResourceInfo, W, <NONE>,  'GetFontResourceInfoW',  \
    GetFontUnicodeRanges, N, <.hdc, .LPGLYPHSET>,  'GetFontUnicodeRanges',  \
    GetGlyphIndices, A, <.hdc, .lpcstr, .ByValt, .lpword, .dword>,  'GetGlyphIndicesA',  \
    GetGlyphIndices, W, <.hdc, .lpcstr, .ByValt, .lpword, .dword>,  'GetGlyphIndicesW',  \
    GetGlyphOutline, A, <.hdc, .uChar, .fuFormat, .lpgm, .cbBuffer, .lpBuffer, .lpmat2>,  'GetGlyphOutlineA',  \
    GetGlyphOutline, W, <.hdc, .uChar, .fuFormat, .lpgm, .cbBuffer, .lpBuffer, .lpmat2>,  'GetGlyphOutlineW',  \
    GetGlyphOutlineWow, N, <NONE>,  'GetGlyphOutlineWow',  \
    GetGraphicsMode, N, <.hdc>,  'GetGraphicsMode',  \
    GetHFONT, N, <NONE>,  'GetHFONT',  \
    GetICMProfile, A, <.hdc, .dw, .lpStr>,  'GetICMProfileA',  \
    GetICMProfile, W, <.hdc, .dw, .lpStr>,  'GetICMProfileW',  \
    GetKerningPairs, A, <.hdc, .cPairs, .lpkrnpair>,  'GetKerningPairsA',  \
    GetKerningPairs, W, <.hdc, .cPairs, .lpkrnpair>,  'GetKerningPairsW',  \
    GetLayout, N, <.hdc>,  'GetLayout',  \
    GetLogColorSpace, A, <.hcolorspace, .lplogcolorspace, .dw>,  'GetLogColorSpaceA',  \
    GetLogColorSpace, W, <.hcolorspace, .lplogcolorspace, .dw>,  'GetLogColorSpaceW',  \
    GetMapMode, N, <.hdc>,  'GetMapMode',  \
    GetMetaFile, A, <.lpFileName>,  'GetMetaFileA',  \
    GetMetaFileBitsEx, N, <.hMF, .nSize, .lpvData>,  'GetMetaFileBitsEx',  \
    GetMetaFile, W, <.lpFileName>,  'GetMetaFileW',  \
    GetMetaRgn, N, <.hdc, .hRgn>,  'GetMetaRgn',  \
    GetMiterLimit, N, <.hdc, .peLimit>,  'GetMiterLimit',  \
    GetNearestColor, N, <.hdc, .crColor>,  'GetNearestColor',  \
    GetNearestPaletteIndex, N, <.hPalette, .crColor>,  'GetNearestPaletteIndex',  \
    GetObject, A, <.hObject, .nCount, .lpObject>,  'GetObjectA',  \
    GetObjectType, N, <.hgdiobj>,  'GetObjectType',  \
    GetObject, W, <.hObject, .nCount, .lpObject>,  'GetObjectW',  \
    GetOutlineTextMetrics, A, <.hdc, .cbData, .lpotm>,  'GetOutlineTextMetricsA',  \
    GetOutlineTextMetrics, W, <.hdc, .cbData, .lpotm>,  'GetOutlineTextMetricsW',  \
    GetPaletteEntries, N, <.hPalette, .wStartIndex, .wNumEntries, .lpPaletteEntries>,  'GetPaletteEntries',  \
    GetPath, N, <.hdc, .lpPoint, .lpTypes, .nSize>,  'GetPath',  \
    GetPixel, N, <.hdc, .x, .y>,  'GetPixel',  \
    GetPixelFormat, N, <.hDC>,  'GetPixelFormat',  \
    GetPolyFillMode, N, <.hdc>,  'GetPolyFillMode',  \
    GetROP2, N, <.hdc>,  'GetROP2',  \
    GetRandomRgn, N, <.hdc, .hrgn, .ByValt>,  'GetRandomRgn',  \
    GetRasterizerCaps, N, <.lpraststat, .cb>,  'GetRasterizerCaps',  \
    GetRegionData, N, <.hRgn, .dwCount, .lpRgnData>,  'GetRegionData',  \
    GetRelAbs, N, <NONE>,  'GetRelAbs',  \
    GetRgnBox, N, <.hRgn, .lpRect>,  'GetRgnBox',  \
    GetStockObject, N, <.fnObject>,  'GetStockObject',  \
    GetStretchBltMode, N, <.hdc>,  'GetStretchBltMode',  \
    GetStringBitmap, A, <NONE>,  'GetStringBitmapA',  \
    GetStringBitmap, W, <NONE>,  'GetStringBitmapW',  \
    GetSystemPaletteEntries, N, <.hdc, .wStartIndex, .wNumEntries, .lpPaletteEntries>,  'GetSystemPaletteEntries',  \
    GetSystemPaletteUse, N, <.hdc>,  'GetSystemPaletteUse',  \
    GetTextAlign, N, <.hdc>,  'GetTextAlign',  \
    GetTextCharacterExtra, N, <.hdc>,  'GetTextCharacterExtra',  \
    GetTextCharset, N, <.hdc>,  'GetTextCharset',  \
    GetTextCharsetInfo, N, <.hdc, .lpSig, .dwFlags>,  'GetTextCharsetInfo',  \
    GetTextColor, N, <.hdc>,  'GetTextColor',  \
    GetTextExtentExPoint, A, <.hdc, .lpszStr, .cchString, .nMaxExtent, .lpnFit, .alpDx, .lpSize>,  'GetTextExtentExPointA',  \
    GetTextExtentExPointI, N, <.hdc, .lpword, .ByValt, .lpint, .lpsize>,  'GetTextExtentExPointI',  \
    GetTextExtentExPoint, W, <.hdc, .lpszStr, .cchString, .nMaxExtent, .lpnFit, .alpDx, .lpSize>,  'GetTextExtentExPointW',  \
    GetTextExtentExPointWPri, N, <NONE>,  'GetTextExtentExPointWPri',  \
    GetTextExtentPoint32, A, <.hdc, .lpsz, .cbString, .lpSize>,  'GetTextExtentPoint32A',  \
    GetTextExtentPoint32, W, <.hdc, .lpsz, .cbString, .lpSize>,  'GetTextExtentPoint32W',  \
    GetTextExtentPoint, A, <.hdc, .lpszString, .cbString, .lpSize>,  'GetTextExtentPointA',  \
    GetTextExtentPointI, N, <.hdc, .lpword, .ByValt, .lpsize>,  'GetTextExtentPointI',  \
    GetTextExtentPoint, W, <.hdc, .lpszString, .cbString, .lpSize>,  'GetTextExtentPointW',  \
    GetTextFace, A, <.hdc, .nCount, .lpFacename>,  'GetTextFaceA',  \
    GetTextFaceAlias, W, <NONE>,  'GetTextFaceAliasW',  \
    GetTextFace, W, <.hdc, .nCount, .lpFacename>,  'GetTextFaceW',  \
    GetTextMetrics, A, <.hdc, .lpMetrics>,  'GetTextMetricsA',  \
    GetTextMetrics, W, <.hdc, .lpMetrics>,  'GetTextMetricsW',  \
    GetTransform, N, <NONE>,  'GetTransform',  \
    GetViewportExtEx, N, <.hdc, .lpSize>,  'GetViewportExtEx',  \
    GetViewportOrgEx, N, <.hdc, .lpPoint>,  'GetViewportOrgEx',  \
    GetWinMetaFileBits, N, <.hemf, .cbBuffer, .lpbBuffer, .fnMapMode, .hdcRef>,  'GetWinMetaFileBits',  \
    GetWindowExtEx, N, <.hdc, .lpSize>,  'GetWindowExtEx',  \
    GetWindowOrgEx, N, <.hdc, .lpPoint>,  'GetWindowOrgEx',  \
    GetWorldTransform, N, <.hdc, .lpXform>,  'GetWorldTransform',  \
    HT_Get8BPPFormatPalette, N, <NONE>,  'HT_Get8BPPFormatPalette',  \
    HT_Get8BPPMaskPalette, N, <NONE>,  'HT_Get8BPPMaskPalette',  \
    IntersectClipRect, N, <.hdc, .X1, .Y1, .X2, .Y2>,  'IntersectClipRect',  \
    InvertRgn, N, <.hdc, .hRgn>,  'InvertRgn',  \
    IsValidEnhMetaRecord, N, <NONE>,  'IsValidEnhMetaRecord',  \
    IsValidEnhMetaRecordOffExt, N, <NONE>,  'IsValidEnhMetaRecordOffExt',  \
    LPtoDP, N, <.hdc, .lpPoint, .nCount>,  'LPtoDP',  \
    LineDD, A, <.ByValt, .pLineddaproc, .lparam>,  'LineDDA',  \
    LineTo, N, <.hdc, .x, .y>,  'LineTo',  \
    MaskBlt, N, <.hdcDest, .nXDest, .nYDest, .nWidth, .nHeight, .hdcSrc, .nXSrc, .nYSrc, .hbmMask, .xMask, .yMask, .dwRop>,  'MaskBlt',  \
    MirrorRgn, N, <NONE>,  'MirrorRgn',  \
    ModifyWorldTransform, N, <.hdc, .lpXform, .iMode>,  'ModifyWorldTransform',  \
    MoveToEx, N, <.hdc, .x, .y, .lpPoint>,  'MoveToEx',  \
    NamedEscape, N, <NONE>,  'NamedEscape',  \
    OffsetClipRgn, N, <.hdc, .x, .y>,  'OffsetClipRgn',  \
    OffsetRgn, N, <.hRgn, .x, .y>,  'OffsetRgn',  \
    OffsetViewportOrgEx, N, <.hdc, .nX, .nY, .lpPoint>,  'OffsetViewportOrgEx',  \
    OffsetWindowOrgEx, N, <.hdc, .nX, .nY, .lpPoint>,  'OffsetWindowOrgEx',  \
    PATHOBJ_bEnum, N, <NONE>,  'PATHOBJ_bEnum',  \
    PATHOBJ_bEnumClipLines, N, <NONE>,  'PATHOBJ_bEnumClipLines',  \
    PATHOBJ_vEnumStart, N, <NONE>,  'PATHOBJ_vEnumStart',  \
    PATHOBJ_vEnumStartClipLines, N, <NONE>,  'PATHOBJ_vEnumStartClipLines',  \
    PATHOBJ_vGetBounds, N, <NONE>,  'PATHOBJ_vGetBounds',  \
    PaintRgn, N, <.hdc, .hRgn>,  'PaintRgn',  \
    PatBlt, N, <.hdc, .x, .y, .nWidth, .nHeight, .dwRop>,  'PatBlt',  \
    PathToRegion, N, <.hdc>,  'PathToRegion',  \
    Pie, N, <.hdc, .X1, .Y1, .X2, .Y2, .X3, .Y3, .X4, .Y4>,  'Pie',  \
    PlayEnhMetaFile, N, <.hdc, .hemf, .lpRect>,  'PlayEnhMetaFile',  \
    PlayEnhMetaFileRecord, N, <.hdc, .lpHandletable, .lpEnhMetaRecord, .nHandles>,  'PlayEnhMetaFileRecord',  \
    PlayMetaFile, N, <.hdc, .hMF>,  'PlayMetaFile',  \
    PlayMetaFileRecord, N, <.hdc, .lpHandletable, .lpMetaRecord, .nHandles>,  'PlayMetaFileRecord',  \
    PlgBlt, N, <.hdcDest, .lpPoint, .hdcSrc, .nXSrc, .nYSrc, .nWidth, .nHeight, .hbmMask, .xMask, .yMask>,  'PlgBlt',  \
    PolyBezier, N, <.hdc, .lppt, .cPoints>,  'PolyBezier',  \
    PolyBezierTo, N, <.hdc, .lppt, .cCount>,  'PolyBezierTo',  \
    PolyDraw, N, <.hdc, .lppt, .lpbTypes, .cCount>,  'PolyDraw',  \
    PolyPatBlt, N, <NONE>,  'PolyPatBlt',  \
    PolyPolygon, N, <.hdc, .lpPoint, .lpPolyCounts, .nCount>,  'PolyPolygon',  \
    PolyPolyline, N, <.hdc, .lppt, .lpdwPolyPoints, .cCount>,  'PolyPolyline',  \
    PolyTextOut, A, <.hdc, .pptxt, .cStrings>,  'PolyTextOutA',  \
    PolyTextOut, W, <.hdc, .pptxt, .cStrings>,  'PolyTextOutW',  \
    Polygon, N, <.hdc, .lpPoint, .nCount>,  'Polygon',  \
    Polyline, N, <.hdc, .lpPoint, .nCount>,  'Polyline',  \
    PolylineTo, N, <.hdc, .lppt, .cCount>,  'PolylineTo',  \
    PtInRegion, N, <.hRgn, .x, .y>,  'PtInRegion',  \
    PtVisible, N, <.hdc, .x, .y>,  'PtVisible',  \
    QueryFontAssocStatus, N, <NONE>,  'QueryFontAssocStatus',  \
    RealizePalette, N, <.hdc>,  'RealizePalette',  \
    RectInRegion, N, <.hRgn, .lpRect>,  'RectInRegion',  \
    RectVisible, N, <.hdc, .lpRect>,  'RectVisible',  \
    Rectangle, N, <.hdc, .X1, .Y1, .X2, .Y2>,  'Rectangle',  \
    RemoveFontMemResourceEx, N, <.handle>,  'RemoveFontMemResourceEx',  \
    RemoveFontResource, A, <.lpFileName>,  'RemoveFontResourceA',  \
    RemoveFontResourceEx, A, <.lpcstr, .dword, .DESIGNVECTOR>,  'RemoveFontResourceExA',  \
    RemoveFontResourceEx, W, <.lpcstr, .dword, .DESIGNVECTOR>,  'RemoveFontResourceExW',  \
    RemoveFontResourceTracking, N, <NONE>,  'RemoveFontResourceTracking',  \
    RemoveFontResource, W, <.lpFileName>,  'RemoveFontResourceW',  \
    ResetDC, A, <.hdc, .lpInitData>,  'ResetDCA',  \
    ResetDC, W, <.hdc, .lpInitData>,  'ResetDCW',  \
    ResizePalette, N, <.hPalette, .nNumEntries>,  'ResizePalette',  \
    RestoreDC, N, <.hdc, .nSavedDC>,  'RestoreDC',  \
    RoundRect, N, <.hdc, .X1, .Y1, .X2, .Y2, .X3, .Y3>,  'RoundRect',  \
    STROBJ_bEnum, N, <NONE>,  'STROBJ_bEnum',  \
    STROBJ_bEnumPositionsOnly, N, <NONE>,  'STROBJ_bEnumPositionsOnly',  \
    STROBJ_bGetAdvanceWidths, N, <NONE>,  'STROBJ_bGetAdvanceWidths',  \
    STROBJ_dwGetCodePage, N, <NONE>,  'STROBJ_dwGetCodePage',  \
    STROBJ_vEnumStart, N, <NONE>,  'STROBJ_vEnumStart',  \
    SaveDC, N, <.hdc>,  'SaveDC',  \
    ScaleViewportExtEx, N, <.hdc, .nXnum, .nXdenom, .nYnum, .nYdenom, .lpSize>,  'ScaleViewportExtEx',  \
    ScaleWindowExtEx, N, <.hdc, .nXnum, .nXdenom, .nYnum, .nYdenom, .lpSize>,  'ScaleWindowExtEx',  \
    SelectBrushLocal, N, <NONE>,  'SelectBrushLocal',  \
    SelectClipPath, N, <.hdc, .iMode>,  'SelectClipPath',  \
    SelectClipRgn, N, <.hdc, .hRgn>,  'SelectClipRgn',  \
    SelectFontLocal, N, <NONE>,  'SelectFontLocal',  \
    SelectObject, N, <.hdc, .hObject>,  'SelectObject',  \
    SelectPalette, N, <.hdc, .hPalette, .bForceBackground>,  'SelectPalette',  \
    SetAbortProc, N, <.hDC, .lpAbortProc>,  'SetAbortProc',  \
    SetArcDirection, N, <.hdc, .ArcDirection>,  'SetArcDirection',  \
    SetBitmapAttributes, N, <NONE>,  'SetBitmapAttributes',  \
    SetBitmapBits, N, <.hBitmap, .dwCount, .lpBits>,  'SetBitmapBits',  \
    SetBitmapDimensionEx, N, <.hbm, .nX, .nY, .lpSize>,  'SetBitmapDimensionEx',  \
    SetBkColor, N, <.hdc, .crColor>,  'SetBkColor',  \
    SetBkMode, N, <.hdc, .nBkMode>,  'SetBkMode',  \
    SetBoundsRect, N, <.hdc, .lprcBounds, .flags>,  'SetBoundsRect',  \
    SetBrushAttributes, N, <NONE>,  'SetBrushAttributes',  \
    SetBrushOrgEx, N, <.hdc, .nXOrg, .nYOrg, .lppt>,  'SetBrushOrgEx',  \
    SetColorAdjustment, N, <.hdc, .lpca>,  'SetColorAdjustment',  \
    SetColorSpace, N, <.hdc, .hcolorspace>,  'SetColorSpace',  \
    SetDCBrushColor, N, <.hdc, .colorref>,  'SetDCBrushColor',  \
    SetDCPenColor, N, <.hdc, .colorref>,  'SetDCPenColor',  \
    SetDIBColorTable, N, <.hDC, .un1, .un2, .pcRGBQuad>,  'SetDIBColorTable',  \
    SetDIBits, N, <.hdc, .hBitmap, .nStartScan, .nNumScans, .lpBits, .lpBI, .wUsage>,  'SetDIBits',  \
    SetDIBitsToDevice, N, <.hdc, .x, .y, .dx, .dy, .SrcX, .SrcY, .Scan, .NumScans, .Bits, .BitsInfo, .wUsage>,  'SetDIBitsToDevice',  \
    SetDeviceGammaRamp, N, <.hdc, .lpv>,  'SetDeviceGammaRamp',  \
    SetEnhMetaFileBits, N, <.cbBuffer, .lpData>,  'SetEnhMetaFileBits',  \
    SetFontEnumeration, N, <NONE>,  'SetFontEnumeration',  \
    SetGraphicsMode, N, <.hdc, .iMode>,  'SetGraphicsMode',  \
    SetICMMode, N, <.hdc, .n>,  'SetICMMode',  \
    SetICMProfile, A, <.hdc, .lpStr>,  'SetICMProfileA',  \
    SetICMProfile, W, <.hdc, .lpStr>,  'SetICMProfileW',  \
    SetLayout, N, <.hdc, .dword>,  'SetLayout',  \
    SetLayoutWidth, N, <NONE>,  'SetLayoutWidth',  \
    SetMagicColors, N, <NONE>,  'SetMagicColors',  \
    SetMapMode, N, <.hdc, .nMapMode>,  'SetMapMode',  \
    SetMapperFlags, N, <.hdc, .dwFlag>,  'SetMapperFlags',  \
    SetMetaFileBitsEx, N, <.nSize, .lpData>,  'SetMetaFileBitsEx',  \
    SetMetaRgn, N, <.hdc>,  'SetMetaRgn',  \
    SetMiterLimit, N, <.hdc, .eNewLimit, .peOldLimit>,  'SetMiterLimit',  \
    SetPaletteEntries, N, <.hPalette, .wStartIndex, .wNumEntries, .lpPaletteEntries>,  'SetPaletteEntries',  \
    SetPixel, N, <.hdc, .x, .y, .crColor>,  'SetPixel',  \
    SetPixelFormat, N, <.hDC, .n, .pcPixelFormatDescriptor>,  'SetPixelFormat',  \
    SetPixelV, N, <.hdc, .x, .y, .crColor>,  'SetPixelV',  \
    SetPolyFillMode, N, <.hdc, .nPolyFillMode>,  'SetPolyFillMode',  \
    SetROP2, N, <.hdc, .nDrawMode>,  'SetROP2',  \
    SetRectRgn, N, <.hRgn, .X1, .Y1, .X2, .Y2>,  'SetRectRgn',  \
    SetRelAbs, N, <NONE>,  'SetRelAbs',  \
    SetStretchBltMode, N, <.hdc, .nStretchMode>,  'SetStretchBltMode',  \
    SetSystemPaletteUse, N, <.hdc, .wUsage>,  'SetSystemPaletteUse',  \
    SetTextAlign, N, <.hdc, .fMode>,  'SetTextAlign',  \
    SetTextCharacterExtra, N, <.hdc, .nCharExtra>,  'SetTextCharacterExtra',  \
    SetTextColor, N, <.hdc, .crColor>,  'SetTextColor',  \
    SetTextJustification, N, <.hdc, .nBreakExtra, .nBreakCount>,  'SetTextJustification',  \
    SetViewportExtEx, N, <.hdc, .nX, .nY, .lpSize>,  'SetViewportExtEx',  \
    SetViewportOrgEx, N, <.hdc, .nX, .nY, .lpPoint>,  'SetViewportOrgEx',  \
    SetVirtualResolution, N, <NONE>,  'SetVirtualResolution',  \
    SetWinMetaFileBits, N, <.cbBuffer, .lpbBuffer, .hdcRef, .lpmfp>,  'SetWinMetaFileBits',  \
    SetWindowExtEx, N, <.hdc, .nX, .nY, .lpSize>,  'SetWindowExtEx',  \
    SetWindowOrgEx, N, <.hdc, .nX, .nY, .lpPoint>,  'SetWindowOrgEx',  \
    SetWorldTransform, N, <.hdc, .lpXform>,  'SetWorldTransform',  \
    StartDoc, A, <.hdc, .lpdi>,  'StartDocA',  \
    StartDoc, W, <.hdc, .lpdi>,  'StartDocW',  \
    StartFormPage, N, <.hdc>,  'StartFormPage',  \
    StartPage, N, <.hdc>,  'StartPage',  \
    StretchBlt, N, <.hdc, .x, .y, .nWidth, .nHeight, .hSrcDC, .xSrc, .ySrc, .nSrcWidth, .nSrcHeight, .dwRop>,  'StretchBlt',  \
    StretchDIBits, N, <.hdc, .x, .y, .dx, .dy, .SrcX, .SrcY, .wSrcWidth, .wSrcHeight, .lpBits, .lpBitsInfo, .wUsage, .dwRop>,  'StretchDIBits',  \
    StrokeAndFillPath, N, <.hdc>,  'StrokeAndFillPath',  \
    StrokePath, N, <.hdc>,  'StrokePath',  \
    SwapBuffers, N, <.hDC>,  'SwapBuffers',  \
    TextOut, A, <.hdc, .x, .y, .lpString, .nCount>,  'TextOutA',  \
    TextOut, W, <.hdc, .x, .y, .lpString, .nCount>,  'TextOutW',  \
    TranslateCharsetInfo, N, <.lpSrc, .lpcs, .dwFlags>,  'TranslateCharsetInfo',  \
    UnloadNetworkFonts, N, <NONE>,  'UnloadNetworkFonts',  \
    UnrealizeObject, N, <.hObject>,  'UnrealizeObject',  \
    UpdateColors, N, <.hdc>,  'UpdateColors',  \
    UpdateICMRegKey, A, <.dword, .lpstr, .uint>,  'UpdateICMRegKeyA',  \
    UpdateICMRegKey, W, <.dword, .lpstr, .uint>,  'UpdateICMRegKeyW',  \
    WidenPath, N, <.hdc>,  'WidenPath',  \
    XFORMOBJ_bApplyXform, N, <NONE>,  'XFORMOBJ_bApplyXform',  \
    XFORMOBJ_iGetXform, N, <NONE>,  'XFORMOBJ_iGetXform',  \
    XLATEOBJ_cGetPalette, N, <NONE>,  'XLATEOBJ_cGetPalette',  \
    XLATEOBJ_hGetColorTransform, N, <NONE>,  'XLATEOBJ_hGetColorTransform',  \
    XLATEOBJ_iXlate, N, <NONE>,  'XLATEOBJ_iXlate',  \
    XLATEOBJ_piVector, N, <NONE>,  'XLATEOBJ_piVector',  \
    bInitSystemAndFontsDirectories, W, <NONE>,  'bInitSystemAndFontsDirectoriesW',  \
    bMakePathName, W, <NONE>,  'bMakePathNameW',  \
    cGetTTFFromFOT, N, <NONE>,  'cGetTTFFromFOT',  \
    gdiPlaySpoolStream, N, <NONE>,  'gdiPlaySpoolStream'
