; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "Fresh artistic license."         |
;|_______________________________________________________________________________________|
;
;  Description: ole32.dll API calls
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


import_proto ole32,  \
    BindMoniker, N, <.pmk, .grfOpt, .iidResult, .ppvResult>,  'BindMoniker',  \
    CLIPFORMAT_UserFree, N, <.pLong, .pClipformat>,  'CLIPFORMAT_UserFree',  \
    CLIPFORMAT_UserMarshal, N, <.pLong, .pChar, .pClipformat>,  'CLIPFORMAT_UserMarshal',  \
    CLIPFORMAT_UserSize, N, <.pLong, .lLong, .pClipformat>,  'CLIPFORMAT_UserSize',  \
    CLIPFORMAT_UserUnmarshal, N, <.pLong, .pChar, .pClipformat>,  'CLIPFORMAT_UserUnmarshal',  \
    CLSIDFromOle1Class, N, <NONE>,  'CLSIDFromOle1Class',  \
    CLSIDFromProgID, N, <.TSzProgID, .T>,  'CLSIDFromProgID',  \
    CLSIDFromProgIDEx, N, <.lpszProgID, .lpclsid>,  'CLSIDFromProgIDEx',  \
    CLSIDFromString, N, <.lpsz, .pclsid>,  'CLSIDFromString',  \
    CoAddRefServerProcess, N, <VOID>,  'CoAddRefServerProcess',  \
    CoAllowSetForegroundWindow, N, <.pUnk, .lpvReserved>,  'CoAllowSetForegroundWindow',  \
    CoBuildVersion, N, <VOID>,  'CoBuildVersion',  \
    CoCancelCall, N, <.dwThreadId, .ulTimeout>,  'CoCancelCall',  \
    CoCopyProxy, N, <.pProxy, .ppCopy>,  'CoCopyProxy',  \
    CoCreateFreeThreadedMarshaler, N, <.punkOuter, .ppunkMarshal>,  'CoCreateFreeThreadedMarshaler',  \
    CoCreateGuid, N, <.pguid>,  'CoCreateGuid',  \
    CoCreateInstance, N, <.rclsid, .pUnkOuter, .dwClsContext, .riid, .ppv>,  'CoCreateInstance',  \
    CoCreateInstanceEx, N, <.Clsid, .punkOuter, .dwClsCtx, .pServerInfo, .dwCount, .pResults>,  'CoCreateInstanceEx',  \
    CoCreateObjectInContext, N, <NONE>,  'CoCreateObjectInContext',  \
    CoDeactivateObject, N, <NONE>,  'CoDeactivateObject',  \
    CoDisableCallCancellation, N, <.pReserved>,  'CoDisableCallCancellation',  \
    CoDisconnectObject, N, <.pUnk, .dwReserved>,  'CoDisconnectObject',  \
    CoDosDateTimeToFileTime, N, <.nDosDate, .nDosTime, .lpFileTime>,  'CoDosDateTimeToFileTime',  \
    CoEnableCallCancellation, N, <.pReserved>,  'CoEnableCallCancellation',  \
    CoFileTimeNow, N, <.lpFileTime>,  'CoFileTimeNow',  \
    CoFileTimeToDosDateTime, N, <.lpFileTime, .lpDosDate, .lpDosTime>,  'CoFileTimeToDosDateTime',  \
    CoFreeAllLibraries, N, <VOID>,  'CoFreeAllLibraries',  \
    CoFreeLibrary, N, <.hInst>,  'CoFreeLibrary',  \
    CoFreeUnusedLibraries, N, <VOID>,  'CoFreeUnusedLibraries',  \
    CoFreeUnusedLibrariesEx, N, <NONE>,  'CoFreeUnusedLibrariesEx',  \
    CoGetApartmentID, N, <NONE>,  'CoGetApartmentID',  \
    CoGetCallContext, N, <.riid, .ppInterface>,  'CoGetCallContext',  \
    CoGetCallerTID, N, <NONE>,  'CoGetCallerTID',  \
    CoGetCancelObject, N, <.dwThreadId, .iid, .ppUnk>,  'CoGetCancelObject',  \
    CoGetClassObject, N, <.rclsid, .dwClsContext, .pvReserved, .riid, .ppv>,  'CoGetClassObject',  \
    CoGetClassVersion, N, <.pClassSpec, .pdwVersionMS, .pdwVersionLS>,  'CoGetClassVersion',  \
    CoGetComCatalog, N, <NONE>,  'CoGetComCatalog',  \
    CoGetContextToken, N, <NONE>,  'CoGetContextToken',  \
    CoGetCurrentLogicalThreadId, N, <NONE>,  'CoGetCurrentLogicalThreadId',  \
    CoGetCurrentProcess, N, <VOID>,  'CoGetCurrentProcess',  \
    CoGetDefaultContext, N, <NONE>,  'CoGetDefaultContext',  \
    CoGetInstanceFromFile, N, <.pServerInfo, .pClsid, .punkOuter, .dwClsCtx, .grfMode, .pwszName, .dwCount, .pResults>,  'CoGetInstanceFromFile',  \
    CoGetInstanceFromIStorage, N, <.pServerInfo, .pClsid, .punkOuter, .dwClsCtx, .pstg, .dwCount, .pResults>,  'CoGetInstanceFromIStorage',  \
    CoGetInterceptor, N, <NONE>,  'CoGetInterceptor',  \
    CoGetInterceptorFromTypeInfo, N, <NONE>,  'CoGetInterceptorFromTypeInfo',  \
    CoGetInterfaceAndReleaseStream, N, <.pStm, .iid, .ppv>,  'CoGetInterfaceAndReleaseStream',  \
    CoGetMalloc, N, <.dwMemContext, .ppMalloc>,  'CoGetMalloc',  \
    CoGetMarshalSizeMax, N, <.pulSize, .riid, .pUnk, .dwDestContext, .pvDestContext, .mshlflags>,  'CoGetMarshalSizeMax',  \
    CoGetObject, N, <.pszName, .pBindOptions, .riid, .ppv>,  'CoGetObject',  \
    CoGetObjectContext, N, <.riid, .ppv>,  'CoGetObjectContext',  \
    CoGetPSClsid, N, <.riid, .pClsid>,  'CoGetPSClsid',  \
    CoGetProcessIdentifier, N, <NONE>,  'CoGetProcessIdentifier',  \
    CoGetStandardMarshal, N, <.riid, .pUnk, .dwDestContext, .pvDestContext, .mshlflags, .ppMarshal>,  'CoGetStandardMarshal',  \
    CoGetState, N, <NONE>,  'CoGetState',  \
    CoGetStdMarshalEx, N, <.pUnkOuter, .smexflags, .ppUnkInner>,  'CoGetStdMarshalEx',  \
    CoGetSystemSecurityPermissions, N, <NONE>,  'CoGetSystemSecurityPermissions',  \
    CoGetTreatAsClass, N, <.clsidOld, .pClsidNew>,  'CoGetTreatAsClass',  \
    CoImpersonateClient, N, <VOID>,  'CoImpersonateClient',  \
    CoInitialize, N, <.pzReserved>,  'CoInitialize',  \
    CoInitializeEx, N, <.pvReserved, .dwCoInit>,  'CoInitializeEx',  \
    CoInitializeSecurity, N, <.pSecDesc, .cAuthSvc, .asAuthSvc, .pReserved1, .dwAuthnLevel, .dwImpLevel, .pAuthList, .dwCapabilities, .pReserved3>,  'CoInitializeSecurity',  \
    CoInitializeWO, W, <NONE>,  'CoInitializeWOW',  \
    CoInstall, N, <.pbc, .dwFlags, .pClassSpec, .pQuery, .pszCodeBase>,  'CoInstall',  \
    CoInvalidateRemoteMachineBindings, N, <NONE>,  'CoInvalidateRemoteMachineBindings',  \
    CoIsHandlerConnected, N, <.pUnk>,  'CoIsHandlerConnected',  \
    CoIsOle1Class, N, <.rclsid>,  'CoIsOle1Class',  \
    CoLoadLibrary, N, <.lpszLibName, .bAutoFree>,  'CoLoadLibrary',  \
    CoLockObjectExternal, N, <.pUnk, .fLock, .fLastUnlockReleases>,  'CoLockObjectExternal',  \
    CoMarshalHresult, N, <.pstm, .hresult>,  'CoMarshalHresult',  \
    CoMarshalInterThreadInterfaceInStream, N, <.riid, .pUnk, .ppStm>,  'CoMarshalInterThreadInterfaceInStream',  \
    CoMarshalInterface, N, <.pStm, .riid, .pUnk, .dwDestContext, .pvDestContext, .mshlflags>,  'CoMarshalInterface',  \
    CoPopServiceDomain, N, <NONE>,  'CoPopServiceDomain',  \
    CoPushServiceDomain, N, <NONE>,  'CoPushServiceDomain',  \
    CoQueryAuthenticationServices, N, <.pcAuthSvc, .asAuthSvc>,  'CoQueryAuthenticationServices',  \
    CoQueryClientBlanket, N, <.pAuthnSvc, .pAuthzSvc, .pServerPrincName, .pAuthnLevel, .pImpLevel, .pPrivs, .pCapabilities>,  'CoQueryClientBlanket',  \
    CoQueryProxyBlanket, N, <.pProxy, .pwAuthnSvc, .pAuthzSvc, .pServerPrincName, .pAuthnLevel, .pImpLevel, .pAuthInfo, .pCapabilites>,  'CoQueryProxyBlanket',  \
    CoQueryReleaseObject, N, <NONE>,  'CoQueryReleaseObject',  \
    CoReactivateObject, N, <NONE>,  'CoReactivateObject',  \
    CoRegisterChannelHook, N, <.ExtensionUuid, .pChannelHook>,  'CoRegisterChannelHook',  \
    CoRegisterClassObject, N, <.rclsid, .pUnk, .dwClsContext, .flags, .lpdwRegister>,  'CoRegisterClassObject',  \
    CoRegisterInitializeSpy, N, <NONE>,  'CoRegisterInitializeSpy',  \
    CoRegisterMallocSpy, N, <.pMallocSpy>,  'CoRegisterMallocSpy',  \
    CoRegisterMessageFilter, N, <.lpMessageFilter, .lplpMessageFilter>,  'CoRegisterMessageFilter',  \
    CoRegisterPSClsid, N, <.riid, .rclsid>,  'CoRegisterPSClsid',  \
    CoRegisterSurrogate, N, <.pSurrogate>,  'CoRegisterSurrogate',  \
    CoRegisterSurrogateEx, N, <NONE>,  'CoRegisterSurrogateEx',  \
    CoReleaseMarshalData, N, <.pStm>,  'CoReleaseMarshalData',  \
    CoReleaseServerProcess, N, <VOID>,  'CoReleaseServerProcess',  \
    CoResumeClassObjects, N, <VOID>,  'CoResumeClassObjects',  \
    CoRetireServer, N, <NONE>,  'CoRetireServer',  \
    CoRevertToSelf, N, <VOID>,  'CoRevertToSelf',  \
    CoRevokeClassObject, N, <.dwRegister>,  'CoRevokeClassObject',  \
    CoRevokeInitializeSpy, N, <NONE>,  'CoRevokeInitializeSpy',  \
    CoRevokeMallocSpy, N, <VOID>,  'CoRevokeMallocSpy',  \
    CoSetCancelObject, N, <.pUnk>,  'CoSetCancelObject',  \
    CoSetProxyBlanket, N, <.pProxy, .dwAuthnSvc, .dwAuthzSvc, .pServerPrincName, .dwAuthnLevel, .dwImpLevel, .pAuthInfo, .dwCapabilities>,  'CoSetProxyBlanket',  \
    CoSetState, N, <NONE>,  'CoSetState',  \
    CoSuspendClassObjects, N, <VOID>,  'CoSuspendClassObjects',  \
    CoSwitchCallContext, N, <.pNewObject, .ppOldObject>,  'CoSwitchCallContext',  \
    CoTaskMemAlloc, N, <.cb>,  'CoTaskMemAlloc',  \
    CoTaskMemFree, N, <.lpIDList>,  'CoTaskMemFree',  \
    CoTaskMemRealloc, N, <.pv, .cb>,  'CoTaskMemRealloc',  \
    CoTestCancel, N, <VOID>,  'CoTestCancel',  \
    CoTreatAsClass, N, <.clsidOld, .clsidNew>,  'CoTreatAsClass',  \
    CoUninitialize, N, <VOID>,  'CoUninitialize',  \
    CoUnloadingWO, W, <NONE>,  'CoUnloadingWOW',  \
    CoUnmarshalHresult, N, <.pstm, .phresult>,  'CoUnmarshalHresult',  \
    CoUnmarshalInterface, N, <.pStm, .riid, .ppv>,  'CoUnmarshalInterface',  \
    CoWaitForMultipleHandles, N, <.dwFlags, .dwTimeout, .cHandles, .pHandles, .lpdwindex>,  'CoWaitForMultipleHandles',  \
    ComPs_CStdStubBuffer_AddRef, N, <NONE>,  'ComPs_CStdStubBuffer_AddRef',  \
    ComPs_CStdStubBuffer_Connect, N, <NONE>,  'ComPs_CStdStubBuffer_Connect',  \
    ComPs_CStdStubBuffer_CountRefs, N, <NONE>,  'ComPs_CStdStubBuffer_CountRefs',  \
    ComPs_CStdStubBuffer_DebugServerQueryInterface, N, <NONE>,  'ComPs_CStdStubBuffer_DebugServerQueryInterface',  \
    ComPs_CStdStubBuffer_DebugServerRelease, N, <NONE>,  'ComPs_CStdStubBuffer_DebugServerRelease',  \
    ComPs_CStdStubBuffer_Disconnect, N, <NONE>,  'ComPs_CStdStubBuffer_Disconnect',  \
    ComPs_CStdStubBuffer_Invoke, N, <NONE>,  'ComPs_CStdStubBuffer_Invoke',  \
    ComPs_CStdStubBuffer_IsIIDSupported, N, <NONE>,  'ComPs_CStdStubBuffer_IsIIDSupported',  \
    ComPs_CStdStubBuffer_QueryInterface, N, <NONE>,  'ComPs_CStdStubBuffer_QueryInterface',  \
    ComPs_IUnknown_AddRef_Proxy, N, <NONE>,  'ComPs_IUnknown_AddRef_Proxy',  \
    ComPs_IUnknown_QueryInterface_Proxy, N, <NONE>,  'ComPs_IUnknown_QueryInterface_Proxy',  \
    ComPs_IUnknown_Release_Proxy, N, <NONE>,  'ComPs_IUnknown_Release_Proxy',  \
    ComPs_NdrCStdStubBuffer2_Release, N, <NONE>,  'ComPs_NdrCStdStubBuffer2_Release',  \
    ComPs_NdrCStdStubBuffer_Release, N, <NONE>,  'ComPs_NdrCStdStubBuffer_Release',  \
    ComPs_NdrClientCall2, N, <NONE>,  'ComPs_NdrClientCall2',  \
    ComPs_NdrClientCall2_va, N, <NONE>,  'ComPs_NdrClientCall2_va',  \
    ComPs_NdrDllCanUnloadNow, N, <NONE>,  'ComPs_NdrDllCanUnloadNow',  \
    ComPs_NdrDllGetClassObject, N, <NONE>,  'ComPs_NdrDllGetClassObject',  \
    ComPs_NdrDllRegisterProxy, N, <NONE>,  'ComPs_NdrDllRegisterProxy',  \
    ComPs_NdrDllUnregisterProxy, N, <NONE>,  'ComPs_NdrDllUnregisterProxy',  \
    ComPs_NdrStubCall2, N, <NONE>,  'ComPs_NdrStubCall2',  \
    ComPs_NdrStubForwardingFunction, N, <NONE>,  'ComPs_NdrStubForwardingFunction',  \
    CreateAntiMoniker, N, <.ppmk>,  'CreateAntiMoniker',  \
    CreateBindCtx, N, <.reserved, .ppbc>,  'CreateBindCtx',  \
    CreateClassMoniker, N, <.rclsid, .ppmk>,  'CreateClassMoniker',  \
    CreateDataAdviseHolder, N, <.ppDAHolder>,  'CreateDataAdviseHolder',  \
    CreateDataCache, N, <.pUnkOuter, .rclsid, .iid, .ppv>,  'CreateDataCache',  \
    CreateErrorInfo, N, <.pperrinfo>,  'CreateErrorInfo',  \
    CreateFileMoniker, N, <.lpszPathName, .ppmk>,  'CreateFileMoniker',  \
    CreateGenericComposite, N, <.pmkFirst, .pmkRest, .ppmkComposite>,  'CreateGenericComposite',  \
    CreateILockBytesOnHGlobal, N, <.hGlobal, .fDeleteOnRelease, .pplkbyt>,  'CreateILockBytesOnHGlobal',  \
    CreateItemMoniker, N, <.lpszDelim, .lpszItem, .ppmk>,  'CreateItemMoniker',  \
    CreateObjrefMoniker, N, <.punk, .ppmk>,  'CreateObjrefMoniker',  \
    CreateOleAdviseHolder, N, <.ppOAHolder>,  'CreateOleAdviseHolder',  \
    CreatePointerMoniker, N, <.punk, .ppmk>,  'CreatePointerMoniker',  \
    CreateStdProgressIndicator, N, <.hwndParent, .pszTitle, .pIbscCaller, .ppIbsc>,  'CreateStdProgressIndicator',  \
    CreateStreamOnHGlobal, N, <.hGlobal, .fDeleteOnRelease, .ppstm>,  'CreateStreamOnHGlobal',  \
    DcomChannelSetHResult, N, <NONE>,  'DcomChannelSetHResult',  \
    DllDebugObjectRPCHook, N, <NONE>,  'DllDebugObjectRPCHook',  \
    DllGetClassObjectWO, W, <NONE>,  'DllGetClassObjectWOW',  \
\;    DllRegisterServer, N, <VOID>,  'DllRegisterServer',  \
    DoDragDrop, N, <.pDataObj, .pDropSource, .dwOKEffects, .pdwEffect>,  'DoDragDrop',  \
    EnableHookObject, N, <NONE>,  'EnableHookObject',  \
    FmtIdToPropStgName, N, <.pfmtid, .oszName>,  'FmtIdToPropStgName',  \
    FreePropVariantArray, N, <.cVariants, .rgvars>,  'FreePropVariantArray',  \
    GetClassFile, N, <.szFilename, .pclsid>,  'GetClassFile',  \
    GetConvertStg, N, <.pStg>,  'GetConvertStg',  \
    GetDocumentBitStg, N, <NONE>,  'GetDocumentBitStg',  \
    GetErrorInfo, N, <.dwReserved, .pperrinfo>,  'GetErrorInfo',  \
    GetHGlobalFromILockBytes, N, <.plkbyt, .phglobal>,  'GetHGlobalFromILockBytes',  \
    GetHGlobalFromStream, N, <.pstm, .phglobal>,  'GetHGlobalFromStream',  \
    GetHookInterface, N, <NONE>,  'GetHookInterface',  \
    GetRunningObjectTable, N, <.reserved, .pprot>,  'GetRunningObjectTable',  \
    HACCEL_UserFree, N, <.pLong, .pHaccel>,  'HACCEL_UserFree',  \
    HACCEL_UserMarshal, N, <.pLong, .pChar, .pHaccel>,  'HACCEL_UserMarshal',  \
    HACCEL_UserSize, N, <.pLong, .lLong, .pHaccel>,  'HACCEL_UserSize',  \
    HACCEL_UserUnmarshal, N, <.pLong, .pChar, .pHaccel>,  'HACCEL_UserUnmarshal',  \
    HBITMAP_UserFree, N, <.pLong, .pHbitmap>,  'HBITMAP_UserFree',  \
    HBITMAP_UserMarshal, N, <.pLong, .pChar, .pHbitmap>,  'HBITMAP_UserMarshal',  \
    HBITMAP_UserSize, N, <.pLong, .lLong, .pHbitmap>,  'HBITMAP_UserSize',  \
    HBITMAP_UserUnmarshal, N, <.pLong, .pChar, .pHbitmap>,  'HBITMAP_UserUnmarshal',  \
    HBRUSH_UserFree, N, <NONE>,  'HBRUSH_UserFree',  \
    HBRUSH_UserMarshal, N, <NONE>,  'HBRUSH_UserMarshal',  \
    HBRUSH_UserSize, N, <NONE>,  'HBRUSH_UserSize',  \
    HBRUSH_UserUnmarshal, N, <NONE>,  'HBRUSH_UserUnmarshal',  \
    HDC_UserFree, N, <.pLong, .pHdc>,  'HDC_UserFree',  \
    HDC_UserMarshal, N, <.pLong, .pChar, .pHdc>,  'HDC_UserMarshal',  \
    HDC_UserSize, N, <.pLong, .lLong, .pHdc>,  'HDC_UserSize',  \
    HDC_UserUnmarshal, N, <.pLong, .pChar, .pHdc>,  'HDC_UserUnmarshal',  \
    HENHMETAFILE_UserFree, N, <NONE>,  'HENHMETAFILE_UserFree',  \
    HENHMETAFILE_UserMarshal, N, <NONE>,  'HENHMETAFILE_UserMarshal',  \
    HENHMETAFILE_UserSize, N, <NONE>,  'HENHMETAFILE_UserSize',  \
    HENHMETAFILE_UserUnmarshal, N, <NONE>,  'HENHMETAFILE_UserUnmarshal',  \
    HGLOBAL_UserFree, N, <.pLong, .pHglobal>,  'HGLOBAL_UserFree',  \
    HGLOBAL_UserMarshal, N, <.pLong, .pChar, .pHglobal>,  'HGLOBAL_UserMarshal',  \
    HGLOBAL_UserSize, N, <.pLong, .lLong, .pHglobal>,  'HGLOBAL_UserSize',  \
    HGLOBAL_UserUnmarshal, N, <.pLong, .pChar, .pHglobal>,  'HGLOBAL_UserUnmarshal',  \
    HICON_UserFree, N, <.pLong, .pHicon>,  'HICON_UserFree',  \
    HICON_UserMarshal, N, <.pLong, .pChar, .pHicon>,  'HICON_UserMarshal',  \
    HICON_UserSize, N, <.pLong, .llong, .pHicon>,  'HICON_UserSize',  \
    HICON_UserUnmarshal, N, <.pLong, .pChar, .pHicon>,  'HICON_UserUnmarshal',  \
    HMENU_UserFree, N, <.pLong, .pHmenu>,  'HMENU_UserFree',  \
    HMENU_UserMarshal, N, <.pLong, .pChar, .pHmenu>,  'HMENU_UserMarshal',  \
    HMENU_UserSize, N, <.pLong, .lLong, .pHmenu>,  'HMENU_UserSize',  \
    HMENU_UserUnmarshal, N, <.pLong, .pChar, .pHmenu>,  'HMENU_UserUnmarshal',  \
    HMETAFILEPICT_UserFree, N, <NONE>,  'HMETAFILEPICT_UserFree',  \
    HMETAFILEPICT_UserMarshal, N, <NONE>,  'HMETAFILEPICT_UserMarshal',  \
    HMETAFILEPICT_UserSize, N, <NONE>,  'HMETAFILEPICT_UserSize',  \
    HMETAFILEPICT_UserUnmarshal, N, <NONE>,  'HMETAFILEPICT_UserUnmarshal',  \
    HMETAFILE_UserFree, N, <NONE>,  'HMETAFILE_UserFree',  \
    HMETAFILE_UserMarshal, N, <NONE>,  'HMETAFILE_UserMarshal',  \
    HMETAFILE_UserSize, N, <NONE>,  'HMETAFILE_UserSize',  \
    HMETAFILE_UserUnmarshal, N, <NONE>,  'HMETAFILE_UserUnmarshal',  \
    HPALETTE_UserFree, N, <.pLong, .pHpalette>,  'HPALETTE_UserFree',  \
    HPALETTE_UserMarshal, N, <.pLong, .pChar, .pHpalette>,  'HPALETTE_UserMarshal',  \
    HPALETTE_UserSize, N, <.pLong, .lLong, .pHpalette>,  'HPALETTE_UserSize',  \
    HPALETTE_UserUnmarshal, N, <.pLong, .pChar, .pHpalette>,  'HPALETTE_UserUnmarshal',  \
    HWND_UserFree, N, <.pLong, .pHwnd>,  'HWND_UserFree',  \
    HWND_UserMarshal, N, <.pLong, .pChar, .pHwnd>,  'HWND_UserMarshal',  \
    HWND_UserSize, N, <.pLong, .lLong, .pHwnd>,  'HWND_UserSize',  \
    HWND_UserUnmarshal, N, <.pLong, .pChar, .pHwnd>,  'HWND_UserUnmarshal',  \
    HkOleRegisterObject, N, <NONE>,  'HkOleRegisterObject',  \
    IIDFromString, N, <.lpsz, .lpiid>,  'IIDFromString',  \
    IsAccelerator, N, <.hAccel, .cAccelEntries, .lpMsg, .lpwCmd>,  'IsAccelerator',  \
    IsEqualGUID, N, <NONE>,  'IsEqualGUID',  \
    IsValidIid, N, <NONE>,  'IsValidIid',  \
    IsValidInterface, N, <NONE>,  'IsValidInterface',  \
    IsValidPtrIn, N, <NONE>,  'IsValidPtrIn',  \
    IsValidPtrOut, N, <NONE>,  'IsValidPtrOut',  \
    MkParseDisplayName, N, <.pbc, .szUserName, .pchEaten, .ppmk>,  'MkParseDisplayName',  \
    MonikerCommonPrefixWith, N, <.pmkThis, .pmkOther, .ppmkCommon>,  'MonikerCommonPrefixWith',  \
    MonikerRelativePathTo, N, <.pmkSrc, .pmkDest, .ppmkRelPath, .dwReserved>,  'MonikerRelativePathTo',  \
    OleBuildVersion, N, <VOID>,  'OleBuildVersion',  \
    OleConvertIStorageToOLESTREAM, N, <.pstg, .lpolestream>,  'OleConvertIStorageToOLESTREAM',  \
    OleConvertIStorageToOLESTREAMEx, N, <.pstg, .cfFormat, .lWidth, .lHeight, .dwSize, .pmedium, .polestm>,  'OleConvertIStorageToOLESTREAMEx',  \
    OleConvertOLESTREAMToIStorage, N, <.lpolestream, .pstg, .ptd>,  'OleConvertOLESTREAMToIStorage',  \
    OleConvertOLESTREAMToIStorageEx, N, <.polestm, .pstg, .pcfFormat, .plwWidth, .plHeight, .pdwSize, .pmedium>,  'OleConvertOLESTREAMToIStorageEx',  \
    OleCreate, N, <.rclsid, .riid, .renderopt, .pFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreate',  \
    OleCreateDefaultHandler, N, <.clsid, .pUnkOuter, .riid, .lplpObj>,  'OleCreateDefaultHandler',  \
    OleCreateEmbeddingHelper, N, <.clsid, .pUnkOuter, .flags, .pCF, .riid, .lplpObj>,  'OleCreateEmbeddingHelper',  \
    OleCreateEx, N, <.rclsid, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection, .pClientSite, .pStg, .ppvObj>,  'OleCreateEx',  \
    OleCreateFromData, N, <.pSrcDataObj, .riid, .renderopt, .pFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateFromData',  \
    OleCreateFromDataEx, N, <.pSrcDataObj, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection, .pClientSite, .pStg, .ppvObj>,  'OleCreateFromDataEx',  \
    OleCreateFromFile, N, <.rclsid, .lpszFileName, .riid, .renderopt, .lpFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateFromFile',  \
    OleCreateFromFileEx, N, <.rclsid, .lpszFileName, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection, .pClientSite, .pStg, .ppvObj>,  'OleCreateFromFileEx',  \
    OleCreateLink, N, <.pmkLinkSrc, .riid, .renderopt, .lpFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateLink',  \
    OleCreateLinkEx, N, <.pmkLinkSrc, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection, .pClientSite, .pStg, .ppvObj>,  'OleCreateLinkEx',  \
    OleCreateLinkFromData, N, <.pSrcDataObj, .riid, .renderopt, .pFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateLinkFromData',  \
    OleCreateLinkFromDataEx, N, <.pSrcDataObj, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection, .pClientSite, .pStg, .ppvObj>,  'OleCreateLinkFromDataEx',  \
    OleCreateLinkToFile, N, <.lpszFileName, .riid, .renderopt, .lpFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateLinkToFile',  \
    OleCreateLinkToFileEx, N, <.lpszFileName, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection, .pClientSite, .pStg, .ppvObj>,  'OleCreateLinkToFileEx',  \
    OleCreateMenuDescriptor, N, <.hmenuCombined, .lpMenuWidths>,  'OleCreateMenuDescriptor',  \
    OleCreateStaticFromData, N, <.pSrcDataObj, .iid, .renderopt, .pFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateStaticFromData',  \
    OleDestroyMenuDescriptor, N, <.holemenu>,  'OleDestroyMenuDescriptor',  \
    OleDoAutoConvert, N, <.pStg, .pClsidNew>,  'OleDoAutoConvert',  \
    OleDraw, N, <.pUnknown, .dwAspect, .hdcDraw, .lprcBounds>,  'OleDraw',  \
    OleDuplicateData, N, <.hSrc, .cfFormat, .uiFlags>,  'OleDuplicateData',  \
    OleFlushClipboard, N, <VOID>,  'OleFlushClipboard',  \
    OleGetAutoConvert, N, <.clsidOld, .pClsidNew>,  'OleGetAutoConvert',  \
    OleGetClipboard, N, <.ppDataObj>,  'OleGetClipboard',  \
    OleGetIconOfClass, N, <.rclsid, .lpszLabel, .fUseTypeAsLabel>,  'OleGetIconOfClass',  \
    OleGetIconOfFile, N, <.lpszPath, .fUseFileAsLabel>,  'OleGetIconOfFile',  \
    OleInitialize, N, <.pvReserved>,  'OleInitialize',  \
    OleInitializeWO, W, <NONE>,  'OleInitializeWOW',  \
    OleIsCurrentClipboard, N, <.pDataObj>,  'OleIsCurrentClipboard',  \
    OleIsRunning, N, <.pObject>,  'OleIsRunning',  \
    OleLoad, N, <.pStg, .riid, .pClientSite, .ppvObj>,  'OleLoad',  \
    OleLoadFromStream, N, <.pStm, .iidInterface, .ppvObj>,  'OleLoadFromStream',  \
    OleLockRunning, N, <.pUnknown, .fLock, .fLastUnlockCloses>,  'OleLockRunning',  \
    OleMetafilePictFromIconAndLabel, N, <.hIcon, .lpszLabel, .lpszSourceFile, .iIconIndex>,  'OleMetafilePictFromIconAndLabel',  \
    OleNoteObjectVisible, N, <.pUnknown, .fVisible>,  'OleNoteObjectVisible',  \
    OleQueryCreateFromData, N, <.pSrcDataObject>,  'OleQueryCreateFromData',  \
    OleQueryLinkFromData, N, <.pSrcDataObject>,  'OleQueryLinkFromData',  \
    OleRegEnumFormatEtc, N, <.clsid, .dwDirection, .ppenum>,  'OleRegEnumFormatEtc',  \
    OleRegEnumVerbs, N, <.clsid, .ppenum>,  'OleRegEnumVerbs',  \
    OleRegGetMiscStatus, N, <.clsid, .dwAspect, .pdwStatus>,  'OleRegGetMiscStatus',  \
    OleRegGetUserType, N, <.clsid, .dwFormOfType, .pszUserType>,  'OleRegGetUserType',  \
    OleRun, N, <.pUnknown>,  'OleRun',  \
    OleSave, N, <.pPS, .pStg, .fSameAsLoad>,  'OleSave',  \
    OleSaveToStream, N, <.pPStm, .pStm>,  'OleSaveToStream',  \
    OleSetAutoConvert, N, <.clsidOld, .clsidNew>,  'OleSetAutoConvert',  \
    OleSetClipboard, N, <.pDataObj>,  'OleSetClipboard',  \
    OleSetContainedObject, N, <.pUnknown, .fContained>,  'OleSetContainedObject',  \
    OleSetMenuDescriptor, N, <.holemenu, .hwndFrame, .hwndActiveObject, .lpFrame, .lpActiveObj>,  'OleSetMenuDescriptor',  \
    OleTranslateAccelerator, N, <.lpFrame, .lpFrameInfo, .lpmsg>,  'OleTranslateAccelerator',  \
    OleUninitialize, N, <VOID>,  'OleUninitialize',  \
    OpenOrCreateStream, N, <NONE>,  'OpenOrCreateStream',  \
    ProgIDFromCLSID, N, <.clsid, .lplpszProgID>,  'ProgIDFromCLSID',  \
    PropStgNameToFmtId, N, <.oszName, .pfmtid>,  'PropStgNameToFmtId',  \
    PropSysAllocString, N, <NONE>,  'PropSysAllocString',  \
    PropSysFreeString, N, <NONE>,  'PropSysFreeString',  \
    PropVariantChangeType, N, <NONE>,  'PropVariantChangeType',  \
    PropVariantClear, N, <.pvar>,  'PropVariantClear',  \
    PropVariantCopy, N, <.pvarDest, .pvarSrc>,  'PropVariantCopy',  \
    ReadClassStg, N, <.pStg, .pclsid>,  'ReadClassStg',  \
    ReadClassStm, N, <.pStm, .pclsid>,  'ReadClassStm',  \
    ReadFmtUserTypeStg, N, <.pstg, .pcf, .lplpszUserType>,  'ReadFmtUserTypeStg',  \
    ReadOleStg, N, <NONE>,  'ReadOleStg',  \
    ReadStringStream, N, <NONE>,  'ReadStringStream',  \
    RegisterDragDrop, N, <.hwnd, .pDropTarget>,  'RegisterDragDrop',  \
    ReleaseStgMedium, N, <.lpstgmedium>,  'ReleaseStgMedium',  \
    RevokeDragDrop, N, <.hwnd>,  'RevokeDragDrop',  \
    SNB_UserFree, N, <.pLong, .pSnb>,  'SNB_UserFree',  \
    SNB_UserMarshal, N, <.pLong, .pChar, .pSnb>,  'SNB_UserMarshal',  \
    SNB_UserSize, N, <.pLong, .lLong, .pSnb>,  'SNB_UserSize',  \
    SNB_UserUnmarshal, N, <.pLong, .pChar, .pSnb>,  'SNB_UserUnmarshal',  \
    STGMEDIUM_UserFree, N, <.pLong, .pStgmedium>,  'STGMEDIUM_UserFree',  \
    STGMEDIUM_UserMarshal, N, <.pLong, .pChar, .pStgmedium>,  'STGMEDIUM_UserMarshal',  \
    STGMEDIUM_UserSize, N, <.pLong, .long, .pStgmedium>,  'STGMEDIUM_UserSize',  \
    STGMEDIUM_UserUnmarshal, N, <.pLong, .pChar, .pStgmedium>,  'STGMEDIUM_UserUnmarshal',  \
    SetConvertStg, N, <.pStg, .fConvert>,  'SetConvertStg',  \
    SetDocumentBitStg, N, <NONE>,  'SetDocumentBitStg',  \
    SetErrorInfo, N, <.dwReserved, .perrinfo>,  'SetErrorInfo',  \
    StgConvertPropertyToVariant, N, <NONE>,  'StgConvertPropertyToVariant',  \
    StgConvertVariantToProperty, N, <NONE>,  'StgConvertVariantToProperty',  \
    StgCreateDocfile, N, <.pwcsName, .grfMode, .reserved, .ppstgOpen>,  'StgCreateDocfile',  \
    StgCreateDocfileOnILockBytes, N, <.plkbyt, .grfMode, .reserved, .ppstgOpen>,  'StgCreateDocfileOnILockBytes',  \
    StgCreatePropSetStg, N, <.pStorage, .dwReserved, .ppPropSetStg>,  'StgCreatePropSetStg',  \
    StgCreatePropStg, N, <.pUnk, .fmtid, .pclsid, .grfFlags, .dwReserved, .ppPropStg>,  'StgCreatePropStg',  \
    StgCreateStorageEx, N, <.pwcsName, .grfMode, .stgfmt, .grfAttrs, .pStgOptions, .reserved, .riid, .ppObjectOpen>,  'StgCreateStorageEx',  \
    StgGetIFillLockBytesOnFile, N, <.pwcsName, .ppflb>,  'StgGetIFillLockBytesOnFile',  \
    StgGetIFillLockBytesOnILockBytes, N, <.pilb, .ppflb>,  'StgGetIFillLockBytesOnILockBytes',  \
    StgIsStorageFile, N, <.pwcsName>,  'StgIsStorageFile',  \
    StgIsStorageILockBytes, N, <.plkbyt>,  'StgIsStorageILockBytes',  \
    StgOpenAsyncDocfileOnIFillLockBytes, N, <.pflb, .grfMode, .asyncFlags, .ppstgOpen>,  'StgOpenAsyncDocfileOnIFillLockBytes',  \
    StgOpenPropStg, N, <.pUnk, .fmtid, .grfFlags, .dwReserved, .ppPropStg>,  'StgOpenPropStg',  \
    StgOpenStorage, N, <.pwcsName, .pstgPriority, .grfMode, .snbExclude, .reserved, .ppstgOpen>,  'StgOpenStorage',  \
    StgOpenStorageEx, N, <.pwcsName, .grfMode, .stgfmt, .grfAttrs, .pStgOptions, .reserved, .riid, .ppObjectOpen>,  'StgOpenStorageEx',  \
    StgOpenStorageOnHandle, N, <NONE>,  'StgOpenStorageOnHandle',  \
    StgOpenStorageOnILockBytes, N, <.plkbyt, .pstgPriority, .grfMode, .snbExclude, .reserved, .ppstgOpen>,  'StgOpenStorageOnILockBytes',  \
    StgPropertyLengthAsVariant, N, <NONE>,  'StgPropertyLengthAsVariant',  \
    StgSetTimes, N, <.lpszName, .pctime, .patime, .pmtime>,  'StgSetTimes',  \
    StringFromCLSID, N, <.rclsid, .lplpsz>,  'StringFromCLSID',  \
    StringFromGUID2, N, <.rguid, .lpsz, .cchMax>,  'StringFromGUID2',  \
    StringFromIID, N, <.rclsid, .lplpsz>,  'StringFromIID',  \
    UpdateDCOMSettings, N, <NONE>,  'UpdateDCOMSettings',  \
    UtConvertDvtd16toDvtd32, N, <NONE>,  'UtConvertDvtd16toDvtd32',  \
    UtConvertDvtd32toDvtd16, N, <NONE>,  'UtConvertDvtd32toDvtd16',  \
    UtGetDvtd16Info, N, <NONE>,  'UtGetDvtd16Info',  \
    UtGetDvtd32Info, N, <NONE>,  'UtGetDvtd32Info',  \
    WdtpInterfacePointer_UserFree, N, <NONE>,  'WdtpInterfacePointer_UserFree',  \
    WdtpInterfacePointer_UserMarshal, N, <NONE>,  'WdtpInterfacePointer_UserMarshal',  \
    WdtpInterfacePointer_UserSize, N, <NONE>,  'WdtpInterfacePointer_UserSize',  \
    WdtpInterfacePointer_UserUnmarshal, N, <NONE>,  'WdtpInterfacePointer_UserUnmarshal',  \
    WriteClassStg, N, <.pStg, .rclsid>,  'WriteClassStg',  \
    WriteClassStm, N, <.pStm, .rclsid>,  'WriteClassStm',  \
    WriteFmtUserTypeStg, N, <.pstg, .cf, .lpszUserType>,  'WriteFmtUserTypeStg',  \
    WriteOleStg, N, <NONE>,  'WriteOleStg',  \
    WriteStringStream, N, <NONE>,  'WriteStringStream'
