; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "Fresh artistic license."         |
;|_______________________________________________________________________________________|
;
;  Description: Macros for importing functions in Linux
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


include '_elf.inc'


macro interpreter [library]
{
 db library,0
}


; creates symbols list with needed libraries.
macro import_proto library, [name, arg]
{
  common
    local str, cnt, use
    match needed,needed@dynamic \{ define needed@dynamic needed, str:cnt:use:library \}
    match ,needed@dynamic \{ define needed@dynamic str:cnt:use:library \}

  forward
    match imported, imported@dynamic \{ imported@dynamic equ imported, cnt:name \}
    match ,imported@dynamic \{ imported@dynamic equ cnt:name \}
    define name#@arg arg
}
define needed@dynamic
define imported@dynamic



macro __define_import_arguments_var [argument] {
common
  virtual at ebp+8
forward
  argument dd ?
common
  end virtual
}


macro __define_import_arguments name {
common
  if name#@arg eq VOID
    .__info.argtype=1
  else
    if name#@arg eq NONE
      .__info.argtype = 0
    else
      match A, name#@arg \{ __define_import_arguments_var A \}
      .__info.argtype = 2
    end if
  end if
}



struc def_name name {
  db `name, 0
}


macro __do_import [cntandname]
{
common
  local strtab,strsz,symtab,rel,relsz,hash
  segment dynamic readable

  match needed, needed@dynamic \{
    irp item, needed \\{
      match str:cnt:use:library, item \\\{
        cnt = 0
        if use > 0
          dd DT_NEEDED, str-strtab
        end if
      \\\}
    \\}
  \}

  dd DT_STRTAB, strtab
  dd DT_STRSZ, strsz
  dd DT_SYMTAB, symtab
  dd DT_SYMENT, sizeof.Elf32_Sym
  dd DT_REL, rel
  dd DT_RELSZ, relsz
  dd DT_RELENT, sizeof.Elf32_Rel
  dd DT_HASH, hash
  dd DT_NULL, 0

  segment readable writeable
  symtab: Elf32_Sym

forward
  match cnt:name, cntandname \{
    if used name
      local fstr
      Elf32_Sym fstr-strtab,0,0,STB_GLOBAL,STT_FUNC,0,0
      cnt = cnt + 1
    end if
  \}

common
  rel:
  local counter
  counter = 1

forward
  match cnt:name, cntandname \{
    if used name
      Elf32_Rel name, counter, R_386_32
      counter = counter + 1
    end if
  \}

common
  relsz = $-rel
  hash:
  dd 1, counter
  dd 0

  repeat counter
   if %=counter
    dd 0
   else
    dd %
   end if
  end repeat
  strtab db 0

forward
  match cnt:name, cntandname \{
    if used name
      fstr def_name name
    end if
  \}

common
  match needed, needed@dynamic \{
    irp item, needed \\{
      match str:cnt:use:library,item \\\{
        use = cnt
        if use > 0
          str db library, 0
        end if
      \\\}
    \\}
  \}
  strsz = $-strtab

forward
  match cnt:name, cntandname \{
label name dword
    if used name
       dd 0
    end if
__define_import_arguments name
  \}
}


macro ImportAll {
  match arguments, __do_import imported@dynamic \{ arguments \}
}


