; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "Fresh artistic license."         |
;|_______________________________________________________________________________________|
;
;  Description: Win32 import macros.
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes: Only import_proto should be used in portable applications. Here we have some
;         old macros that needs revision or even removing.
;_________________________________________________________________________________________

; macroinstruction for making import section
macro library [name,string] {
forward
    local _label
    if ~ name#.needed
    dd 0,0,0,RVA _label,RVA name
    end if
common
    dd 0,0,0,0,0
forward
    if ~ name#.needed
    _label db string,0
;    display 'Import from:', string, $0d, $0a
    end if
 }


macro import name,[label, string]
 { common
    name:
   forward
    if used label
     local _label
     label dd RVA _label
    end if
   common
    if $ > name
     name#.needed = FALSE
     dd 0
    else
     name#.needed = TRUE
    end if
   forward
    if used label
    _label dw 0
           db string,0
    end if
  }



macro define_import_arguments [argument] {
common
  virtual at ebp+8
forward
    argument dd ?
common
  end virtual
}

macro import_proto name, [lbl, api, arg, string] {
common
    name:
forward
    local ..lbl, ..used

    match =N, api \{ @label equ lbl\}
    match =W, api \{
      match =ascii, GlobalAPI \\{ @label equ lbl#W \\}
      match =unicode, GlobalAPI \\{ @label equ lbl \\}
      match , GlobalAPI \\{ @label equ lbl#W \\}
    \}
    match =A, api \{
      match =ascii, GlobalAPI \\{ @label equ lbl \\}
      match =unicode, GlobalAPI \\{ @label equ lbl#A \\}
      match , GlobalAPI \\{ @label equ lbl#A \\}
    \}

    ..used = 0
    if used @label
      @label dd RVA ..lbl
      ..used = 1
    end if

   if ~(arg eq NONE)
     if arg eq VOID
       .__info.argtype = 1
     else
       define_import_arguments arg
       .__info.argtype = 2
     end if
   else
     .__info.argtype = 0
   end if

   restore @label

common
    if $ > name
     name#.needed = FALSE
     dd 0
    else
     name#.needed = TRUE
    end if

forward
    if ..used
    ..lbl dw 0
          db string,0
    end if
}



macro U_library [name,string]
 { forward
     local _label
     dd 0,0,0,RVA _label,RVA name
   common
     dd 0,0,0,0,0
   forward
    _label db string,0
 }


macro U_import name,[label,string]
{ common
    name:
   forward
     local _label
     label dd RVA _label
   common
     dd 0
   forward
    _label dw 0
           db string,0
}


macro ImportLib [lib] {
forward
    local _label
    if ~ lib#.needed
      dd 0, 0, 0, RVA _label, RVA lib
    end if

common
    dd 0, 0, 0, 0, 0

forward
  if ~ lib#.needed
    _label db `lib#'.dll', 0
  end if

forward
  \include "%finc%\win32\api\"#`lib#".inc"
}


GlobalAPI equ unicode
